      program magnet
      include 'option.i'

      call iopar
      if(genbox)call generate_box
      if(loadmol)call load_mol(MOLECULE)
      if(lrest)call load_mol('RESTART.X')
      if(minimize)then
       call assignmasses
       call minimini
      endif
      call dynamic
      if(wrend)call save_mol('END.X')
      stop
      end

      subroutine  addbond(ib,i1,i2,k,b)
      include 'common.i'
      integer*4 i,ib,i1,i2
      real*8 k,b
      if (i1.eq.0.or.i2.eq.0)return
      do 1 i=1,ib
1     if((b1(i).eq.i1.and.b2(i).eq.i2).or.(b1(i).eq.i2.and.
     1b2(i).eq.i1))return
      ib=ib+1
      b1(ib)=i1
      b2(ib)=i2
      k0(ib)=k
      b0(ib)=b
      return
      end

      subroutine adddiangle(id,i1,i2,i3,i4,r1,r2,w3)
      include 'common.i'
      integer*4 id,i1,i2,i3,i4
      real*8 r1,r2,w3
      id=id+1
      d1(id)=i1
      d2(id)=i2
      d3(id)=i3
      d4(id)=i4
      k1d(id)=r1
      k2d(id)=r2
      k3d(id)=w3
      return
      end

      subroutine addop(id,i1,i2,i3,i4,r1)
      include 'common.i'
      integer*4 id,i1,i2,i3,i4
      real*8 r1
      id=id+1
      o1(id)=i1
      o2(id)=i2
      o3(id)=i3
      o4(id)=i4
      oo(id)=r1
      return
      end

      subroutine  addangle(ib,i1,i2,i3,k,b)
      include 'common.i'
      integer*4 ib,i2,i1,i3,i
      real*8 k,b
      if (i1.eq.0.or.i2.eq.0.or.i3.eq.0)return
      do 1 i=1,ib
1     if((t1(i).eq.i1.and.t2(i).eq.i2.and.t3(i).eq.i3).or.
     1   (t1(i).eq.i1.and.t2(i).eq.i3.and.t3(i).eq.i2).or.
     2   (t1(i).eq.i2.and.t2(i).eq.i1.and.t3(i).eq.i3).or.
     3   (t1(i).eq.i2.and.t2(i).eq.i3.and.t3(i).eq.i1).or.
     4   (t1(i).eq.i3.and.t2(i).eq.i1.and.t3(i).eq.i2).or.
     5   (t1(i).eq.i3.and.t2(i).eq.i2.and.t3(i).eq.i1))return
      ib=ib+1
      t1(ib)=i1
      t2(ib)=i2
      t3(ib)=i3
      kt(ib)=k
      bt(ib)=b
      return
      end

      subroutine shi(iaa,i,ss)
      include 'common.i'
      integer*4 ii,iaa,i
      real*8 ss
      ii=3*(iaa-1)+i
      r(ii)=r(ii)+ss
      rm(ii)=rm(ii)+ss
      rmm(ii)=rmm(ii)+ss
      return
      end

      subroutine  mksh(nat1sw,nasw,im) 
      include 'common.i'
      include 'option.i'
      integer*4 nat1sw,nasw,im,ix,iy,az,jx,jy,jz,ia,ii,jj,iaa
      ix=0
      iy=0
      az=0
      jx=0
      jy=0
      jz=0
      ii=nat1sw+(im-1)*nasw-1
      do 1 ia=1,nasw
      iaa=ii+ia
      jj=3*(iaa-1)
      if(r(jj+1).gt.xbox)then
       ix=ix+1 
      else  
       if(r(jj+1).lt.z0)jx=jx+1
      endif
      if(r(jj+2).gt.ybox)then 
       iy=iy+1 
      else 
       if(r(jj+2).lt.z0)jy=jy+1
      endif
      if(r(jj+3).gt.zbox)then 
       az=az+1 
      else 
       if(r(jj+3).lt.z0)jz=jz+1
      endif
1     continue

      if(jx.gt.0.and.ix.gt.0)call save_mol('TMP.X')
      if(jy.gt.0.and.iy.gt.0)call save_mol('TMP.X')
      if(jz.gt.0.and.az.gt.0)call save_mol('TMP.X')
      if(jx.gt.0.and.ix.gt.0)call report('exploded molecule')
      if(jy.gt.0.and.iy.gt.0)call report('exploded molecule')
      if(jz.gt.0.and.az.gt.0)call report('exploded molecule')

      if(ix.eq.nasw)then
       do 2 ia=1,nasw  
2      call shi(ii+ia,1,-xbox)
      else
       if(jx.eq.nasw)then  
        do 3 ia=1,nasw  
3       call shi(ii+ia,1, xbox)
       endif
      endif

      if(iy.eq.nasw)then  
       do 4 ia=1,nasw  
4      call shi(ii+ia,2,-ybox)
      else
       if(jy.eq.nasw)then  
        do 5 ia=1,nasw  
5       call shi(ii+ia,2, ybox)
       endif
      endif

      if(az.eq.nasw)then  
       do 6 ia=1,nasw  
6      call shi(ii+ia,3,-zbox)
      else
       if(jz.eq.nasw)then  
        do 7 ia=1,nasw  
7       call shi(ii+ia,3, zbox)
       endif
      endif
      return
      end

      function mass(q)
      real*8 mass
      integer*4 q,m
      m=0
      if(q.eq.1)m=1
      if(q.eq.2)m=2
      if(q.eq.6)m=12
      if(q.eq.7)m=14
      if(q.eq.8)m=16
      if(q.eq.9)m=19
      if(q.eq.17)m=35
      if(q.eq.35)m=80
      if(m.eq.0)then
       write(6,*)q
       call report('unknown charge')
      endif
      mass=dble(m)
      return
      end

      subroutine fixbox
      include 'common.i'
      include 'option.i'
c{if a molecule is out of box, shift it back}
      integer*4 im
      do 1 im=1,nso   
1     call mksh(nat1so,naso,im)
      do 2 im=1,2*nch 
2     call mksh(nat1ch,nach,im)
      return
      end

      subroutine fixboxall
      include 'common.i'
      include 'option.i'
c{if a molecule is out of box, shift it back}
      integer*4 im
      do 3 im=1,2*nst   
3     call mksh(nat1st,nast,im)
      do 1 im=1,nso   
1     call mksh(nat1so,naso,im)
      do 2 im=1,2*nch 
2     call mksh(nat1ch,nach,im)
      return
      end

      subroutine setmolecules
c{set all molecules including static}
c{atoms    1(nat1st) .... nat2st nat1so ... nat2so  nat1ch ... nat2ch
c             static molecules      solvent mols        chiral mols
c                 2*nst               nso                   2*nch
c             each nast atoms      each naso atoms      each nach atoms}
      include 'common.i'
      include 'option.i'
      integer*4 i,js,ks
      js=0
      ks=0        
      do 1 i=1,2*nst           
      ias(i)=js+(i-1-ks)*nast+1
1     iae(i)=js+(i-ks)*nast
      js=2*nst*nast         
      ks=2*nst    
      do 2 i=2*nst+1,2*nst+nso       
      ias(i)=js+(i-1-ks)*naso+1
2     iae(i)=js+(i-ks)*naso
      js=2*nst*nast+nso*naso
      ks=2*nst+nso
      do 3 i=2*nst+nso+1,2*nst+nso+2*nch
      ias(i)=js+(i-1-ks)*nach+1
3     iae(i)=js+(i-ks)*nach
      return
      end

      subroutine assignmasses
      include 'common.i'
      integer*4 ia
      real*8 cwm,mass
      do 1 ia=1,nat 
1     mmass(ia)=mass(iz(ia))
c{To atomic units:}
      cwm=0.001d0/nav/me
      do 2 ia=1,nat 
2     mmass(ia)=mmass(ia)*cwm 
      return
      end

      subroutine writex(icon,fn)
      include 'common.i'
      integer*4 i,j,bonds(nat0,7),nbonds(nat0),ii,icon
      character*(*) fn
      do 1 i=1,nat 
1     nbonds(i)=0
      do 2 i=1,nb 
      nbonds(b1(i))=nbonds(b1(i))+1
      bonds(b1(i),nbonds(b1(i)))=b2(i)
      nbonds(b2(i))=nbonds(b2(i))+1
2     bonds(b2(i),nbonds(b2(i)))=b1(i)
      do 3 i=1,nat 
      do 3 j=nbonds(i)+1,7 
3     bonds(i,j)=0
      open(73,file=fn)
11    read(73,*,err=999,end=999)
      goto 11
999   write(73,*)icon
      write(73,*)nat
      do 4 i=1,nat 
4     write(73,5)iz(i),(r(3*(i-1)+ii),ii=1,3),(bonds(i,ii),ii=1,7),q(i)
5     format(i4,3f12.6,7i5,f12.6)
      close(73)
      return
      end

      subroutine dynamove
      include 'common.i'
      include 'option.i'
      real*8 coupling2,ni
      parameter (coupling2=0.9d0)
      integer*4 iactual_temperature,iref,kic,ia,ix,iref2,iia,idyn,irefx,
     1irefr,ilin,im,io
      real*8 fx,fy,fz,qia,a1,a2,ekini,ekina,t,mia,anao,rdragx,rdragz,
     1da,dd,dtmia,sf,qiamia,vch1,vch2,ekin,anat,pf1,atc,vavx,vavz,
     2xm,ym,zm,xmm,ymm,zmm,bk,rdrag,vav,x,y,z,lms,a3,dt2,down,ybox2
      logical lex

      ybox2=ybox/2.0d0
      if(llog)open(34,file='dyn.log')
      if(llog)write(6,*)'dyn.log opened'
      if(lfllog)then
       open(35,file='FLOW.PRN')
       if (lrest)then
        ilin=0
7010    read(35,*,end=7009,err=7009)
        ilin=ilin+1
        goto 7010
7009    write(6,*)'FLOW.PRN opened and will be appended'
        write(6,*)ilin,' lines present already'
       else
        write(6,*)'FLOW.PRN opened'
       endif
      endif
      write(6,3431)ncycles,dble(ncycles)*dt*vdrag*bohr*0.1d0
3431  format(I10,' cycles ,',f15.4,' nm')
      ichdi=0
      ichsi=0
      vchdi=z0
      vchsi=z0
      ni=z0
      t=z0
      iref=0
      iref2=0
      irefx=0
      irefr=0
      kic=0
      bk=bohr/kcal
      dt2=dt*dt
      pf1=2.0d0/3.0d0/Ru*1000.0d0*jcal*kcal
      anat=dble(nat-nat2st-1+1)
      anao=dble(nat2so-nat1so+1)
      atc=dble(nat12ch-nat1ch+1)
c
c     local variable for maxstep:
      lms=maxstep

      idyn=0
      if(lrest)call ls_rest(1,r,rm,rmm,idyn,vchdi,vchsi,t,ni,nat)
99999 idyn=idyn+1
      t=t+dt
      iref=iref+1
      iref2=iref2+1
      irefx=irefx+1
      irefr=irefr+1
      kic=kic+1
      call energy(1)

      vavx=z0
      vav=z0
      vavz=z0
      ekin=z0
      iia=3*(nat2st-1)
      do 1 ia=nat2st+1,nat
      iia=iia+3
      mia=mmass(ia)
      qia=q(ia)
      qiamia=qia/mia
      dtmia=dt/mia
      xm = rm(iia+1)/bohr
      ym = rm(iia+2)/bohr
      zm = rm(iia+3)/bohr
      xmm=rmm(iia+1)/bohr
      ymm=rmm(iia+2)/bohr
      zmm=rmm(iia+3)/bohr
c      {**********    F = q / m p x B - grad -kf*p/m(friction) ****}
      a1= qiamia*(bx+bxf(ia))*dt/2.0d0
      a2= qiamia*(by+byf(ia))*dt/2.0d0
      a3= qiamia*(bz+bzf(ia))*dt/2.0d0
      da=1.0d0+kf*dtmia/2.0d0 
      dd=1.0d0-kf*dtmia/2.0d0 
c
c     get force in from kcal/A to au:
c     divide by m and multiply by dt^2
      fx=-g(iia+1)*bk/mia*dt2  
      fy=-g(iia+2)*bk/mia*dt2-ggrav*dt2
      fz=-g(iia+3)*bk/mia*dt2         
      fx=fx+zmm*a2-ymm*a3-dd*xmm+xm+xm
      fy=fy+xmm*a3-zmm*a1-dd*ymm+ym+ym
      fz=fz+ymm*a1-xmm*a2-dd*zmm+zm+zm
      down=da*(da**2+a1**2+a2**2+a3**2)
      x=(fx*(da**2+a1**2)+(fy*a2+fz*a3)*a1+(fy*a3-fz*a2)*da)/down
      y=(fy*(da**2+a2**2)+(fz*a3+fx*a1)*a2+(fz*a1-fx*a3)*da)/down
      z=(fz*(da**2+a3**2)+(fx*a1+fy*a2)*a3+(fx*a2-fy*a1)*da)/down
      if( x-xm.gt.lms)then
       x=xm+lms
      else
       if(xm-x .gt.lms)x=xm-lms
      endif
      if( y-ym.gt.lms)then
       y=ym+lms
      else
       if(ym-y .gt.lms)y=ym-lms
      endif
      if( z-zm.gt.lms)then
       z=zm+lms
      else
       if(zm-z .gt.lms)z=zm-lms
      endif
      r(iia+1)=x*bohr
      r(iia+2)=y*bohr
      r(iia+3)=z*bohr
      if(lwdrag.or.(ia.ge.nat1so.and.ia.le.nat2so))vavx=vavx+x-xm
      if(lwdrag.or.(ia.ge.nat1so.and.ia.le.nat2so))vav =vav +y-ym
      if(lwdrag.or.(ia.ge.nat1so.and.ia.le.nat2so))vavz=vavz+z-zm
1     ekin=ekin+mia*((x-xmm)**2+(y-ymm)**2+(z-zmm)**2)
c     kin energy, au:
      ekin=ekin/2.0d0/(2.0d0*dt)**2
c     average kin energy  do one atom in au, 3/2RT=<1/2 mv^2>:
      ekini=ekin/anat
      iactual_temperature=int(pf1*ekini)
c     average shift in y-direction, zero in the others
      if(lwdrag)then
c      drag also solute atoms
       vavx=vavx/anat
       vav=vav/anat
       vavz=vavz/anat
       rdragx=-vavx*bohr
       rdrag =(vdrag*dt-vav)*bohr
       rdragz=-vavz*bohr
       do 31 ia=nat2st+1,nat
       r(ia+ia+ia-2)=r(ia+ia+ia-2)+rdragx
       r(ia+ia+ia-1)=r(ia+ia+ia-1)+rdrag
31     r(ia+ia+ia  )=r(ia+ia+ia  )+rdragz
      else
c      drag only water atoms
       vavx=vavx/anao
       vav=vav/anao
       vavz=vavz/anao
       rdragx=-vavx*bohr
       rdrag =(vdrag*dt-vav)*bohr
       rdragz=-vavz*bohr
       do 3 ia=nat1so,nat2so
       r(ia+ia+ia-2)=r(ia+ia+ia-2)+rdragx
       r(ia+ia+ia-1)=r(ia+ia+ia-1)+rdrag
3      r(ia+ia+ia  )=r(ia+ia+ia  )+rdragz
      endif
c
      if(kic.ge.ikin.and.lbath)then 
       kic=0
c      redistribute velocity so no atom gets too fast:
       do 5 ia=nat2st+1,nat 
       iia=3*(ia-1)
       mia=mmass(ia)
       ekina=mia*((r(iia+1)-rm(iia+1))**2+(r(iia+2)-rm(iia+2))**2
     1 +(r(iia+3)-rm(iia+3))**2)/2.0d0/(dt*bohr)**2
       sf=dsqrt(ekini/ekina)
       do 5 ix=1,3
5      r(iia+ix)=coupling2*r(iia+ix)+
     1 (1.0d0-coupling2)*(rm(iia+ix)+sf*(r(iia+ix)-rm(iia+ix)))
c
c      scale for constant temperature:
       sf=dsqrt(ekin0/ekini)
       do 4 ia=nat2st+1,nat 
       iia=3*(ia-1)
       do 4 ix=1,3
4      r(iia+ix)=rmm(iia+ix)+sf*(r(iia+ix)-rmm(iia+ix))
      endif
      
      call fixbox

      vch1=z0
      vch2=z0
      do 6 ia=nat1ch   ,nat12ch 
6     vch1=vch1+r(ia+ia+ia-1)-rm(ia+ia+ia-1)
      do 7 ia=nat12ch+1,nat2ch  
7     vch2=vch2+r(ia+ia+ia-1)-rm(ia+ia+ia-1)
      do 61 im=1,nch
      ia=nat1ch+(im-1)*nach
      iia=3*(ia-1)
      if(r(iia+2).gt.ybox2.and.rm(iia+2).le.ybox2)then
       ichdi=ichdi+1
       ichsi=ichsi+1
      endif
      if(r(iia+2).lt.ybox2.and.rm(iia+2).ge.ybox2)then
       ichdi=ichdi-1
       ichsi=ichsi-1
      endif
61    continue
      do 71 im=nch+1,2*nch
      ia=nat1ch+(im-1)*nach
      iia=3*(ia-1)
      if(r(iia+2).gt.ybox2.and.rm(iia+2).le.ybox2)then
       ichdi=ichdi-1
       ichsi=ichsi+1
      endif
      if(r(iia+2).lt.ybox2.and.rm(iia+2).ge.ybox2)then
       ichdi=ichdi+1
       ichsi=ichsi-1
      endif
71    continue

      vchdi=vchdi+vch2-vch1
      vchsi=vchsi+vch2+vch1
      ni=z0
      if(abs(vchsi).gt.1.0d-8)ni=vchdi/vchsi
      if(iref2.ge.flref)then
       iref2=0
       if(lfllog)then
        write(35,3411)t*vdrag*bohr*0.1d0
3411    format(f15.4,$)
        if(lchisu)write(35,3411)vchsi/2.0d0*0.1d0/atc
        if(lchidi)write(35,3411)vchdi/2.0d0*0.1d0/atc
        if(lchidi)write(35,345)ni
        if(lchidi)write(35,3451)ichsi
        if(lchidi)write(35,3451)ichdi
3451    format(i10,$)
345     format(f12.6,$)
        write(35,*)
       endif
      endif

      do 8 ia=3*nat2st+1,3*nat 
      rmm(ia)=rm(ia)
8     rm(ia)=r(ia)

      if(irefx.ge.xref) then 
       if(lwrx)call writex(idyn,'FILE.X')
       irefx=0
      endif
      if(irefr.ge.resref) then 
       if(lwres)call save_mol('RESTART.X')
       if(lwres)call ls_rest(0,r,rm,rmm,idyn,vchdi,vchsi,t,ni,nat)
       irefr=0
      endif

      if(iref.ge.mdref) then 
       inquire(file='STOP',exist=lex)
       if(lex)goto 888
       write(6,341)idyn
341    format(i10,$)
       write(6,344)iactual_temperature
       write(6,342)etot
       write(6,342)ekin*kcal
       write(6,342)etot+ekin*kcal
       write(6,345)ni
       write(6,343)t*vdrag*bohr*0.1d0
       if(llog)then
        write(34,341)idyn
        if(ltlist)write(34,344)iactual_temperature
344     format(i5,$)
        if(lepot)write(34,342)etot
        if(lekin)write(34,342)ekin*kcal
        if(letot)write(34,342)etot+ekin*kcal
342     format(f12.2,$)
        write(34,343)t*vdrag*bohr*0.1d0
343     format(f10.4,' nm')
       endif
       iref=0
      endif

      if(idyn.le.ncycles.or.ncycles.eq.0)goto 99999
888   close(34)
      close(35)
      return
      end

      subroutine dynamic
      include 'common.i'
      include 'option.i'
      integer*4  i,ia,ix,iactual_temperature,ii
      real*8 p(3*nat0),vav,ss,frandom,ekini,fekin,anat
      write(6,6000)temperature
6000  format('dynamic started, temperature = ',f8.1,'K')
      call setmolecules
      if(nat.lt.1)call report('No atoms loaded')
      call assignmasses
      rtau=Ru*temperature/jcal/1000.0d0/kcal
c {Boltzmann RT in Hartree}
      ekin0=3.0d0/2.0d0*Ru/jcal/1000.0d0*temperature/kcal
c {ave kin energy  do 1 atom (au) corresponding,T}
      write(6,6001)temperature,ekin0,by*2.352d5,bx*2.352d5,bz*2.352d5,
     1vdrag/(0.01d0/60.0d0/0.529177d-10*2.418d-17),kf
      iactual_temperature=int(2.0d0/3.0d0*ekin0/Ru*1000.0d0*jcal*kcal)
6001  format('T=',f10.1,', ekin0=',f12.6,' By=',f12.3,' Bx =',f12.3,
     1'Bz=',f12.3,/,' vdrag= ',f12.2,
     1/,'fk=',f12.6)
      write(6,*)lbath,iactual_temperature
      mv2=3.0d0*rtau
c{averege velocities of the + and - enantiomers}
c{inital velocities-only in xz direction,,avoid chiral bias}

      if(.not.lrest)then
       do 1 ia=1,nat 
       if(ia.gt.nat2st.or.ia.lt.nat1st)then
        vav=dsqrt(mv2/mmass(ia))
        ss=1.0d0
        if((dble(frandom(0))-0.50d0).lt.0.0d0)ss=-1.0d0
        p(3*(ia-1)+1)=ss*vav*(0.5d0+0.5d0*dble(frandom(0)))
        p(3*(ia-1)+2)=z0
        ss=1.0d0
        if((dble(frandom(0))-0.50d0).lt.0.0d0)ss=-1.0d0
        p(3*(ia-1)+3)=ss*vav*(0.5d0+0.5d0*dble(frandom(0)))
       else
        do 2 i=1,3 
2       p(3*(ia-1)+i)=0.0d0 
       endif
1      continue
       do 4 ia=1,nat
       do 4 ix=1,3
       ii=3*(ia-1)+ix
       rm(ii)=r(ii)
       rmm(ii)=r(ii)
       if(ia.gt.nat2st.or.ia.lt.nat1st)then
       if(ix.eq.1.or.ix.eq.3)then
        rm(ii)=r(ii)+p(ii)*dt*bohr
        rmm(ii)=r(ii)+p(ii)*2.0d0*dt*bohr
       endif
       endif
4      continue
       anat=dble(nat-nat2st-1+1)
       ekini=fekin(r,rmm,mmass,nat2st+1,nat,dt,bohr)/anat
       iactual_temperature=int(2.0d0/3.0d0*ekini/Ru*1000.0d0*jcal*kcal)
       write(6,*)iactual_temperature,' before projection'
c{eliminate global translations via r, rmm:}
       call project
       ekini=fekin(r,rmm,mmass,nat2st+1,nat,dt,bohr)/anat
       iactual_temperature=int(2.0d0/3.0d0*ekini/Ru*1000.0d0*jcal*kcal)
       write(6,*)iactual_temperature,' after projection'
      endif

      call dynamove

      return
      end

      subroutine load_mol(mlk)
      include 'common.i'
      include 'option.i'
      integer*4 i,j,du
      character*(*) mlk
      character*6 t6
      open(33,file=mlk)
      read(33,*)
      read(33,*)nat
      if(nat.gt.nat0)call report('Too many atoms')
      do 1 i=1,nat 
1     read(33,*)iz(i),r(3*(i-1)+1),r(3*(i-1)+2),r(3*(i-1)+3),du,du,du,
     1du,du,du,du,q(i)
      do 2 i=1,nat 
2     read(33,*)eps(i),r3(i)
      read(33,*)nb
      if(nb.gt.nat0)call report('Too many bonds')
      do 3 i=1,nb 
3     read(33,*)b1(i),b2(i),k0(i),b0(i)
      read(33,*)nt
      if(nt.gt.nat0)call report('Too many angles')
      do 4 i=1,nt 
4     read(33,*)t1(i),t2(i),t3(i),kt(i),bt(i)
      read(33,*)nd
      if(nd.gt.nat0)call report('Too many torsions')
      do 5 i=1,nd 
5     read(33,*)d1(i),d2(i),d3(i),d4(i),k1d(i),k2d(i),k3d(i)
      read(33,*)np
      if(np.gt.nat0)call report('Too many oops')
      do  6 i=1,np 
6     read(33,*)o1(i),o2(i),o3(i),o4(i),oo(i)
      read(33,*)nat1so,nat2so,nat1ch,nat2ch,nat1st,nat2st
      nat12ch=(nat2ch+nat1ch) / 2
      read(33,*)
      read(33,*)(btd(i),i=1,nt)
      read(33,*)cw,xbox,ybox
      read(33,*)nst,nso,nch
      read(33,*)nast,naso,nach
      zbox=xbox
      if(lmagnet)then
       rewind 33
101    read(33,330,err=102,end=102)t6
330    format(a6)
       if(t6.ne.'magnet')goto 101
102    if(t6.ne.'magnet')call report('susceptibility not found')
       read(33,*)((chism(i,j),j=1,3),i=1,3)
       read(33,*)((chiom(i,j),j=1,3),i=1,3)
       read(33,*)((chicm(i,j),j=1,3),i=1,3)
       read(33,*)
       read(33,*)(pmds(i),i=1,3)
       read(33,*)(pmdo(i),i=1,3)
       read(33,*)(pmdc(i),i=1,3)
      endif
      if(lpolar)then
       rewind 33
103    read(33,330,err=104,end=104)t6
       if(t6.ne.'polari')goto 103
104    if(t6.ne.'polari')call report('polarizabilities not found')
       read(33,*)((polsm(i,j),j=1,3),i=1,3)
       read(33,*)((polom(i,j),j=1,3),i=1,3)
       read(33,*)((polcm(i,j),j=1,3),i=1,3)
      endif
      close(33)
      write(6,*)mlk,' loaded'
      call setmolecules
      write(6,*)'molecules set'
      call assignmasses
      write(6,*)'masses assigned'
      call fixboxall
      write(6,*)'periodic box checked'
      return
      end

      subroutine save_mol(mlk)
      include 'common.i'
      include 'option.i'
      integer*4 i,j,nbonds(nat0),bonds(nat0,7)
      character*(*) mlk
      open(33,file=mlk)
      write(33,*)'Chiral Column'
      do 1 i=1,nat 
1     nbonds(i)=0
      do 2 i=1,nb
      nbonds(b1(i))=nbonds(b1(i))+1
      bonds(b1(i),nbonds(b1(i)))=b2(i)
      nbonds(b2(i))=nbonds(b2(i))+1
2     bonds(b2(i),nbonds(b2(i)))=b1(i)
      do 3 i=1,nat
      do 3 j=nbonds(i)+1,7 
3     bonds(i,j)=0
      write(33,*)nat
      do 4 i=1,nat 
4     write(33,3000)iz(i),(r(3*(i-1)+j),j=1,3),(bonds(i,j),j=1,7),q(i)
3000  format(i4,3f12.6,7i5,f12.6)
      do 5 i=1,nat 
5     write(33,3001)eps(i),r3(i)
3001  format(f12.6,f10.3)
      write(33,*)nb,' bonds:'
      do 6 i=1,nb 
6     write(33,3002)b1(i),b2(i),k0(i),b0(i)
3002  format(2i5,f11.4,f10.5)
      write(33,*)nt,' angles:'
      do 7 i=1,nt 
7     write(33,3003)t1(i),t2(i),t3(i),kt(i),bt(i)
3003  format(3i5,f11.4,f10.3)
      write(33,*)nd,' torsions:'
      do 8 i=1,nd 
8     write(33,3004)d1(i),d2(i),d3(i),d4(i),k1d(i),k2d(i),k3d(i)
3004  format(4i5,3f11.4)
      write(33,*)np,' out of planes:'
      do 9 i=1,np 
9     write(33,3005)o1(i),o2(i),o3(i),o4(i),oo(i)
3005  format(4i5,f11.4)
      write(33,3006)nat1so,nat2so,nat1ch,nat2ch,nat1st,nat2st
3006  format(6i6,/,
     1'Improper bonds instead of bond angles (squares, do shake):')
      write(33,3007)(btd(i),i=1,nt)
3007  format(8f10.5)
      write(33,3008)cw,xbox,ybox
3008  format(3f12.3)
      write(33,3009)nst,nso,nch
3009  format(3i6)
      write(33,3009)nast,naso,nach
      if(lmagnet)then
       if(l3vec)then
        write(33,30101)
30101   format('magnetic susceptibilities in the 3v system, au')
       else
        write(33,3010)
3010    format('magnetic susceptibilities in the inertia system, au')
       endif
       write(33,3011)((chism(i,j),j=1,3),i=1,3)
       write(33,3011)((chiom(i,j),j=1,3),i=1,3)
       write(33,3011)((chicm(i,j),j=1,3),i=1,3)
3011   format(9f12.6)
       if(l3vec)then
        write(33,30121)
30121   format(
     1  'permanent magnetic dipole moments in the 3v system, au')
       else
        write(33,3012)
3012    format(
     1  'permanent magnetic dipole moments in the inertia system, au')
       endif
       write(33,3013)(pmds(i),i=1,3)
       write(33,3013)(pmdo(i),i=1,3)
       write(33,3013)(pmdc(i),i=1,3)
3013   format(3f12.6)
      endif 
      if(lpolar)then
       if(l3vec)then
        write(33,3014)
3014    format('polarizabilities in the inertia system, au')
       else
        write(33,30141)
30141   format('polarizabilities in the 3v system, au')
       endif
       write(33,3011)((polsm(i,j),j=1,3),i=1,3)
       write(33,3011)((polom(i,j),j=1,3),i=1,3)
       write(33,3011)((polcm(i,j),j=1,3),i=1,3)
      endif
      close(33)
      return
      end

      subroutine iopar
      include 'common.i'
      include 'option.i'
      character*10 sct,s
      character*80 ts1,ts2
      integer*4 ix_r,iy_r,iz_r,ib,i
      common /randc/ ix_r, iy_r, iz_r
c
c     Initialize the random generator:
      ix_r=1
      iy_r=1000
      iz_r=99
c
      ib=0
      do i=1,80
      ts1(i:i)=' '
      ts2(i:i)=' '
      enddo
      xref=1000
      lwrx=.true.
      lwdrag=.true.
      lmcut=.false.
      xtol=0.01d0
      maxstep=0.35d0
      maxstep=maxstep/bohr
      elim=0.0001d0
      glim=0.1d0
      temperature=298.0d0
      dt=1.0d0
      maxnum=10000
      flref=1000
      mdref=1000
      resref=1000
      by=0.0d0
      bx=0.0d0
      bz=0.0d0
      efieldy=0.0d0
      vdrag=250.0d0
      vdrag=vdrag*0.01d0/60.0d0/0.529177d-10*2.418d-17
      ggrav=10.0d0
      kf=0.0d0
      ggrav=ggrav*1.105273d-23
      ikin=10
      lbath=.true.
      wrend=.true.
      llog=.true.
      lepot=.true.
      lekin=.false.
      letot=.false.
      ltlist=.true.
      lchidi=.true.
      lchisu=.true.
      ltlist=.true.
      lfllog=.true.
      llog=.true.
      lwres=.true.
      lrest=.false.
      l3vec=.false.
      xbox=15.0d0
      ybox=15.0d0
      nst=4
      nso=33
      nch=6
      SOLVENT='H2O.X'
      STATIC='CH4.X'
      CHIRAL='CHFCLBR.X'
      POLCHIRAL='CHFCLBR.POL'
      POLSOLVENT='H2O.POL'
      POLSTATIC='CH4.POL'
      CHICHIRAL='CHFCLBR.SUS'
      CHISOLVENT='H2O.SUS'
      CHISTATIC='CH4.SUS'
      MOLECULE='G.X'
      regular=.true.
      solma=.false.
      perma=.true.
      lmagnet=.true.
      lpolar=.true.
      loadmol=.true.
      minimize=.true.
      wrmin=.true.

      open(44,file='magnet.opt')
1     read(44,440,end=999,err=999)s
440   format(a10)
      if(s(1:1).eq.'#')goto 1
      if(s(1:5).eq.'POLST')read(44,441)POLSTATIC
      if(s(1:5).eq.'POLSO')read(44,441)POLSOLVENT
      if(s(1:5).eq.'POLCH')read(44,441)POLCHIRAL
      if(s(1:5).eq.'CHIST')read(44,441)CHISTATIC
      if(s(1:5).eq.'CHISO')read(44,441)CHISOLVENT
      if(s(1:5).eq.'CHICH')read(44,441)CHICHIRAL
      if(s(1:5).eq.'STATI')read(44,441)STATIC
      if(s(1:5).eq.'LWDRA')read(44,*)lwdrag
      if(s(1:5).eq.'MACUT')read(44,*)lmcut
      if(s(1:5).eq.'SOLVE')read(44,441)SOLVENT
      if(s(1:5).eq.'CHIRA')read(44,441)CHIRAL
441   format(a80)
      if(s(1:5).eq.'GENER')read(44,*)genbox
      if(s(1:5).eq.'LOADM')read(44,*)loadmol
      if(s(1:5).eq.'MFILE')read(44,*)MOLECULE
      if(s(1:5).eq.'MINIM')read(44,*)minimize
      if(s(1:5).eq.'VDRAG')then
       read(44,*)vdrag
       vdrag=vdrag*0.01d0/60.0d0/0.529177d-10*2.418d-17
c{solvent drag cm/min - m/s - au}
      endif
      if(s(1:5).eq.'REGUL')read(44,*)regular
      if(s(1:5).eq.'WIDTH')read(44,*)xbox
      if(s(1:5).eq.'HEIGH')read(44,*)ybox
      if(s(1:3).eq.'NST')read(44,*)nst
      if(s(1:3).eq.'NCH')read(44,*)nch
      if(s(1:3).eq.'NSO')read(44,*)nso
      if(s(1:5).eq.'WRMIN')read(44,*)wrmin
      if(s(1:5).eq.'WREND')read(44,*)wrend
      if(s(1:5).eq.'MAGNE')read(44,*)lmagnet
      if(s(1:5).eq.'POLAR')read(44,*)lpolar
      if(s(1:5).eq.'L3VEC')read(44,*)l3vec
      if(s(1:5).eq.'PERMA')read(44,*)perma
      if(s(1:5).eq.'SOLMA')read(44,*)solma
      if(s(1:5).eq.'MAXST')then
       read(44,*)maxstep
       maxstep=maxstep/bohr
      endif
      if(s(1:5).eq.'MAXNU')read(44,*)maxnum
      if(s(1:4).eq.'ELIM')read(44,*)elim
      if(s(1:4).eq.'GLIM')read(44,*)glim
      if(s(1:5).eq.'LSLIM')read(44,*)xtol
c     magnetic field in T, transfer immediatelly to au}
      if(s(1:6).eq.'BFIELD')then
       read(44,*)by
       by=by/2.352d5
      endif
      if(s(1:6).eq.'XFIELD')then
       read(44,*)bx
       bx=bx/2.352d5
      endif
      if(s(1:6).eq.'ZFIELD')then
       read(44,*)bz
       bz=bz/2.352d5
      endif
      if(s(1:6).eq.'EFIELD')read(44,*)efieldy
      if(s(1:5).eq.'GGRAV')then
       read(44,*)ggrav
       ggrav=ggrav*1.105273d-23
      endif
      if(s(1:5).eq.'FRICT')read(44,*)kf
      if(s(1:5).eq.'CUTOF')read(44,*)cutoff
      if(s(1:5).eq.'SMOOT')read(44,*)smooth
      if(s(1:5).eq.'MAXMD')read(44,*)ncycles
      if(s(1:2).eq.'DT')then
       read(44,*)dt
       dt=dt*1d-15/t0
      endif
      if(s(1:5).eq.'TEMPE')read(44,*)temperature
      if(s(1:5).eq.'BATH')read(44,*)lbath
      if(s(1:5).eq.'LOGFI')read(44,*)llog
      if(s(1:4).eq.'EPOT')read(44,*)lepot
      if(s(1:4).eq.'EKIN')read(44,*)lekin
      if(s(1:4).eq.'ETOT')read(44,*)letot
      if(s(1:5).eq.'TLIST')read(44,*)ltlist
      if(s(1:4).eq.'IKIN')read(44,*)ikin
      if(s(1:5).eq.'CHIDI')read(44,*)lchidi
      if(s(1:5).eq.'CHISU')read(44,*)lchisu
      if(s(1:5).eq.'MDREF')read(44,*)mdref
      if(s(1:5).eq.'FLREF')read(44,*)flref
      if(s(1:6).eq.'RESREF')read(44,*)resref
      if(s(1:5).eq.'LWRES')read(44,*)lwres
      if(s(1:7).eq.'RESTART')read(44,*)lrest
      if(s(1:5).eq.'FLLOG')read(44,*)lfllog
      if(s(1:4).eq.'LWRX')read(44,*)lwrx
      if(s(1:4).eq.'XREF')read(44,*)xref
      backspace 44
      read(44,440,end=999,err=999)sct
      if(sct.eq.s)then
       write(6,440)s
       call report('unknown option')
      endif
      ib=ib+1
      ts1((ib-1)*10+1:(ib-1)*10+8)=s(1:8)
      ts2((ib-1)*10+1:(ib-1)*10+8)=sct(1:8)
      if(ib.eq.8)then
       write(6,680)ts1(1:79)
       write(6,680)ts2(1:79)
       write(6,*)
680    format(a79)
       do i=1,80
       ts1(i:i)=' '
       ts2(i:i)=' '
       enddo
       ib=0
      endif
      goto 1
999   close(44)
      write(6,680)ts1,ts2
      zbox=xbox
      write(6,*)'magnet.opt read'
      write(6,6900)int(1.0d0/(dt*vdrag*bohr*0.1d0))
6900  format(I10,' cycles per nm')
      return
      end

      subroutine adda(ia,r,x,y,z,q,qst,iz,izst,eps,epsst,r3,r3st)
      implicit none
      real*8 r(*),x,y,z,q(*),eps(*),epsst,r3(*),r3st,qst
      integer*4 ia,iz(*),izst
      ia=ia+1
      r(3*(ia-1)+1)=x
      r(3*(ia-1)+2)=y
      r(3*(ia-1)+3)=z
      q(ia)=qst
      iz(ia)=izst
      eps(ia)=epsst
      r3(ia)=r3st
      return
      end

      subroutine generate_box
      include 'common.i'
      include 'option.i'
      integer*4 id,b,ia,ii,j,ix,i,ib,jx,it,nbst,nbso,nbch,ntst,ntso,ip,
     1ntch,ixp,jxp,ierr,k,im,kk,izso(nat00),ndch,ndso,ndst,nopch,nopst,
     2izch(nat00),izst(nat00),nopso
      real*8 x,y,z,dsx,dsy,dsz,vone,smass,omass,cmass,mass,frandom
      real*8 centers(3),centero(3),centerc(3),ss
c     f:textfile 
      integer*4 b1st(nat00),b2st(nat00),b1so(nat00),b2so(nat00),
     1b1ch(nat00),b2ch(nat00)
      integer*4 t1st(nat00),t2st(nat00),t3st(nat00),t1so(nat00),
     1t2so(nat00),t3so(nat00),t1ch(nat00),t2ch(nat00),t3ch(nat00),
     5itst(4,nat00),itso(4,nat00),itch(4,nat00),
     5iopst(4,nat00),iopso(4,nat00),iopch(4,nat00)
      real*8 epsst(nat00),ths(3,3),tho(3,3),thc(3,3),
     1epsch(nat00),epsso(nat00),r3so(nat00),r3ch(nat00),r3st(nat00),
     2k0st(nat00),k0so(nat00),
     3k0ch(nat00),b0so(nat00),b0ch(nat00),b0st(nat00),ktst(nat00),
     4ktso(nat00),ktch(nat00),btso(nat00),btch(nat00),btst(nat00),
     5tst(3,nat00),tso(3,nat00),tch(3,nat00),
     5kopst(nat00),kopso(nat00),kopch(nat00)

      cw=xbox
c{read in one static molecule}
      call redm(STATIC,nast,nat00,izst,rst,bondst,qst,epsst,r3st,
     1nbst,b1st,b2st,k0st,b0st,ntst,t1st,t2st,t3st,ktst,btst,nat0,
     2ndst,tst,itst,nopst,kopst,iopst)
c{read in one solvent molecule}
      call redm(SOLVENT,naso,nat00,izso,rso,bondso,qso,epsso,r3so,
     1nbso,b1so,b2so,k0so,b0so,ntso,t1so,t2so,t3so,ktso,btso,nat0,
     2ndso,tso,itso,nopso,kopso,iopso)
c{read in one chiral molecule}
      call redm(CHIRAL,nach,nat00,izch,rch,bondch,qch,epsch,r3ch,
     1nbch,b1ch,b2ch,k0ch,b0ch,ntch,t1ch,t2ch,t3ch,ktch,btch,nat0,
     2ndch,tch,itch,nopch,kopch,iopch)
      do 1 i=1,3
      centers(i)=0.0d0
      centero(i)=0.0d0
      centerc(i)=0.0d0
      do 1 j=1,3
      pols(i,j)=0.d0
      polo(i,j)=0.d0
      polc(i,j)=0.d0
      chis(i,j)=0.d0
      chio(i,j)=0.d0
      chic(i,j)=0.d0
      imc(i,j)=0.d0
      ims(i,j)=0.d0
1     imo(i,j)=0.d0

      if(lmagnet)then
c{read-in magnetic susceptibilities (in au)}
       call reds(CHISTATIC,nast,chis,perms,perma,0)
       call reds(CHISOLVENT,naso,chio,permo,perma,0)
       call reds(CHICHIRAL,nach,chic,permc,perma,0)
      endif
      if(lpolar)then
c{read-in polarizabilities (in au)}
       call reds(POLSTATIC,nast,pols,perms,.false.,1)
       call reds(POLSOLVENT,naso,polo,permo,.false.,1)
       call reds(POLCHIRAL,nach,polc,permc,.false.,1)
      endif
      if(lmagnet.or.lpolar)then
       if(l3vec)then
c       coordinate systems by first 3 atoms
        call tvec(nast,ths,rst,nat0)
        call tvec(naso,tho,rso,nat0)
        call tvec(nach,thc,rch,nat0)
       else
c       coordinate systems by inertia moments
c       {molecular masses}
c       {and center of gravity}
        smass=0.0d0
        omass=0.0d0
        cmass=0.0d0
        do 5 ia=1,nast
        smass=smass+mass(izst(ia))
        do 5 ix=1,3
5       centers(ix)=centers(ix)+mass(izst(ia))*rst(ia,ix)
        do 6 ia=1,naso
        omass=omass+mass(izso(ia))
        do 6 ix=1,3 
6       centero(ix)=centero(ix)+mass(izso(ia))*rso(ia,ix)
        do 7 ia=1,nach
        cmass=cmass+mass(izch(ia))
        do 7 ix=1,3 
7       centerc(ix)=centerc(ix)+mass(izch(ia))*rch(ia,ix)
        do 8 ix=1,3
        centers(ix)=centers(ix)/smass
        centero(ix)=centero(ix)/omass
8       centerc(ix)=centerc(ix)/cmass
c       {make inertia tensors}
        do 9 ix=1,3 
        do 9 jx=1,3
        do 91 ia=1,naso
91      imo(ix,jx)=imo(ix,jx)+mass(izso(ia))*
     1  (rso(ia,ix)-centero(ix))*(rso(ia,jx)-centero(jx))
        do 92 ia=1,nach
92      imc(ix,jx)=imc(ix,jx)+mass(izch(ia))*
     1  (rch(ia,ix)-centerc(ix))*(rch(ia,jx)-centerc(jx))
        do 9 ia=1,nast 
9       ims(ix,jx)=ims(ix,jx)+mass(izst(ia))*
     1  (rst(ia,ix)-centers(ix))*(rst(ia,jx)-centers(jx))
        call TRED12(3,ims,ths,dms,2,ierr)
        if(ierr.ne.0)call report('diagonalization error')
        call TRED12(3,imo,tho,dmo,2,ierr)
        if(ierr.ne.0)call report('diagonalization error')
        call TRED12(3,imc,thc,dmc,2,ierr)
        if(ierr.ne.0)call report('diagonalization error')
       endif
c      {magnetic susceptibilities in the molecular system}
       do 10 ix=1,3 
       do 10 jx=1,3 
       polcm(ix,jx)=0.0d0
       polom(ix,jx)=0.0d0
       polsm(ix,jx)=0.0d0
       chicm(ix,jx)=0.0d0
       chiom(ix,jx)=0.0d0
       chism(ix,jx)=0.0d0
       do 10 ixp=1,3
       do 10 jxp=1,3
       polsm(ix,jx)=polsm(ix,jx)+ths(ixp,ix)*pols(ixp,jxp)*ths(jxp,jx)
       polcm(ix,jx)=polcm(ix,jx)+thc(ixp,ix)*polc(ixp,jxp)*thc(jxp,jx)
       polom(ix,jx)=polom(ix,jx)+tho(ixp,ix)*polo(ixp,jxp)*tho(jxp,jx)
       chism(ix,jx)=chism(ix,jx)+ths(ixp,ix)*chis(ixp,jxp)*ths(jxp,jx)
       chicm(ix,jx)=chicm(ix,jx)+thc(ixp,ix)*chic(ixp,jxp)*thc(jxp,jx)
10     chiom(ix,jx)=chiom(ix,jx)+tho(ixp,ix)*chio(ixp,jxp)*tho(jxp,jx)
c      {permanent magnetic dipole moments in the molecular system}
       if(perma)then
        do 11 ix=1,3
        pmds(ix)=0.0d0
        pmdo(ix)=0.0d0
        pmdc(ix)=0.0d0
        do 11 ixp=1,3
        pmds(ix)=pmds(ix)+ths(ixp,ix)*perms(ixp)
        pmdo(ix)=pmdo(ix)+tho(ixp,ix)*permo(ixp)
11      pmdc(ix)=pmdc(ix)+thc(ixp,ix)*permc(ixp)
       endif
      endif

      if(nst*nast*2+nso*naso+nch*nach*2.gt.nat0)
     1call report('Too many atoms')

c{Generate static molecules -plane symmetry enforced,avoid chirality}
      ia=0
      ib=0
      it=0
      id=0
      ip=0
      IF(regular.and.nst.gt.0)THEN
       vone=xbox*ybox*zbox/2.0d0/dble(nst)
       dsx=exp(log(vone*xbox*xbox/ybox/zbox)/3.0d0)
       dsy=exp(log(vone*ybox*ybox/xbox/zbox)/3.0d0)
       dsz=exp(log(vone*zbox*zbox/xbox/ybox)/3.0d0)
1001   ia=0
       ib=0
       it=0
       id=0
       ip=0
       im=0
       x=xbox/2.0d0-dsx/2.0d0
1002   x=x+dsx
       y=-dsy/2.0d0
1003   y=y+dsy
       z=-dsz/2.0d0
1004   z=z+dsz
       im=im+1
       if(im.le.nst)then
	do 152 j=1,2
        do 12 i=1,nast
	if(j.eq.1)call adda(ia,r,rst(i,1)+x,rst(i,2)+y,
     1  rst(i,3)+z,q,qst(i),iz,izst(i),eps,epsst(i),r3,r3st(i))
12      if(j.eq.2)call adda(ia,r,rst(i,1)+cw-x,rst(i,2)+y,
     1  rst(i,3)+z,q,qst(i),iz,izst(i),eps,epsst(i),r3,r3st(i))
        do 14 i=1,nbst
14      call addbond(ib,ia+b1st(i)-nast,ia+b2st(i)-nast,k0st(i),b0st(i))
        do 15 i=1,ntst
15      call addangle(it,ia+t1st(i)-nast,ia+t2st(i)-nast,
     1  ia+t3st(i)-nast,ktst(i),btst(i))
        do 151 i=1,ndst
151     call adddiangle(id,ia+itst(1,i)-nast,ia+itst(2,i)-nast,
     1  ia+itst(3,i)-nast,ia+itst(4,i)-nast,tst(i,1),tst(i,2),tst(i,3))
        do 152 i=1,ndst
152     call addop(ip,ia+iopst(1,i)-nast,ia+iopst(2,i)-nast,
     1  ia+iopst(3,i)-nast,ia+iopst(4,i)-nast,kopst(i))
       endif
       if(z+dsz.le.zbox)goto 1004
       if(y+dsy.le.ybox)goto 1003
       if(x+dsx.le.xbox)goto 1002
       write(6,*)x,dsx,xbox,x+dsx
       dsx=dsx*0.95d0
       dsy=dsy*0.95d0
       dsz=dsz*0.95d0
       if(im.lt.nst)goto 1001
       nat=ia
       nb=ib
       nt=it
       nd=id
       np=ip
      ELSE
       do 16 j=1,nst
       x=xbox*dble(frandom(0))
       y=ybox*dble(frandom(0))
       z=zbox*dble(frandom(0))
       do 18 i=1,nast
18     call adda(ia,r,rst(i,1)+x,rst(i,2)+y,
     1 rst(i,3)+z,q,qst(i),iz,izst(i),eps,epsst(i),r3,r3st(i))
       do 19 i=1,nbst
19     call addbond(ib,ia+b1st(i)-nast,ia+b2st(i)-nast,k0st(i),b0st(i))
       do 20 i=1,ntst 
20     call addangle(it,ia+t1st(i)-nast,ia+t2st(i)-nast,ia+t3st(i)-nast,
     1 ktst(i),btst(i)) 
       do 153 i=1,ndst
153    call adddiangle(id,ia+itst(1,i)-nast,ia+itst(2,i)-nast,
     1 ia+itst(3,i)-nast,ia+itst(4,i)-nast,tst(i,1),tst(i,2),tst(i,3))
       do 154 i=1,ndst
154    call addop(ip,ia+iopst(1,i)-nast,ia+iopst(2,i)-nast,
     1 ia+iopst(3,i)-nast,ia+iopst(4,i)-nast,kopst(i))
16     continue
       nat=ia
       nb=ib
       nt=it
       nd=id
       np=ip
c      duplicate via the yz plane symmetry:
       do 21  ia=nat+1,2*nat
       r(3*(ia-1)+1)=cw-r(3*(ia-nat-1)+1)
       r(3*(ia-1)+2)=   r(3*(ia-nat-1)+2)
       r(3*(ia-1)+3)=   r(3*(ia-nat-1)+3)
       q(ia)=q(ia-nat)
       iz(ia)=iz(ia-nat)
       eps(ia)=eps(ia-nat)
21     r3(ia)=r3(ia-nat)
       do 22 i=nb+1,2*nb 
       b1(i)=b1(i-ib)+nat
       b2(i)=b2(i-ib)+nat
       k0(i)=k0(i-ib)
22     b0(i)=b0(i-ib)
       do 23 i=nt+1,2*nt
       t1(i)=t1(i-it)+nat
       t2(i)=t2(i-it)+nat
       t3(i)=t3(i-it)+nat
       kt(i)=kt(i-it)
23     bt(i)=bt(i-it)
       do 231 i=nd+1,2*nd
       d1(i)=d1(i-it)+nat
       d2(i)=d2(i-it)+nat
       d3(i)=d3(i-it)+nat
       d4(i)=d4(i-it)+nat
       k3d(i)=k3d(i-it)
       k2d(i)=k2d(i-it)
231    k1d(i)=k1d(i-it)
       do 232 i=np+1,2*np
       o1(i)=o1(i-it)+nat
       o2(i)=o2(i-it)+nat
       o3(i)=o3(i-it)+nat
       o4(i)=o4(i-it)+nat
232    oo(i)=oo(i-it)
       nb=2*nb
       nat=2*nat
       nt=2*nt
       nd=2*nd
       np=2*np
      ENDIF

      nat1st=1
      nat2st=nat

c{Generate solvent molecules -no symmetry}
      ia=nat
      ib=nb
      it=nt
      id=nd
      ip=np
      do 26 j=1,nso
      x=xbox*dble(frandom(0))
      y=ybox*dble(frandom(0))
      z=zbox*dble(frandom(0))
      do 25 i=1,naso
25    call adda(ia,r,rso(i,1)+x,rso(i,2)+y,
     1  rso(i,3)+z,q,qso(i),iz,izso(i),eps,epsso(i),r3,r3so(i))
      do 27 i=1,nbso
27    call addbond(ib,ia+b1so(i)-naso,ia+b2so(i)-naso,k0so(i),b0so(i))
      do 28 i=1,ntso
28    call addangle(it,ia+t1so(i)-naso,ia+t2so(i)-naso,ia+t3so(i)-naso,
     1ktso(i),btso(i))
      do 155 i=1,ndso
155   call adddiangle(id,ia+itso(1,i)-naso,ia+itso(2,i)-naso,
     1ia+itso(3,i)-naso,ia+itso(4,i)-naso,tso(i,1),tso(i,2),tso(i,3))
      do 156 i=1,ndso
156   call addop(ip,ia+iopso(1,i)-naso,ia+iopso(2,i)-naso,
     1ia+iopso(3,i)-naso,ia+iopso(4,i)-naso,kopso(i))
26    continue
      nat1so=nat+1
      nat=ia
      nb=ib
      nt=it
      nd=id
      np=ip
      nat2so=nat

c{Generate chiral molecules - replicate same number of enantiomers}
      ia=nat
      ib=nb
      it=nt
      id=nd
      ip=np
      do 30 j=1,2*nch
      x=xbox*dble(frandom(0))
      y=ybox*dble(frandom(0))
      z=zbox*dble(frandom(0))
      ss=1.0d0
      if(j.gt.nch)ss=-1.0d0
      do 32 i=1,nach
32    call adda(ia,r,rch(i,1)*ss+x,rch(i,2)*ss+y,
     1rch(i,3)*ss+z,q,qch(i),iz,izch(i),eps,epsch(i),r3,r3ch(i))
      do 33 i=1,nbch 
33    call addbond(ib,ia+b1ch(i)-nach,ia+b2ch(i)-nach,k0ch(i),b0ch(i))
      do 30 i=1,ntch 
30    call addangle(it,ia+t1ch(i)-nach,ia+t2ch(i)-nach,ia+t3ch(i)-nach,
     1ktch(i),btch(i))
      do 157 i=1,ndch
157   call adddiangle(id,ia+itch(1,i)-nach,ia+itch(2,i)-nach,
     1ia+itch(3,i)-nach,ia+itch(4,i)-nach,tch(i,1),tch(i,2),tch(i,3))
      do 158 i=1,ndch
158   call addop(ip,ia+iopch(1,i)-nach,ia+iopch(2,i)-nach,
     1ia+iopch(3,i)-nach,ia+iopch(4,i)-nach,kopch(i))
c
      nat1ch=nat+1
      nat=ia
      nb=ib
      nt=it
      nd=id
      np=ip
      nat2ch=nat
      nat12ch=(nat2ch+nat1ch) / 2
      call fixbox
      write(6,6001)nat,nb,nt,nd
6001  format('System was generated, ',i4,' atoms, ',i4,' bonds, ',
     1i4,' angles, ',i4,' torsions.') 

c{generate inproper bonds  do bond angles, in case that they are treated by the shake algorithm:}
      do 37 b=1,nt
      i=t1(b)
      k=t3(b)
      if(i.gt.nat2st.or.k.gt.nat2st.or.i.lt.nat1st.or.k.lt.nat1st)then
       ii=i+i+i-2
       kk=k+k+k-2
       btd(b)=(r(ii)-r(kk))**2+(r(ii+1)-r(kk+1))**2+(r(ii+2)-r(kk+2))**2
      else
       btd(b)=0
      endif
37    continue

      call setmolecules
      call assignmasses
      return
      end

      subroutine report(s)
      character*(*)s
      write(6,1)
1     format(80(1h*))
      write(6,*)s
      write(6,*)'Program stopped'
      write(6,1)
      stop
      end

      subroutine redm(STATIC,nast,nat00,izst,rst,bondst,qst,epsst,r3st,
     1nbst,b1st,b2st,k0st,b0st,ntst,t1st,t2st,t3st,ktst,btst,nat0,
     2ndst,tst,itst,nopst,kopst,iopst)
      implicit none
      character*80 STATIC
      integer*4 nast,i,nat00,bondst(nat00,7),nbst,ntst,t1st(*),
     1b1st(*),b2st(*),t2st(*),t3st(*),izst(*),nat0,itst(4,nat00),
     1iopst(4,nat00),ndst,nopst
      real*8 qst(*),epsst(*),r3st(*),kopst(*),
     1k0st(*),b0st(*),ktst(*),btst(*),rst(nat0,3),tst(3,nat00)
      open(33,file=STATIC)
      read(33,*)
      read(33,*)nast
      if(nast.gt.nat00)call report('Too many atoms')
      do 1 i=1,nast
1     read(33,*)izst(i),rst(i,1),rst(i,2),rst(i,3),bondst(i,1),
     1bondst(i,2),bondst(i,3),bondst(i,4),bondst(i,5),bondst(i,6),
     2bondst(i,7),qst(i)
      do 2 i=1,nast
2     read(33,*)epsst(i),r3st(i)
      read(33,*)nbst
      if(nbst.gt.nat00)call report('Too many bonds')
      do 3  i=1,nbst 
3     read(33,*)b1st(i),b2st(i),k0st(i),b0st(i)
      read(33,*)ntst
      if(ntst.gt.nat00)call report('Too many angles')
      do 4 i=1,ntst
4     read(33,*)t1st(i),t2st(i),t3st(i),ktst(i),btst(i)
      read(33,*)ndst
      if(ndst.gt.nat00)call report('Too many dihedral angles')
      do 5 i=1,ndst
5     read(33,*)itst(1,i),itst(2,i),itst(3,i),itst(4,i),
     1tst(1,i),tst(2,i),tst(3,i)
      read(33,*)nopst
      if(nopst.gt.nat00)call report('Too many oops')
      do 6 i=1,nopst
6     read(33,*)iopst(1,i),iopst(2,i),iopst(3,i),iopst(4,i),
     1kopst(i)
      close(33)
      return
      end

      subroutine reds(CHISTATIC,nast,chis,perms,perma,ic)
      logical perma
      character*80 CHISTATIC
      integer*4 nast,i,j,ic
      real*8 chis(3,3),perms(3)
      open(33,file=CHISTATIC)
      do 2 i=1,nast+1
2     read(33,*)
      if(ic.eq.0)then
       do 3 i=1,3
3      read(33,*)(chis(j,i),j=1,3)
      else
       read(33,*)chis(1,1),chis(2,1),chis(2,2),chis(3,1),chis(3,2),
     1 chis(3,3)
       chis(1,2)=chis(2,1)
       chis(1,3)=chis(3,1)
       chis(2,3)=chis(3,2)
      endif
      perms(1)=0.0d0
      perms(2)=0.0d0
      perms(3)=0.0d0
      if(perma)read(33,*)(perms(i),i=1,3)
      close(33)
      return
      end

      function sp(v1,v2)
      real*8 v1(3),v2(3),sp
      sp=v1(1)*v2(1)+v1(2)*v2(2)+v1(3)*v2(3)
      return
      end

      subroutine vp(v1,v2,v3)
      real*8 v1(3),v2(3),v3(3)
      v3(1)=v1(2)*v2(3)-v1(3)*v2(2)
      v3(2)=v1(3)*v2(1)-v1(1)*v2(3)
      v3(3)=v1(1)*v2(2)-v1(2)*v2(1)
      return
      end

      function ArcCosine(y)
      real*8 number,y,ArcCosine,x,o,pi,z0
      number=y
      o=1.0d0
      z0=0.0d0
      pi=4.0d0*datan(1.0d0)
      if(number.lt.-o)number=-o
      if(number.gt. o)number=o
      if(dabs(number).lt.0.00001d0)then 
       arccosine=90.0d0
      else 
       x=o-number*number
       if(dabs(x).lt.0.00001d0)then
        if(number.gt.z0)then 
	 arccosine=z0 
	else 
	 arccosine=180.0d0
	endif
       else
        x=(180.0d0/pi)*datan(dsqrt(x)/number)
        if(x.lt.z0) then 
	 arccosine=180.0d0+x 
	else 
	 arccosine=x
	endif
       endif
      endif
      return
      end
      
      subroutine energy(ic) 
      include 'common.i'
      include 'option.i'
c     {energy in kcal/mol, gradien in kcal/mol/A}
      real*8 pi180,pi1802,qic,ri3,ri6,rj3,rj6,epsilon,epsi,sum_b,
     1sum_vdw,sum_es,xi,yi,zi,d6,d33,rr,tem,aa,ba,sum_o,ct,sum_pol,
     2sum_a,v12,v13,v23,sum_t,c1,c2,c3,v3q,chi,ffr,oop,mjr3,mir3,
     3cc,ff,v2q,v1q,xb2,yb2,zb2,v1av2a,xj,yj,rr2,gnorm,rij7,
     4zj,xk,yk,zk,xl,yl,zl,rst3,sum_mag,mmas,rij2,rij5,xij,
     5yij,zij,fx,fy,fz,mjr,mir,mimj,tx,ty,tz,xia,bfx,bfy,bfz,
     6yia,zia,co,sumx,sumy,sumz,cut2,cl31,cl32,cl33,
     7cv(3),av(3),bv(3),v3(3),v1(3),v2(3),mcomx,mcomy,mcomz,mlocalx,
     7mlocaly,mlocalz,
     8 th(3,3),imom(3,3),dh(3),pi,an,cl11,cl12,cl13,cl21,cl22,cl23,
     9co1,sp,arccosine,t,ffes,ffres,shx,shy,shz,rmolix,rmoliy,
     armoliz,rmoljx,rmoljy,rmoljz,sumxx,sumxy,sumxz,sumyy,sumyz,sumzz,
     bmel(nat0,3),pl33,bindx,bindy,bindz,pl23,pl31,pl32,
     cmix,miy,miz,eix,eiy,eiz,Efield(nat0,3),pl11,pl12,pl13,pl21,pl22,
     deindx,eindy,eindz,gxe,gye,gze,gxm,gym,gzm,mjx,mjy,mjz,
     eejx,ejy,ejz,co2,ex,ey,ez,Efieldg(nat0*3,3),co3,mmi,
     frmol(3*nat0),gxe2,gye2,gze2,chicom11,chicom12,chicom13,
     fchicom21,chicom22,chicom23,chicom31,chicom32,chicom33,
     fpolcom11,polcom12,polcom13,mmagx(nat0),mmagz(nat0),mmagy(nat0),
     fpolcom21,polcom22,polcom23,polcom31,polcom32,polcom33,
     fv1x,v1y,v1z,e1x,e1y,e1z,e2x,e2y,e2z,e3x,e3y,e3z,bjf,
     ftxx,txy,txz,tyx,tyy,tyz,tzx,tzy,tzz,xt,yt,zt,rrmol(nat0)
      integer*4 ic,ll,kk,a,i,j,k,jj,l,ii,b,imol,jmol,
     1ia,ierr,i1,i2,j1,j2,nmol,i3

      co1=7.881d-6
      co3=bohr**3
      pi=4.0d0*datan(1.0d0)
      pi180=pi/180.0d0
      pi1802=pi*pi/180.0d0/180.0d0
      sum_es=z0
      sum_pol=z0
      sum_vdw=z0
      sum_b=z0
      sum_a=z0
      sum_t=z0
      sum_o=z0
      sum_mag=z0 
      xb2=xbox/2.0d0
      yb2=ybox/2.0d0
      zb2=zbox/2.0d0
      do 1 i=1,nat 
      g(3*(i-1)+1)=z0
      g(3*(i-1)+2)=z0
      g(3*(i-1)+3)=z0
      bxf(i)=z0
      byf(i)=z0
1     bzf(i)=z0
      cut2=cutoff**2
      co=cutoff-smooth
      if(co.lt.0)call report('cutoff must be bigger than smoothing')
      nmol=2*nst+nso+2*nch 

c     pre-calculate molecular positions and <r^2>:
      do 611 imol=1,nmol
      mmas=z0
      sumx=z0
      sumy=z0
      sumz=z0
      do 7 ia=ias(imol),iae(imol)
      mmi=mmass(ia)
      mmas=mmas+mmi
      sumx=sumx+mmi*r(3*(ia-1)+1)
      sumy=sumy+mmi*r(3*(ia-1)+2)
7     sumz=sumz+mmi*r(3*(ia-1)+3)
      sumx=sumx/mmas
      sumy=sumy/mmas
      sumz=sumz/mmas
      rmol(3*(imol-1)+1)=sumx
      rmol(3*(imol-1)+2)=sumy
      rmol(3*(imol-1)+3)=sumz
      rr=z0
      do 71 ia=ias(imol),iae(imol)
71    rr=rr+mmass(ia)*
     1((r(3*(ia-1)+1)-sumx)**2+
     2 (r(3*(ia-1)+2)-sumy)**2+
     3 (r(3*(ia-1)+3)-sumz)**2)
611   rrmol(imol)=rr/mmas
c
c     {electrostatic and van der Waals}
c     Individual molecules extra:
      do 9 imol=2*nst+1,nmol
      do 9 i=ias(imol),iae(imol)
      ri3=r3(i)
      ri6=ri3*ri3
      epsi=eps(i)
      qic=q(i)*bohr*kcal
      ii=i+i+i-2
      xi=r(ii  )
      yi=r(ii+1)
      zi=r(ii+2)
      do 9 j=i+1,iae(imol)
      do 6195 b=1,nb
6195  if((i.eq.b1(b).and.j.eq.b2(b)).
     1or.(j.eq.b1(b).and.i.eq.b2(b)))goto 9
      do 6196 b=1,nt
6196  if((i.eq.t1(b).and.j.eq.t3(b)).
     1or.(j.eq.t1(b).and.i.eq.t3(b)))goto 9
      do 6197 b=1,nd
6197  if((i.eq.d1(b).and.j.eq.d4(b)).
     1or.(j.eq.d1(b).and.i.eq.d4(b)))goto 9
      jj=j+j+j-2
      xij=xi-r(jj  )
      yij=yi-r(jj+1)
      zij=zi-r(jj+2)
      rr2=xij**2+yij**2+zij**2+1.0d-8
      rr=dsqrt(rr2)
      rj3=r3(j)
      rj6=rj3*rj3
      epsilon=2.0d0*dsqrt(epsi*eps(j))*ri3*rj3/(ri6+rj6)
      rst3=sqrt(0.5d0*(ri6+rj6))
      d33=rst3/rr/rr2
      d6=d33**2
      ff=epsilon*(d33+d33-3.0d0)*d6
      ffes=qic*q(j)/rr
      sum_vdw=sum_vdw+ff
      sum_es=sum_es+ffes
      if(ic.gt.0)then 
       ffr=-18.0d0*epsilon*(d6*d33-d6)/rr
       ffres=-ffes/rr
       tem=(ffr+ffres)/rr
       g(ii  )=g(ii  )+tem*xij
       g(jj  )=g(jj  )-tem*xij
       g(ii+1)=g(ii+1)+tem*yij
       g(jj+1)=g(jj+1)-tem*yij
       g(ii+2)=g(ii+2)+tem*zij
       g(jj+2)=g(jj+2)-tem*zij
      endif
9     continue
c     Rest, I-J, I<>J:
      do 61 imol=1,nmol
      i1=ias(imol)
      i2=iae(imol)
      ii=3*(imol-1)
      rmolix=rmol(ii+1)
      rmoliy=rmol(ii+2)
      rmoliz=rmol(ii+3)
      do 62 jmol=imol+1,nmol
      if(jmol.gt.2*nst.or.imol.gt.2*nst)then
       j1=ias(jmol)
       j2=iae(jmol)
       jj=3*(jmol-1)
       rmoljx=rmol(jj+1)
       rmoljy=rmol(jj+2)
       rmoljz=rmol(jj+3)
       call lpc(shx,shy,shz,rmolix,rmoljx,xb2,rmoliy,rmoljy,yb2,
     1 rmoliz,rmoljz,zb2,xbox,ybox,zbox)
       rmoljx=rmoljx+shx
       rmoljy=rmoljy+shy
       rmoljz=rmoljz+shz
       if((rmolix-rmoljx)**2+(rmoliy-rmoljy)**2+(rmoliz-rmoljz)**2
     1 .lt.cut2)then
        do 2 i=i1,i2
        ri3=r3(i)
        ri6=ri3*ri3
        epsi=eps(i)
        qic=q(i)*bohr*kcal
        ii=i+i+i-2
        xi=r(ii  )-shx
        yi=r(ii+1)-shy
        zi=r(ii+2)-shz
	bfx=z0
	bfy=z0
	bfz=z0
        do 3 j=j1,j2
        jj=j+j+j-2
        xij=xi-r(jj  )
        yij=yi-r(jj+1)
        zij=zi-r(jj+2)
        rr2=xij**2+yij**2+zij**2+1.0d-8
        if(rr2.lt.cut2)THEN
         rr=dsqrt(rr2)
         rj3=r3(j)
         rj6=rj3*rj3
         epsilon=2.0d0*dsqrt(epsi*eps(j))*ri3*rj3/(ri6+rj6)
         rst3=sqrt(0.5d0*(ri6+rj6))
         d33=rst3/rr/rr2
         d6=d33**2
         ff=epsilon*(d33+d33-3.0d0)*d6
         ffes=qic*q(j)/rr
c
c        record also magnetic field from moving charges for 
c        latter use: B~vxr/r^3
         bjf=q(j)/rr/rr2
	 bfx=bfx+bjf*((r(jj+1)-rmm(jj+1))*zij-(r(jj+2)-rmm(jj+2))*yij)
	 bfy=bfy+bjf*((r(jj+2)-rmm(jj+2))*xij-(r(jj  )-rmm(jj  ))*zij)
	 bfz=bfz+bjf*((r(jj  )-rmm(jj  ))*yij-(r(jj+1)-rmm(jj+1))*xij)
         if(rr.gt.co)then 
          cc=(cutoff-rr)/smooth
          sum_vdw=sum_vdw+ff*cc
          sum_es=sum_es+ffes*cc 
         else
          sum_vdw=sum_vdw+ff
          sum_es=sum_es+ffes
         endif
         if(ic.gt.0)then 
          ffr=-18.0d0*epsilon*(d6*d33-d6)/rr
          ffres=-ffes/rr
          if(rr.gt.co)then
           tem=((ffr+ffres)*cc-(ff+ffes)/smooth)/rr
          else
  	   tem=(ffr+ffres)/rr
          endif
          g(ii  )=g(ii  )+tem*xij
          g(jj  )=g(jj  )-tem*xij
          g(ii+1)=g(ii+1)+tem*yij
          g(jj+1)=g(jj+1)-tem*yij
          g(ii+2)=g(ii+2)+tem*zij
          g(jj+2)=g(jj+2)-tem*zij
         endif
        ENDIF
3       continue
        bxf(i)=bfx*2.881d-6/0.529d0/2.0d0/dt
        byf(i)=bfy*2.881d-6/0.529d0/2.0d0/dt
        bzf(i)=bfz*2.881d-6/0.529d0/2.0d0/dt
2       continue
       endif
      endif
62    continue
      do 629 i=i1,i2
629   sum_es=sum_es-q(i)*efieldy*r(3*(i-1)+2)/bohr*kcal
      if(ic.gt.0)then 
       do 6194 i=i1,i2
6194   g(3*(i-1)+2)=g(3*(i-1)+2)-efieldy*q(i)/bohr*kcal
      endif
61    continue

      if(lpolar)then
c      ES field from charges + external acting on molecule imol
       do 6111 imol=1,nmol
       ii=3*(imol-1)
       xi=rmol(ii+1)
       yi=rmol(ii+2)
       zi=rmol(ii+3)
       sumx=z0
       sumy=z0
       sumz=z0
       sumxx=z0
       sumyy=z0
       sumzz=z0
       sumxy=z0
       sumxz=z0
       sumyz=z0
       do 6112 jmol=1,nmol
       if(jmol.ne.imol)then
        jj=3*(jmol-1)
        rmoljx=rmol(jj+1)
        rmoljy=rmol(jj+2)
        rmoljz=rmol(jj+3)
	call lpc(shx,shy,shz,xi,rmoljx,xb2,yi,rmoljy,yb2,zi,rmoljz,zb2,
     1  xbox,ybox,zbox)
        rmoljx=rmoljx+shx
        rmoljy=rmoljy+shy
        rmoljz=rmoljz+shz
        rr2=(xi-rmoljx)**2+(yi-rmoljy)**2+(zi-rmoljz)**2
        if(rr2.lt.cut2)then
         do 311 j=ias(jmol),iae(jmol)
         jj=j+j+j-2
         xij=xi-r(jj  )-shx
         yij=yi-r(jj+1)-shy
         zij=zi-r(jj+2)-shz
         rr2=xij**2+yij**2+zij**2+1.0d-8
         if(rr2.lt.cut2)THEN
          rr=dsqrt(rr2)
          ffes=q(j)/rr2
          if(rr.gt.co)then 
           cc=((cutoff-rr)/rr+1.0d0)/smooth*ffes
           sumx=sumx+xij*cc
           sumy=sumy+yij*cc
           sumz=sumz+zij*cc
           cc=(cutoff-rr)/rr+1.0d0
           sumxx=sumxx+ffes*(-2.0d0*cc*xij*xij/rr2
     2     -(cutoff-rr)*xij*xij/rr/rr2-xij*xij/rr2+cc)/smooth
           sumyy=sumyy+ffes*(-2.0d0*cc*yij*yij/rr2
     2     -(cutoff-rr)*yij*yij/rr/rr2-yij*yij/rr2+cc)/smooth
           sumzz=sumzz+ffes*(-2.0d0*cc*zij*zij/rr2
     2     -(cutoff-rr)*zij*zij/rr/rr2-zij*zij/rr2+cc)/smooth
           sumxy=sumxy+ffes*(-2.0d0*cc*xij*yij/rr2
     2     -(cutoff-rr)*xij*yij/rr/rr2-xij*yij/rr2)/smooth
           sumxz=sumxz+ffes*(-2.0d0*cc*xij*zij/rr2
     2     -(cutoff-rr)*xij*zij/rr/rr2-xij*zij/rr2)/smooth
           sumyz=sumyz+ffes*(-2.0d0*cc*yij*zij/rr2
     2     -(cutoff-rr)*yij*zij/rr/rr2-yij*zij/rr2)/smooth
          else
           sumx=sumx+ffes*xij/rr
           sumy=sumy+ffes*yij/rr
           sumz=sumz+ffes*zij/rr
           sumxx=sumxx+ffes*(1.0d0-3.0d0*xij*xij/rr2)/rr
           sumyy=sumyy+ffes*(1.0d0-3.0d0*yij*yij/rr2)/rr
           sumzz=sumzz+ffes*(1.0d0-3.0d0*zij*zij/rr2)/rr
           sumxy=sumxy+ffes*(-3.0d0*xij*yij/rr2)/rr
           sumxz=sumxz+ffes*(-3.0d0*xij*zij/rr2)/rr
           sumyz=sumyz+ffes*(-3.0d0*yij*zij/rr2)/rr
          endif
         endif
311      continue
        endif
       endif
6112   continue
       Efield(imol,1)=sumx*bohr**2
       Efield(imol,2)=sumy*bohr**2+efieldy
       Efield(imol,3)=sumz*bohr**2
       Efieldg(3*(imol-1)+1,1)=sumxx*bohr**2
       Efieldg(3*(imol-1)+1,2)=sumxy*bohr**2
       Efieldg(3*(imol-1)+1,3)=sumxz*bohr**2
       Efieldg(3*(imol-1)+2,1)=sumxy*bohr**2
       Efieldg(3*(imol-1)+2,2)=sumyy*bohr**2
       Efieldg(3*(imol-1)+2,3)=sumyz*bohr**2
       Efieldg(3*(imol-1)+3,1)=sumxz*bohr**2
       Efieldg(3*(imol-1)+3,2)=sumyz*bohr**2
       Efieldg(3*(imol-1)+3,3)=sumzz*bohr**2
6111   continue
      endif
 
      if(lpolar.or.lmagnet)then
c      {chiloc - susceptibilities in local coordinate system, 
c      {polloc - polarizability in local coordinate system, 
c      mlocal - mag moments; initialize with static values:}
       if(lmagnet)then
        mlocalx=pmds(1)
        mlocaly=pmds(2)
        mlocalz=pmds(3)
        cl11=chism(1,1)
        cl12=chism(1,2)
        cl13=chism(1,3)
        cl21=chism(2,1)
        cl22=chism(2,2)
        cl23=chism(2,3)
        cl31=chism(3,1)
        cl32=chism(3,2)
        cl33=chism(3,3)
       endif
       if(lpolar)then
        pl11=polsm(1,1)
        pl12=polsm(1,2)
        pl13=polsm(1,3)
        pl21=polsm(2,1)
        pl22=polsm(2,2)
        pl23=polsm(2,3)
        pl31=polsm(3,1)
        pl32=polsm(3,2)
        pl33=polsm(3,3)
       endif

       do 6 imol=1,nmol
       if(imol.eq.2*nst+1)then
	if(lmagnet)then
         mlocalx=pmdo(1)
         mlocaly=pmdo(2)
         mlocalz=pmdo(3)
         cl11=chiom(1,1)
         cl12=chiom(1,2)
         cl13=chiom(1,3)
         cl21=chiom(2,1)
         cl22=chiom(2,2)
         cl23=chiom(2,3)
         cl31=chiom(3,1)
         cl32=chiom(3,2)
         cl33=chiom(3,3)
        endif
	if(lpolar)then
         pl11=polom(1,1)
         pl12=polom(1,2)
         pl13=polom(1,3)
         pl21=polom(2,1)
         pl22=polom(2,2)
         pl23=polom(2,3)
         pl31=polom(3,1)
         pl32=polom(3,2)
         pl33=polom(3,3)
        endif
       endif
       if(imol.eq.2*nst+nso+1)then
	if(lmagnet)then
         mlocalx=pmdc(1)
         mlocaly=pmdc(2)
         mlocalz=pmdc(3)
         cl11=chicm(1,1)
         cl12=chicm(1,2)
         cl13=chicm(1,3)
         cl21=chicm(2,1)
         cl22=chicm(2,2)
         cl23=chicm(2,3)
         cl31=chicm(3,1)
         cl32=chicm(3,2)
         cl33=chicm(3,3)
        endif
	if(lpolar)then
         pl11=polcm(1,1)
         pl12=polcm(1,2)
         pl13=polcm(1,3)
         pl21=polcm(2,1)
         pl22=polcm(2,2)
         pl23=polcm(2,3)
         pl31=polcm(3,1)
         pl32=polcm(3,2)
         pl33=polcm(3,3)
        endif
       endif
c
c      for polarizability, look at all molecules,
c      otherwise exclude solvent if not requested:
       if(lpolar.or.(solma.or.(imol.le.2*nst.or.imol.gt.2*nst+nso)))THEN
c       {get molecular moments of inertia}
        if(imol.eq.1.or.imol.gt.2*nst)then
c        static do not change positions, all have same moments as first
         if(l3vec)then
	  i1=3*(ias(imol)  -1)
	  i2=3*(ias(imol)+1-1)
	  i3=3*(ias(imol)+2-1)
          v1x=r(i2+1)-r(i1+1)
          v1y=r(i2+2)-r(i1+2)
          v1z=r(i2+3)-r(i1+3)
          e1x=r(i3+1)-r(i2+1)
          e1y=r(i3+2)-r(i2+2)
          e1z=r(i3+3)-r(i2+3)
          an=dsqrt(e1x**2+e1y**2+e1z**2+1.0d-8)
          e1x=e1x/an
          e1y=e1y/an
          e1z=e1z/an
          e2x=v1y*e1z-v1z*e1y
          e2y=v1z*e1x-v1x*e1z
          e2z=v1x*e1y-v1y*e1x
          an=dsqrt(e2x**2+e2y**2+e2z**2+1.0d-8)
          e2x=e2x/an
          e2y=e2y/an
          e2z=e2z/an
          e3x=e1y*e2z-e1z*e2y
          e3y=e1z*e2x-e1x*e2z
          e3z=e1x*e2y-e1y*e2x
	 else
          sumxx=z0
          sumxy=z0
          sumxz=z0
          sumyy=z0
          sumyz=z0
          sumzz=z0
          ii=3*(imol-1)
          xi=rmol(ii+1)
          yi=rmol(ii+2)
          zi=rmol(ii+3)
          do 619 ia=ias(imol),iae(imol)
	  ii=3*(ia-1)
	  mmi=mmass(ia)
	  xt=r(ii+1)-xi
	  yt=r(ii+2)-yi
	  zt=r(ii+3)-zi
          sumxx=sumxx+mmi*xt*xt
          sumxy=sumxy+mmi*xt*yt
          sumxz=sumxz+mmi*xt*zt
          sumyy=sumyy+mmi*yt*yt
          sumyz=sumyz+mmi*yt*zt
619       sumzz=sumzz+mmi*zt*zt
          imom(1,1)=sumxx
          imom(1,2)=sumxy
          imom(1,3)=sumxz
          imom(2,1)=sumxy
          imom(2,2)=sumyy
          imom(2,3)=sumyz
          imom(3,1)=sumxz
          imom(3,2)=sumyz
          imom(3,3)=sumzz
c         { th(common, diag local)}
          call TRED12(3,imom,th,dh,2,ierr)
	  if( ierr.ne.0)then
	   write(6,*)imom
	   call report('diagonalization error in energy')
          endif
          e1x=th(1,1)
          e2x=th(1,2)
          e3x=th(1,3)
          e1y=th(2,1)
          e2y=th(2,2)
          e3y=th(2,3)
          e1z=th(3,1)
          e2z=th(3,2)
          e3z=th(3,3)
	 endif
c        {chi in common origin system}
c        {premanent magnetic moments in common origin system}
         if(lmagnet)then
          mcomx=e1x*mlocalx+e2x*mlocaly+e3x*mlocalz
          mcomy=e1y*mlocalx+e2y*mlocaly+e3y*mlocalz
          mcomz=e1z*mlocalx+e2z*mlocaly+e3z*mlocalz
c         transform first index to common
          txx=e1x*cl11+e2x*cl21+e3x*cl31
          txy=e1x*cl12+e2x*cl22+e3x*cl32
          txz=e1x*cl13+e2x*cl23+e3x*cl33
          tyx=e1y*cl11+e2y*cl21+e3y*cl31
          tyy=e1y*cl12+e2y*cl22+e3y*cl32
          tyz=e1y*cl13+e2y*cl23+e3y*cl33
          tzx=e1z*cl11+e2z*cl21+e3z*cl31
          tzy=e1z*cl12+e2z*cl22+e3z*cl32
          tzz=e1z*cl13+e2z*cl23+e3z*cl33
c         transform second index to common
          chicom11=e1x*txx+e2x*txy+e3x*txz
          chicom12=e1y*txx+e2y*txy+e3y*txz
          chicom13=e1z*txx+e2z*txy+e3z*txz
          chicom21=e1x*tyx+e2x*tyy+e3x*tyz
          chicom22=e1y*tyx+e2y*tyy+e3y*tyz
          chicom23=e1z*tyx+e2z*tyy+e3z*tyz
          chicom31=e1x*tzx+e2x*tzy+e3x*tzz
          chicom32=e1y*tzx+e2y*tzy+e3y*tzz
          chicom33=e1z*tzx+e2z*tzy+e3z*tzz
c         {total magnetic moments do molecules m=m0+chi*B0}
          mmagx(imol)=mcomx+chicom11*bx+chicom12*by+chicom13*bz
          mmagy(imol)=mcomy+chicom21*bx+chicom22*by+chicom23*bz
          mmagz(imol)=mcomz+chicom31*bx+chicom32*by+chicom33*bz
         endif
         if(lpolar)then
c         transform first index to common
          txx=e1x*pl11+e2x*pl21+e3x*pl31
          txy=e1x*pl12+e2x*pl22+e3x*pl32
          txz=e1x*pl13+e2x*pl23+e3x*pl33
          tyx=e1y*pl11+e2y*pl21+e3y*pl31
          tyy=e1y*pl12+e2y*pl22+e3y*pl32
          tyz=e1y*pl13+e2y*pl23+e3y*pl33
          tzx=e1z*pl11+e2z*pl21+e3z*pl31
          tzy=e1z*pl12+e2z*pl22+e3z*pl32
          tzz=e1z*pl13+e2z*pl23+e3z*pl33
c         transform second index to common
          polcom11=e1x*txx+e2x*txy+e3x*txz
          polcom12=e1y*txx+e2y*txy+e3y*txz
          polcom13=e1z*txx+e2z*txy+e3z*txz
          polcom21=e1x*tyx+e2x*tyy+e3x*tyz
          polcom22=e1y*tyx+e2y*tyy+e3y*tyz
          polcom23=e1z*tyx+e2z*tyy+e3z*tyz
          polcom31=e1x*tzx+e2x*tzy+e3x*tzz
          polcom32=e1y*tzx+e2y*tzy+e3y*tzz
          polcom33=e1z*tzx+e2z*tzy+e3z*tzz
         endif
	else
c        static molecules 2..2*nst all same moments as first:
         if(lmagnet)then
          mmagx(imol)=mmagx(1)
          mmagy(imol)=mmagy(1)
          mmagz(imol)=mmagz(1)
         endif
        endif
        if(lpolar)then
c        {total induced electric moment m=alpha*E}
         mel(imol,1)=polcom11*Efield(imol,1)+
     1               polcom12*Efield(imol,2)+polcom13*Efield(imol,3)
         mel(imol,2)=polcom21*Efield(imol,1)+
     1               polcom22*Efield(imol,2)+polcom23*Efield(imol,3)
         mel(imol,3)=polcom31*Efield(imol,1)+
     1               polcom32*Efield(imol,2)+polcom33*Efield(imol,3)
        endif
c       polar
       ENDIF
c      polar/solma
6      continue
c      imol

c      {energy and gradient only do chiral + solvent(if desired)}
       do 14 imol=2*nst+1,nmol
       if(lpolar.or.(imol.gt.2*nst+nso.or.solma))THEN
        ii=3*(imol-1)
        xi=rmol(ii+1)
	yi=rmol(ii+2)
	zi=rmol(ii+3)
        if(lmagnet)then
         mix=mmagx(imol)
         miy=mmagy(imol)
         miz=mmagz(imol)
         bindx=z0
         bindy=z0
         bindz=z0
        endif
        if(lpolar)then
         eix=mel(imol,1)
         eiy=mel(imol,2)
         eiz=mel(imol,3)
         eindx=z0
         eindy=z0
         eindz=z0
        endif
        gxe2=z0
	gye2=z0
	gze2=z0
        gxe=z0
	gye=z0
	gze=z0
        gxm=z0
	gym=z0
	gzm=z0

c       {induced field from everything:}
        do 16 jmol=1,nmol
        if(jmol.le.2*nst.or.jmol.gt.2*nst+nso.or.solma.or.lpolar)THEN
         if( jmol.ne.imol) then 
          jj=3*(jmol-1)
          xj=rmol(jj+1)
	  yj=rmol(jj+2)
	  zj=rmol(jj+3)
	  call lpc(shx,shy,shz,xi,xj,xb2,yi,yj,yb2,zi,zj,zb2,
     1    xbox,ybox,zbox)
	  xj=xj+shx
	  yj=yj+shy
	  zj=zj+shz
          xij=xi-xj
	  yij=yi-yj
	  zij=zi-zj
          rij2=xij**2+yij**2+zij**2+1.0d-8
	  if(.not.lmcut.or.rij2.lt.cut2)then
           rij5=dsqrt(rij2)*rij2**2
           rij7=5.0d0*rij5*rij2
           if(lmagnet)then
            mjx=mmagx(jmol)
            mjy=mmagy(jmol)
            mjz=mmagz(jmol)
            mjr=xij*mjx+yij*mjy+zij*mjz
            mjr3=mjr+mjr+mjr
            bindx=bindx+(mjr3*xij-rij2*mjx)/rij5
            bindy=bindy+(mjr3*yij-rij2*mjy)/rij5
            bindz=bindz+(mjr3*zij-rij2*mjz)/rij5
            if(ic.gt.0)then
             mir =xij*mix+yij*miy+zij*miz
             mir3=mir+mir+mir
             mimj=mjx*mix+mjy*miy+mjz*miz
c            {force due to the magnetic field inhomogenity}
             gxm=gxm-(mir3*mjx+mjr3*mix-2.0d0*xij*mimj)/rij5
     2       +(mjr*mir3-rij2*mimj)*xij/rij7
             gym=gym-(mir3*mjy+mjr3*miy-2.0d0*yij*mimj)/rij5
     2       +(mjr*mir3-rij2*mimj)*yij/rij7
             gzm=gzm-(mir3*mjz+mjr3*miz-2.0d0*zij*mimj)/rij5
     2       +(mjr*mir3-rij2*mimj)*zij/rij7
            endif
           endif
           if(lpolar)then
	    ejx=mel(jmol,1)
	    ejy=mel(jmol,2)
	    ejz=mel(jmol,3)
            mjr=xij*ejx+yij*ejy+zij*ejz
            mjr3=mjr+mjr+mjr
            eindx=eindx+(mjr3*xij-rij2*ejx)/rij5*co3
            eindy=eindy+(mjr3*yij-rij2*ejy)/rij5*co3
            eindz=eindz+(mjr3*zij-rij2*ejz)/rij5*co3
            if(ic.gt.0)then
             mir =xij*eix+yij*eiy+zij*eiz
             mir3=mir+mir+mir
             mimj=ejx*eix+ejy*eiy+ejz*eiz
c            {force due to the E field inhomogenity}
             gxe=gxe-(mir3*ejx+mjr3*eix-
     1       2.0d0*xij*mimj)/rij5
     2       +(mjr*mir3-rij2*mimj)*xij/rij7
             gye=gye-(mir3*ejy+mjr3*eiy-
     1       2.0d0*yij*mimj)/rij5
     2       +(mjr*mir3-rij2*mimj)*yij/rij7
             gze=gze-(mir3*ejz+mjr3*eiz-
     1       2.0d0*zij*mimj)/rij5
     2       +(mjr*mir3-rij2*mimj)*zij/rij7
            endif
           endif
          endif
         endif
        ENDIF
16      continue

        if(lmagnet)then
c        {to au, coordinates in A, mag moments in au}
         bindx=bindx*co1
         bindy=bindy*co1
         bindz=bindz*co1
c        add moments induced from secondary magnetization:
         mix=mix+chicom11*bindx+chicom12*bindy+chicom13*bindz
         miy=miy+chicom21*bindx+chicom22*bindy+chicom23*bindz
         miz=miz+chicom31*bindx+chicom32*bindy+chicom33*bindz
         bindx=bindx+bx
         bindy=bindy+by
         bindz=bindz+bz
         sum_mag=sum_mag-mix*bindx-miy*bindy-miz*bindz
c        write(6,*)mix,miy,miz,bindx,bindy,bindz
        endif

        if(lpolar)then
c        {to au, coordinates in A, mag moments in au}
         eix=eix+polcom11*eindx+polcom12*eindy+polcom13*eindz
         eiy=eiy+polcom21*eindx+polcom22*eindy+polcom23*eindz
         eiz=eiz+polcom31*eindx+polcom32*eindy+polcom33*eindz
         sum_pol=sum_pol-eix*(eindx+Efield(imol,1))
     1                  -eiy*(eindy+Efield(imol,2))
     2                  -eiz*(eindz+Efield(imol,3))
         if(ic.gt.0)then
	  gxe2=gxe2-eix*Efieldg(3*(imol-1)+1,1)
     1           -eiy*Efieldg(3*(imol-1)+1,2)
     2           -eiz*Efieldg(3*(imol-1)+1,3)
	  gye2=gye2-eix*Efieldg(3*(imol-1)+2,1)
     1           -eiy*Efieldg(3*(imol-1)+2,2)
     2           -eiz*Efieldg(3*(imol-1)+2,3)
	  gze2=gze2-eix*Efieldg(3*(imol-1)+3,1)
     1           -eiy*Efieldg(3*(imol-1)+3,2)
     2           -eiz*Efieldg(3*(imol-1)+3,3)
	 endif
        endif

c       {distribute over all atoms in imol}
        if(ic.gt.0)then 
	 fx=gxm*co1+gxe*co3+gxe2
	 fy=gym*co1+gye*co3+gye2
	 fz=gzm*co1+gze*co3+gze2
	 i1=ias(imol)
	 i2=iae(imol) 
	 co2=kcal/dble(i2-i1+1)
         fx=fx*co2
         fy=fy*co2
         fz=fz*co2
         do 20 ia=i1,i2
	 ii=3*(ia-1)
         g(ii+1)=g(ii+1)+fx
         g(ii+2)=g(ii+2)+fy
20       g(ii+3)=g(ii+3)+fz
c        {torsional force:}
         tx=z0
         ty=z0
         tz=z0
         if(lmagnet)then
          tx=tx+miy*bindz-miz*bindy
          ty=ty+miz*bindx-mix*bindz
          tz=tz+mix*bindy-miy*bindx
	 endif
         if(lpolar)then
	  ex=eindx+Efield(imol,1)
	  ey=eindy+Efield(imol,2)
	  ez=eindz+Efield(imol,3)
          tx=tx+(eiy*ez-eiz*ey)
          ty=ty+(eiz*ex-eix*ez)
          tz=tz+(eix*ey-eiy*ex)
	 endif
         tx=tx*co2
         ty=ty*co2
         tz=tz*co2
	 rr=rrmol(imol)
         do 21 ia=i1,i2
	 ii=3*(ia-1)
         xia=r(ii+1)-xi
	 yia=r(ii+2)-yi
	 zia=r(ii+3)-zi
         g(ii+1)=g(ii+1)+(       -ty*zia+tz*yia)/rr
         g(ii+2)=g(ii+2)+( tx*zia       -tz*xia)/rr
21       g(ii+3)=g(ii+3)+(-tx*yia+ty*xia       )/rr
        endif
       ENDIF
14     continue
       sum_mag=sum_mag*kcal
       sum_pol=sum_pol*kcal
      endif

c{bonds}
c{Periodic conditions do not need,be considered since whole molecules are always in box}
      do 22 b=1,nb 
      i=b1(b)
      j=b2(b)
      if(i.gt.nat2st.or.j.gt.nat2st)then
       ii=i+i+i-2
       jj=j+j+j-2
       xij=r(ii  )-r(jj  )
       yij=r(ii+1)-r(jj+1)
       zij=r(ii+2)-r(jj+2)
       rr=dsqrt(xij**2+yij**2+zij**2)
       sum_b=sum_b+k0(b)*(rr-b0(b))**2
       if(ic.gt.0.and.rr.gt.1.0d-5)then
        ffr=2.0d0*k0(b)*(rr-b0(b))/rr
        g(ii  )=g(ii  )+ffr*xij
	g(jj  )=g(jj  )-ffr*xij
        g(ii+1)=g(ii+1)+ffr*yij
	g(jj+1)=g(jj+1)-ffr*yij
        g(ii+2)=g(ii+2)+ffr*zij
	g(jj+2)=g(jj+2)-ffr*zij
       endif
      endif
22    continue

c{bond angles}
      do 23 b=1,nt 
      i=t1(b)
      j=t2(b)
      k=t3(b)
      if(i.gt.nat2st.or.j.gt.nat2st.or.k.gt.nat2st) then 
       ii=i+i+i-2
       jj=j+j+j-2
       kk=k+k+k-2
       xi=r(ii)
       yi=r(ii+1)
       zi=r(ii+2)
       xj=r(jj)
       yj=r(jj+1)
       zj=r(jj+2)
       xk=r(kk)
       yk=r(kk+1)
       zk=r(kk+2)
       v1(1)=xi-xj
       v1(2)=yi-yj
       v1(3)=zi-zj
       v2(1)=xk-xj
       v2(2)=yk-yj
       v2(3)=zk-zj
       v1q=sp(v1,v1)+1.0d-8
       v2q=sp(v2,v2)+1.0d-8
       v1av2a=1.0d0/dsqrt(v1q*v2q)
       ct=sp(v1,v2)*v1av2a
       tem=arccosine(ct)-bt(b)
       sum_a=sum_a+pi1802*kt(b)*tem**2
       if(ic.gt.0)then
        t=2.0d0*kt(b)*pi180*tem*(-1.0d0/dsqrt(1.0001d0-ct**2))
        do 24 a=0,2 
        c1=(v2(a+1)*v1av2a-ct/v1q*v1(a+1))*t
        c2=(v1(a+1)*v1av2a-ct/v2q*v2(a+1))*t
        g(ii+a)=g(ii+a)+c1
        g(jj+a)=g(jj+a)-c1-c2
24      g(kk+a)=g(kk+a)+c2
       endif
      endif
23    continue

c{torsion angles}
      do 25 b=1,nd 
      i=d1(b)
      j=d2(b)
      k=d3(b)
      l=d4(b)
      if(i.gt.nat2st.or.j.gt.nat2st.or.k.gt.nat2st.or.l.gt.nat2st)then
       ii=i+i+i-2
       jj=j+j+j-2
       kk=k+k+k-2
       ll=l+l+l-2
       xi=r(ii)
       yi=r(ii+1)
       zi=r(ii+2)
       xj=r(jj)
       yj=r(jj+1)
       zj=r(jj+2)
       xk=r(kk)
       yk=r(kk+1)
       zk=r(kk+2)
       xl=r(ll)
       yl=r(ll+1)
       zl=r(ll+2)
       v1(1)=xi-xj
       v1(2)=yi-yj
       v1(3)=zi-zj
       v2(1)=xk-xj
       v2(2)=yk-yj
       v2(3)=zk-zj
       v3(1)=xl-xk
       v3(2)=yl-yk
       v3(3)=zl-zk
       call vp(v1,v2,av)
       aa=sp(av,av)
       call vp(v3,v2,bv)
       ba=sp(bv,bv)
       if(aa.gt.1.0d-4.and.ba.gt.1.0d-4)then
        rr=1.0d0/dsqrt(aa*ba)
        ct=sp(av,bv)*rr
        sum_t=sum_t+k1d(b)*(1.0d0-ct)
     1  +k2d(b)*(1.0d0-(2.0d0*ct*ct-1.0d0))
     2  +k3d(b)*(1.0d0-(4.0d0*ct*ct*ct-3.0d0*ct))
        if(ic.gt.0)then 
c        {c1,c2,c3 -derivative with respect,v1,v2,v3}
         v23=sp(v2,v3)
         v12=sp(v2,v1)
	 v13=sp(v1,v3)
         v1q=sp(v1,v1)
	 v2q=sp(v2,v2)
	 v3q=sp(v3,v3)
         do 26 a=0,2 
         c1=(v2q*v3(a+1)-v2(a+1)*v23)*rr-ct/aa*(v2q*v1(a+1)-v12*v2(a+1))
         c3=(v2q*v1(a+1)-v2(a+1)*v12)*rr-ct/ba*(v2q*v3(a+1)-v23*v2(a+1))
         c2=-(v3(a+1)*v12+v1(a+1)*v23-2.0d0*v2(a+1)*v13)*rr-
     2   ct/aa*(v1q*v2(a+1)-v12*v1(a+1))-ct/ba*(v3q*v2(a+1)-v23*v3(a+1))
c  {tem - derivative of ct with respect,x_a,l
c  i tem=c1
c  l tem=c3
c  j tem=-c1-c2
c  k tem=-c3+c2}
         ff=k1d(b)+4.0d0*ct*k2d(b)+k3d(b)*(12.0d0*ct*ct-3.0d0)
         tem=c1
         g(ii+a)=g(ii+a)-ff*tem
         tem=c3
         g(ll+a)=g(ll+a)-ff*tem
         tem=-c1-c2
         g(jj+a)=g(jj+a)-ff*tem
         tem=-c3+c2
26       g(kk+a)=g(kk+a)-ff*tem
        endif
       endif
      endif
25    continue

c{out of plane}
      do 27 b=1,np 
      i=o1(b)
      j=o2(b)
      k=o3(b)
      l=o4(b)
      if(i.gt.nat2st.or.j.gt.nat2st.or.k.gt.nat2st.or.l.gt.nat2st.or.
     1i.lt.nat1st.or.j.lt.nat1st.or.k.lt.nat1st.or.l.lt.nat1st)then
       ii=i+i+i-2
       jj=j+j+j-2
       kk=k+k+k-2
       ll=l+l+l-2
       xi=r(ii)
       yi=r(ii+1)
       zi=r(ii+2)
       xj=r(jj)
       yj=r(jj+1)
       zj=r(jj+2)
       xk=r(kk)
       yk=r(kk+1)
       zk=r(kk+2)
       xl=r(ll)
       yl=r(ll+1)
       zl=r(ll+2)
       v1(1)=xj-xi
       v2(1)=xk-xi
       v3(1)=xl-xi
       v1(2)=yj-yi
       v2(2)=yk-yi
       v3(2)=yl-yi
       v1(3)=zj-zi
       v2(3)=zk-zi
       v3(3)=zl-zi
       call vp(v1,v2,av)
       if(sp(av,av).gt.1.0d-4.and.sp(v3,v3).gt.1.0d-4)then
        oop=sp(av,v3)/dsqrt(sp(av,av))/dsqrt(sp(v3,v3))
        if(i.gt.nat2st.or.j.gt.nat2st.or.k.gt.nat2st.or.l.gt.nat2st)
     1  sum_o=sum_o+oo(b)*oop**2
        if(ic.gt.0)then 
         call vp(v2,v3,bv)
         call vp(v3,v1,cv)
         aa=sp(av,av)
         v3q=sp(v3,v3)
	 if(aa.gt.1.0d-4.and.v3q.gt.1.0d-4)then
          rr=1.0d0/dsqrt(aa*v3q)
          chi=sp(av,v3)*rr
          do 28 a=0,2 
          c3=av(a+1)*rr-chi/v3q*v3(a+1)
          c1=bv(a+1)*rr-chi/aa*(sp(v2,v2)*v1(a+1)-sp(v1,v2)*v2(a+1))
          c2=cv(a+1)*rr-chi/aa*(sp(v1,v1)*v2(a+1)-sp(v1,v2)*v1(a+1))
          g(ii+a)=g(ii+a)+2.0d0*oo(b)*chi*(-c1-c2-c3)
          g(jj+a)=g(jj+a)+2.0d0*oo(b)*chi*c1
          g(kk+a)=g(kk+a)+2.0d0*oo(b)*chi*c2
28        g(ll+a)=g(ll+a)+2.0d0*oo(b)*chi*c3
         endif 
        endif 
       endif 
      endif 
27    continue

      etot=sum_pol+sum_es+sum_vdw+sum_b+sum_a+sum_t+sum_o+sum_mag

      gnorm=z0
      if(ic.eq.2.or.ic.eq.3)then
       do 29 l=1,nat
       if (l.lt.nat1st.or.l.gt.nat2st)then
        do 30 i=1,3 
30      gnorm=gnorm+g(3*(l-1)+i)**2
       endif
29     continue 
       gnorm=dsqrt(gnorm)
      endif

      if(ic.eq.2)write(6,*)'Initial Energy '
      if(ic.eq.3)write(6,*)'Final Energy '
      if(ic.gt.1)
     1write(6,600)nstep,sum_es,sum_vdw,sum_b,sum_a,sum_t,sum_o,sum_mag,
     1sum_pol,etot,gnorm
600   format(
     1'Step          ',I5,/,
     2'electrostatic ',f20.3,/,
     3'van der Waals ',f20.3,/,
     4'bonds         ',f20.3,/,
     5'angles        ',f20.3,/,
     6'torsions      ',f20.3,/,
     7'planes        ',f20.3,/,
     8'magnetic      ',f20.3,/,
     8'polarization  ',f20.3,/,
     9'              --------------------',/,
     a'total         ',f20.3,' kcal/mol',/,
     b'|grad|        ',f20.3,/)
      return
      end

      function func(a)
      include 'common.i'
      real*8 func ,a
      integer*4 i
      do 1 i=1  ,3*(nat1st-1)
1     r(i)=x0(i)-a*h0(i)
      do 2 i=3*nat2st+1,3*nat 
2     r(i)=x0(i)-a*h0(i)
      call fixbox
      call energy(-1)
      func=etot
      return
      end

      subroutine mnbrak(ax,bx,cx,fa,fb,fc)
      real*8 ax,bx,cx,fa,fb,fc,dum,fu,q,r,u,ulim,TINY,GOLD,func
      integer*4 GLIMIT
      parameter( GOLD=1.618034d0,GLIMIT=100,TINY=1.0d-20)
c     Given a function func, and given distinct initial points ax and bx
c     this routine searches in the downhill direction (defined by the
c     function as evaluated at the initial points)and returns new points
c     ax, bx, cx that bracket a minimum of the function.Alsoreturned are
c     the function values at the three points, fa, fb,and fc.
c     Parameters:GOLD is the default ratio by which successive intervals
c     are magnified  GLIMIT is the maximum magnification allowed for
c     a parabolic-fit step. 
      fa=func(ax) 
      fb=func(bx) 
c     {Switch roles of a and b so that we can go downhill in the
c     direction from a,b. }
      if(fb.gt.fa)then
       dum=ax 
       ax=bx 
       bx=dum 
       dum=fb 
       fb=fa 
       fa=dum 
      endif
      cx=bx+GOLD*(bx-ax) 
      fc=func(cx) 
      
1     if(fb.ge.fc)then
       r=(bx-ax)*(fb-fc) 
       q=(bx-cx)*(fb-fa) 
       u=bx-((bx-cx)*q-(bx-ax)* r)/(2.0d0*sign(max(abs(q-r),TINY),q-r))  
       ulim=bx+GLIMIT*(cx-bx) 
       if((bx-u)*(u-cx).gt.0.0d0)then 
        fu=func(u) 
        if(fu.lt.fc)then 
         ax=bx 
         fa=fb 
         bx=u 
         fb=fu 
	 return
	else 
	 if(fu.gt.fb)then 
          cx=u 
          fc=fu 
          return
	 endif
	endif
        u=cx+GOLD*(cx-bx) 
        fu=func(u) 
       else 
        if((cx-u)*(u-ulim).gt.0.0d0)then 
         fu=func(u) 
         if(fu.lt.fc)then 
          bx=cx 
          cx=u 
          u=cx+GOLD*(cx-bx) 
          fb=fc 
          fc=fu 
          fu=func(u) 
         endif
        else 
	 if((u-ulim)*(ulim-cx).ge.0.0d0)then 
          u=ulim 
          fu=func(u) 
         else 
          u=cx+GOLD*(cx-bx) 
          fu=func(u) 
         endif
        endif
       endif
       ax=bx 
       bx=cx 
       cx=u 
       fa=fb 
       fb=fc 
       fc=fu 
       goto 1 
      endif
      return
      END 

      FUNCTION golden(ax,bx,cx,tol,xmin)
      real*8 ax,bx,cx,tol,xmin,golden,R,C,f1,f2,x0,x1,x2,x3,func
      parameter (R=0.61803399d0,C=1.0d0-R)
      x0=ax 
      x3=cx 
      if(abs(cx-bx).gt.abs(bx -ax))then 
       x1=bx 
       x2=bx+C*(cx-bx) 
      else 
       x2=bx 
       x1=bx-C*(bx-ax) 
      endif
      f1=func(x1) 
      f2=func(x2) 
1     if(abs(x3-x0).gt.tol*(abs(x1)+abs(x2)))then 
       if(f2.lt.f1)then 
        x0=x1 
        x1=x2 
        x2=R*x1+C*x3 
        f1=f2 
        f2=func(x2) 
       else 
        x3=x2 
        x2=x1 
        x1=R*x2+C*x0 
        f2=f1 
        f1=func(x1) 
       endif
       goto 1
      endif
      if(f1.lt.f2)then 
       golden=f1 
       xmin=x1 
      else 
       golden=f2 
       xmin=x2 
      endif
      return
      end

      subroutine minimini
      include 'common.i'
      include 'option.i'
      integer*8 ii,i,l
      real*8 dh,h,gnorm1,e00,gmax,gnorm0,ax,dx,cx,fa,fb,fc,
     1golden
      logical lex
      nstep=0
      do 1 l=1,3*nat 
1     g(l)=z0
      call energy(2)
      gnorm0=0.0d0
      gmax=abs(g(1))
      do 2 l=1,nat 
      do 2 i=1,3 
      ii=3*(l-1)+i
      x0(ii)=r(ii)
      h0(ii)=g(ii)
      if(l.lt.nat1st.or.l.gt.nat2st)then
       gnorm0=gnorm0+g(ii)**2
       if(dabs(g(ii)).gt.gmax)gmax=dabs(g(ii))
      endif
2     continue
      gnorm0=dsqrt(gnorm0)
      if(gnorm0.lt.glim)then
       write(6,*)'Initial gradient too small - minimized'
       goto 300
      endif

  100 nstep=nstep+1
      e00=etot
      ax=0.0d0
      dh=maxstep/gmax
      call mnbrak(ax,dh,h,fa,fb,fc)
      dx=dh
      cx=h
      etot=golden(ax,dx,cx,xtol,h)
      do 3 i=1,3*(nat1st-1)   
3     r(i)=x0(i)-sign(min(maxstep,abs(h*h0(i))),h*h0(i))
      do 4 i=3*nat2st+1,3*nat 
4     r(i)=x0(i)-sign(min(maxstep,abs(h*h0(i))),h*h0(i))
      call fixbox

      if(etot.gt.e00)call report('Lin. search not successful')

      call energy(1)
      gnorm1=z0
      gmax=dabs(g(1))
      do 5 l=1,nat
      if (l.lt.nat1st.or.l.gt.nat2st)then
       do 6 i=1,3 
       gnorm1=gnorm1+g(3*(l-1)+i)**2
6      if(abs(g(3*(l-1)+i)).gt.gmax) gmax= abs(g(3*(l-1)+i))
      endif
5     continue
      do 7 i=1,3*nat 
7     x0(i)=r(i)
      gnorm1=dsqrt(gnorm1)
      do 8 ii=1,3*nat 
8     h0(ii)=g(ii)+(gnorm1/gnorm0)**2*h0(ii)
      if(wrmin)write(6,5000)nstep,etot,gnorm1
5000  format(I6,'. step: Energy = ',f15.6,'  Gradient = ',f15.6)
      if(wrmin)call writex(nstep,'MINI.X')

      if (abs(e00-etot).lt.elim.and.gnorm1.lt.glim) then
       write(6,*)'Optimization converged'
       goto 300
      endif
      if (gnorm1.lt.glim) then
       write(6,*)'Optimization converged - small grad'
       goto 300
      endif
      if(nstep.gt.maxnum)then
       write(6,*)'Too many steps'
       goto 300
      endif
      inquire(file='STOP',exist=lex)
      if(lex)then
       write(6,*)'Optimization interrupted'
       goto 300
      endif
      gnorm0=gnorm1
      goto 100

 300  call energy(3)
      return
      end

      subroutine TQL12(N,Z,D,ierr,ICODE) 
      implicit none
      integer*4 N,ierr,ICODE,k,mml,ii,i,l1,j,m,l
      real*8 Z(3,3),D(3),c,s,p,r,g,f,b,h,MACHEP,E(3)
      common/eee/E
c     EPS= 1.0d0 
c  10 EPS= 0.50d0*EPS 
c     TOL1= EPS + 1.0d0 
c     IF(TOL1.gt.1.0d0.AND.TOL1-EPS.eq.1.0d0) goto 10 
c     IF(TOL1-EPS.eq.1.0d0)EPS= EPS + EPS 
c     MACHEP= EPS 
c     for real*8 arithmetic thsi is about 1e-16
      MACHEP=1.0d-14
      IERR= 0 
      IF (N.eq. 1)goto 1001 
      do 1 I= 2,N 
1     E(I-1)= E(I) 
      F= 0.0d0 
      B= 0.0d0 
      E(N)= 0.0d0 
      DO 240 L= 1, N
      J= 0 
      H= MACHEP * (DABS(D(L)) + DABS(E(L))) 
      IF (B .lt. H)  B= H 
      do 2 m=l,n  
2     IF (ABS(E(M)) .le. B)goto 120 
  120 IF (M.eq. L)goto 220 
  130 IF (J.eq. 30)goto 1000 
      J= J + 1 
      L1= L + 1 
      G= D(L) 
      P= (D(L1) - G) / (2.0d0 * E(L)) 
      R= DSQRT(P*P+1.0d0) 
      D(L)= E(L) / (P + SIGN(R,P)) 
      H= G - D(L) 
      do 3 I= L1,N 
3     D(I)= D(I) - H 
      F= F + H 
      P= D(M) 
      C= 1.0d0 
      S= 0.0d0 
      MML= M - L 
      DO 200 II= 1, MML
      I= M - II 
      G= C * E(I) 
      H= C * P  
      IF (ABS(P) .lt. ABS(E(I))) goto 150 
      C= E(I) / P 
      R= sqrt(C*C+1.0d0) 
      E(I+1)= S * P * R 
      S= C / R          
      C= 1.0d0 / R         
      goto 160 
  150 C= P / E(I) 
      R= sqrt(C*C+1.0d0) 
      E(I+1)= S * E(I) * R 
      S= 1.0d0 / R 
      C= C * S   
  160 P= C * D(I) - S * G 
      D(I+1)= H + S * (C * G + S * D(I)) 
      IF (ICODE .ne. 2)  goto 200 
      do K= 1,N 
       H= Z(K,I+1) 
       Z(K,I+1)= S * Z(K,I) + C * H 
       Z(K,I)= C * Z(K,I) - S * H 
      enddo
200   CONTINUE
      E(L)= S * P 
      D(L)= C * P 
      IF (abs(E(L)) .gt. B) goto 130 
  220 D(L)= D(L) + F 
  240 CONTINUE
c{C     :::::::::: ORDER EIGENVALUES AND EIGENVECTORS ::::::::::}
c{!!!!!!!!!! Take care that chirality is not changed !!!!!!!!!!!}
      do ii=2,n 
       I= II - 1 
       K= I 
       P= D(I) 
       do  J= II,N 
        IF( D(J).gt.P) then 
         K= J 
       	 P=  D(J) 
        endif
       enddo
       IF (K.ne.I )then 
        D(K)= D(I) 
        D(I)= P 
        IF( ICODE.eq.2) then
         do J= 1,N 
          P= Z(J,I) 
	  Z(J,I)= Z(J,K) 
	  Z(J,K)= P 
         enddo
        endif
       endif
      enddo
      goto 1001 
 1000 IERR= L 
 1001 return
      end

      subroutine TRED12(N,A,Z,D,IEIG,IERR)
      implicit none
      integer*4 N,IEIG,IERR,i,ii,l,k,j,icode,jp1
      real*8 A(3,3),Z(3,3),D(3),hh,f,g,scale,h,E(3)
      common/eee/E
      IF (IEIG .lt. 0) GOTO 110 
      do 1 i=1,n 
      do 1 j=1,i 
1     Z(I,J) = A(I,J) 
  110 ICODE= ABS(IEIG) 
      IF (N .eq. 1)  goto 320 
      DO 300 II = 2, N
      I = N + 2 - II 
      L = I - 1 
      H = 0.0d0 
      SCALE= 0.0d0 
      IF (L .lt. 2) goto 130 
      do 2 k=1,l 
2     SCALE= SCALE + ABS(Z(I,K)) 
      IF (ABS(SCALE).gt.1.0d-10) goto 140 
  130 E(I)= Z(I,L) 
      goto 290 
  140 do k=1,l 
       F= Z(I,K) / SCALE 
       Z(I,K)= F 
       H= H + F * F 
      enddo
      G= -SIGN(SQRT(H),F) 
      E(I)= SCALE * G 
      H= H - F * G 
      Z(I,L)= F - G 
      F= 0.0d0
      DO 240 J= 1, L
      IF (ICODE.eq. 2) Z(J,I)= Z(I,J) / (SCALE * H) 
      G= 0.0d0 
      do 3 k=1,j 
3     G= G + Z(J,K) * Z(I,K) 
      JP1= J + 1 
      IF (L .lt. JP1)  goto 220 
      do 4 k=jp1,l 
4     G= G + Z(K,J) * Z(I,K) 
  220 E(J)= G / H 
      F= F + E(J) * Z(I,J) 
  240 CONTINUE
      HH= F / (H + H) 
      DO 260 J= 1, L
      F= Z(I,J) 
      G= E(J) - HH * F 
      E(J)= G 
      do 5 k=1,j 
5     Z(J,K)= Z(J,K) - F * E(K) - G * Z(I,K) 
  260 CONTINUE
      do 6 K= 1,L 
6     Z(I,K)= SCALE * Z(I,K) 
  290 D(I)= H 
  300 CONTINUE 
  320 D(1)= 0.0d0 
      E(1)= 0.0d0  
      IF (ICODE .ne. 2) goto 600 
      do 500 I= 1,N 
      L= I - 1 
      IF (ABS(D(I)) .lt. 1.0d-10) goto 380 
      do 360 J= 1,L 
      G= 0.0d0 
      do 7 K= 1,L 
7     G= G + Z(I,K) * Z(K,J) 
      do 8 K= 1,L 
8     Z(K,J)= Z(K,J) - G * Z(K,I) 
  360 CONTINUE 
  380 D(I)= Z(I,I) 
      Z(I,I)= 1 
      IF (L .lt. 1) goto 500 
      do 9 J= 1,L 
      Z(I,J)= 0.0d0 
9     Z(J,I)= 0.0d0
  500 continue
  620 call TQL12(N,Z,D,IERR,ICODE) 
      return
cC     :::::::::: ALTERNATE FINAL LOOP FOR EIGENVALUES ONLY ::::::::::}
  600 do 10 I=1,N 
  10  D(I)= Z(I,I) 
      goto 620 
      END       

      subroutine ORT(AA,nat00,N,N6)
      implicit none
      integer*4 nat00
      real*8 SP,AA(3*nat00,3*nat00)
      integer*4  IC,ICP,J,N6,N
      do 6 IC=1,N6 
      do 4  ICP=1,IC-1 
      SP=0.0d0
      do 3 J=1,N 
3     SP=SP+AA(J,IC)*AA(J,ICP) 
      do 4 J=1,N 
4     AA(J,IC)=AA(J,IC)-SP*AA(J,ICP) 
      SP=0.0d0 
      do 5 J=1,N 
5     SP=SP+AA(J,IC)**2
      IF(SP.gt.1.0d-14)SP=1.0d0/DSQRT(SP) 
      do 6 J=1,N 
6     AA(J,IC)=AA(J,IC)*SP 
      return
      end

      subroutine DOMA(N,nat1,nat2,AA) 
      include 'common.i'
      real*8 C(3,nat00),TEM(3*nat00,3*nat00),S,sum,
     1AA(3*nat00,3*nat00),AMACH
      integer*4 I,ii,j,ICOL,nat1,nat2,N,N6
      AMACH=1.0d-10
      do 1 I=nat1,nat2 
      do 1 II=1,3 
1     C(II,I-nat1+1)=r(3*(I-1)+II) 
      do 2 i=1,N 
      do 2 j=1,N 
2     AA(i,j)=0.0d0
      do i=1,nat2-nat1+1 
       AA(3*I-2,1)= 1.0d0 
       AA(3*I-1,2)= 1.0d0
       AA(3*I  ,3)= 1.0d0
       AA(3*I-2,4)=-C(2,I) 
       AA(3*I-1,4)= C(1,I) 
       AA(3*I-1,5)=-C(3,I) 
       AA(3*I  ,5)= C(2,I) 
       AA(3*I-2,6)= C(3,I) 
       AA(3*I  ,6)=-C(1,I) 
      enddo
      N6=6 
      call ORT(AA,nat00,N,N6)
      ICOL=1 
 5    IF(ICOL.gt.N6) GOTO 8 
      S=0.0d0
      do 9 J=1,N 
9     S=S+AA(J,ICOL)**2
      IF(S.lt.1000.0d0*AMACH)THEN 
       do 10 J=1,N 
10     AA(J,ICOL)=AA(J,N6) 
       N6=N6-1 
       GOTO 5 
      ENDIF
      ICOL=ICOL+1 
      GOTO 5 
8     do I=1,N
       do J=1,N 
        sum=0 
        do 11 II=1,N6 
11      sum=sum+AA(I,II)*AA(J,II) 
        TEM(I,J)=sum 
       enddo
      enddo
      do I=1,N 
       do 12 J=1,N 
12     AA(I,J)=-TEM(I,J) 
       AA(I,I)=AA(I,I)+1.0d0 
      enddo
      return
      end

      subroutine PROJECT
      include 'common.i'
      integer*4 N1,N2,nat1,nat2,N,J,II
      real*8 AA(3*nat00,3*nat00),TEM(3*nat00),sum,V(3*nat0)

      do 5 ii=1,3*nat
5     V(ii)=r(ii)-rmm(ii)

      nat1=1
1     nat2=nat1+nat00-1 
      if(nat2.gt.nat)nat2=nat
      N1=3*(nat1-1)+1 
      N2=3* nat2      
      N=N2-N1+1 
      call DOMA(N,nat1,nat2,AA)
      do 4 J=N1,N2 
      sum=0.0d0 
      do 2 II=N1,N2 
2     sum=sum+AA(J-N1+1,II-N1+1)*V(II) 
4     TEM(J-N1+1)=sum 
      do 3 J=N1,N2 
3     V(J)=TEM(J-N1+1) 
      nat1=nat2+1 
      if( nat2.lt.nat)goto 1 
      
      do 6 ii=1,3*nat
6     r(ii)=rmm(ii)+V(ii)

      return
      end
      
      function frandom(i)
      implicit none
      real*8 frandom
      integer*4 i
c
c     Algorithm AS 183 Appl. Statist. (1982) vol.31, no.2
c
c     Returns a pseudo-random number rectangularly distributed
c     between 0 and 1.   The cycle length is 6.95E+12 (See page 123
c     of Applied Statistics (1984) vol.33), not as claimed in the
c     original article.
c
c     IX, IY and IZ should be set to integer values between 1 and
c     30000 before the first entry.
c
      integer*4 ix, iy, iz
      common /randc/ ix, iy, iz
      if(ix.eq.0)ix=10
      if(iy.eq.0)iy=40
      if(iz.eq.0)iz=80
c
      ix = mod(171 * ix, 30269)
      iy = mod(172 * iy, 30307)
      iz = mod(170 * iz, 30323)
      frandom = mod(dble(ix) / 30269.0d0 + dble(iy) / 30307.0d0 +
     1                        dble(iz) / 30323.0d0, 1.0d0)
      return
      end

      function fekin(r,rmm,mmass,n1,n2,dt,bohr)
c
c     calculates kin energy (in au) from step (r,rm in A) and dt(au)
      implicit none
      real*8 fekin,r(*),rmm(*),mmass(*),sum,dt,bohr
      integer*4 n1,n2,i,ix
      sum=0.0d0
      do 1 i=n1,n2
      do 1 ix=1,3
1     sum=sum+mmass(i)*((r(3*(i-1)+ix)-rmm(3*(i-1)+ix))**2)
      fekin=sum/2.0d0/(2.0d0*dt*bohr)**2
      return
      end

      subroutine ls_rest(ic,r,rm,rmm,idyn,vchdi,vchsi,t,ni,nat)
      real*8 r(*),rm(*),rmm(*),vchdi,vchsi,t,ni
      integer*4 n,i,idyn,ic,nat
      open(33,file='RESTART.INF',form='unformatted')
      if(ic.eq.0)then
       n=3*nat
       write(33)n,(r(i),i=1,n),(rm(i),i=1,n),(rmm(i),i=1,n),
     1 idyn,vchdi,vchsi,t,ni
      else
       read(33)n,(r(i),i=1,n),(rm(i),i=1,n),(rmm(i),i=1,n),
     1 idyn,vchdi,vchsi,t,ni
      endif
      close(33)
      return
      end

      subroutine lpc(shx,shy,shz,rmolix,rmoljx,xb2,rmoliy,rmoljy,yb2,
     1rmoliz,rmoljz,zb2,xbox,ybox,zbox)
c     {Periodic conditions:}
      implicit none
      real*8 shx,shy,shz,rmolix,rmoljx,xb2,rmoliy,rmoljy,yb2,
     1rmoliz,rmoljz,zb2,xbox,ybox,zbox,tol
      parameter (tol=0.01d0)
      shx=0.0d0
      shy=0.0d0
      shz=0.0d0
      if(rmolix-rmoljx.gt.xb2+tol) then
       shx=xbox 
      else
       if(rmoljx-rmolix.gt.xb2+tol)shx=-xbox
      endif
      if(rmoliy-rmoljy.gt.yb2+tol)then
       shy=ybox 
      else
       if(rmoljy-rmoliy.gt.yb2+tol)shy=-ybox
      endif
      if(rmoliz-rmoljz.gt.zb2+tol)then
       shz=zbox 
      else
       if(rmoljz-rmoliz.gt.zb2+tol)shz=-zbox
      endif
      return
      end

      subroutine tvec(nast,ths,r,nat0)
      implicit none
      integer*4 nast,nat0
      real*8 ths(3,3),r(nat0,3),v1x,v1y,v1z,e1x,e1y,e1z,
     1e2x,e2y,e2z,e3x,e3y,e3z,an
      if(nast.lt.3)call report('not enough atoms for tvec')
c     make this fast here so that it can be used later:
      v1x=r(2,1)-r(1,1)
      v1y=r(2,2)-r(1,2)
      v1z=r(2,3)-r(1,3)
      e1x=r(3,1)-r(2,1)
      e1y=r(3,2)-r(2,2)
      e1z=r(3,3)-r(2,3)
      an=dsqrt(e1x**2+e1y**2+e1z**2+1.0d-8)
      e1x=e1x/an
      e1y=e1y/an
      e1z=e1z/an
      e2x=v1y*e1z-v1z*e1y
      e2y=v1z*e1x-v1x*e1z
      e2z=v1x*e1y-v1y*e1x
      an=dsqrt(e2x**2+e2y**2+e2z**2+1.0d-8)
      e2x=e2x/an
      e2y=e2y/an
      e2z=e2z/an
      e3x=e1y*e2z-e1z*e2y
      e3y=e1z*e2x-e1x*e2z
      e3z=e1x*e2y-e1y*e2x
      ths(1,1)=e1x
      ths(1,2)=e2x
      ths(1,3)=e3x
      ths(2,1)=e1y
      ths(2,2)=e2y
      ths(2,3)=e3y
      ths(3,1)=e1z
      ths(3,2)=e2z
      ths(3,3)=e3z
      return
      end
