unit minimize;
   {$J+}
interface
uses unit1;

type real=single;

procedure MinimizeEnergy;
procedure energy(ic:integer);
procedure shake;

implementation

uses dialogs,sysutils,unit2,windows,controls,unit3,math,diagpas;

var nstep:integer;
    fv:textfile;
    nba:array[1..nat0] of integer;
    nbt:array[1..nat0,1..7] of integer;

function sp(v1,v2:vector):real;begin sp:=v1[1]*v2[1]+v1[2]*v2[2]+v1[3]*v2[3];end;

procedure vp(v1,v2:vector;var v3:vector);begin v3[1]:=v1[2]*v2[3]-v1[3]*v2[2];v3[2]:=v1[3]*v2[1]-v1[1]*v2[3];v3[3]:=v1[1]*v2[2]-v1[2]*v2[1];end;

function ArcCosine(number: real): real;
var x: real;
begin
 if number<-1 then number:=-1;
 if number>1 then number:=1;
 if abs(number)<0.00001 then arccosine:=90 else begin
  x:=1-number*number;
  if abs(x)<0.00001 then begin
   if number>0 then arccosine:=0 else arccosine:=180;
  end  else   begin
   x:=(180/pi)*arctan(sqrt(x)/number);
   if x<0 then arccosine:=180+x else arccosine:=x;
  end;
 end;
end;

procedure shake;
const itmax=200;tol=0.01;
var b,ic,it,i,j,ii,jj:integer;
    sum,rr,bb,l,m1m,m2m,dx,dy,dz:real;
procedure  addats0;
begin if(i>nat2st)or(j>nat2st)or(i<nat1st)or(j<nat1st)then begin
 ii:=i+i+i-2;jj:=j+j+j-2;
 x0sh[ii]:=r[ii];x0sh[ii+1]:=r[ii+1];x0sh[ii+2]:=r[ii+2];
 x0sh[jj]:=r[jj];x0sh[jj+1]:=r[jj+1];x0sh[jj+2]:=r[jj+2];
end;end;
procedure shb;
begin if(i>nat2st)or(j>nat2st)or(i<nat1st)or(j<nat1st)then begin
 m1m:=1/mmass[i];m2m:=1/mmass[j];ii:=i+i+i-2;jj:=j+j+j-2;
 dx:=x0sh[ii]-x0sh[jj];dy:=x0sh[ii+1]-x0sh[jj+1];dz:=x0sh[ii+2]-x0sh[jj+2];
 rr:=sqr(dx)+sqr(dy)+sqr(dz);l:=(rr-bb)/2/(m1m+m2m)/rr;
 dx:=dx*l;dy:=dy*l;dz:=dz*l;
 r[ii]:=r[ii]-dx*m1m;r[ii+1]:=r[ii+1]-dy*m1m;r[ii+2]:=r[ii+2]-dz*m1m;
 r[jj]:=r[jj]+dx*m2m;r[jj+1]:=r[jj+1]+dy*m2m;r[jj+2]:=r[jj+2]+dz*m2m;
 if abs(bb-rr)/bb>tol then ic:=ic+1;
 sum:=sum+abs(bb-rr);
end;end;
Begin
it:=0;
repeat it:=it+1;
sum:=0; ic:=0;
if(form3.checkbox13.Checked)then for b:=1 to nb do begin i:=b1[b];j:=b2[b];addats0;end;
if(form3.checkbox14.Checked)then for b:=1 to nt do begin i:=t1[b];j:=t3[b];addats0;end;
if(form3.checkbox13.Checked)then for b:=1 to nb do begin i:=b1[b];j:=b2[b];bb:=sqr(b0[b]);shb;end;
if(form3.checkbox14.Checked)then for b:=1 to nt do begin i:=t1[b];j:=t3[b];bb:=btd[b];shb;end;
until (it>itmax)or(ic=0)or(sum<0.01);
end;


procedure energy(ic:integer); {energy in kcal/mol, gradien in kcal/mol/A}
label sk1,sk2;
const pi180=pi/180;pi1802=pi*pi/180/180;
      cow:real=6;{cutoff vdW}
      coe:real=20;{cutoff C}
      del:real=3;{transitional distance around cutoffs}

var qi,ri3,ri6,rj3,rj6,epsilon,epsi,rst,sum_b,sum_vdw,sum_es,xi,yi,zi,d6,d33,rr,
tem,aa,ba,x,y,z,sum_o,ct,sum_a,v12,v13,v23,st,v1a,v2a,sum_t,t,c1,c2,c3,
v3q,chi,ffr,oop,cc,ccr,ff,v2q,v1q,xb2,yb2,zb2,v1av2a,xx,yy,zz,
xj,yj,rr2,gnorm,zj,xk,yk,zk,xl,yl,zl,rst3,sum,sum_mag,mmas,rij2,rij5,mdotr,
xij,yij,zij,qiqj,fx,fy,fz,mjdotr,midotr,midotmj,tx,ty,tz,ri2,xia,yia,zia,ri2xy,ri2xz,ri2yz,
sumx,sumy,sumz:real;
cv,av,bv,v3,v1,v2,mmagi,mcom,mlocal:vector;
io,kp,m,ll,kk,a,i,j,k,jj,l,ii,b,ix,jx,imol,jmol,ixp,jxp,ia,ierr:integer;
      ts:string;
th,imom:mat3;
dh,bind:vector;
chilocal,chicom:array[1..3,1..3]of real;

begin
sum_es:=0.0;sum_vdw:=0.0;sum_b:=0.0;sum_a:=0.0;sum_t:=0.0;sum_o:=0;sum_mag:=0;
xb2:=xbox/2;yb2:=ybox/2;zb2:=zbox/2;
for i:=1 to 3*nat do g[i]:=0;

{electrostatic and van der Waals}
for i:=1 to nat do begin
 ri3:=r3[i];ri6:=ri3*ri3;epsi:=eps[i];qi:=q[i];
 ii:=i+i+i-2;xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];
 for j:=i+1 to nat do begin if (i>nat2st)or(j>nat2st)or(j<nat1st)or(i<nat1st) then begin
  {check, if i,j bonded or part of an angle}
  for k:=1 to nba[i] do begin  {nba[i] .. number of bonds on atom i}
   if nbt[i,k]=j then goto sk1;{ bond  i ... nbt[i,k]}
   for kp:=1 to nba[nbt[i,k]] do if nbt[nbt[i,k],kp]=j then goto sk1;
  end;

  jj:=j+j+j-2;xj:=r[jj];yj:=r[jj+1];zj:=r[jj+2];qiqj:=qi*q[j];

  {Periodic conditions:}
  if xi-xj>xb2 then xj:=xj+xbox else if xj-xi>xb2 then xj:=xj-xbox;
  if yi-yj>yb2 then yj:=yj+ybox else if yj-yi>yb2 then yj:=yj-ybox;
  if zi-zj>zb2 then zj:=zj+zbox else if zj-zi>zb2 then zj:=zj-zbox;

  xij:=xi-xj;yij:=yi-yj;zij:=zi-zj;rr2:=sqr(xij)+sqr(yij)+sqr(zij)+0.000001;rr:=sqrt(rr2);

  rj3:=r3[j];rj6:=rj3*rj3;
  epsilon:=2*sqrt(epsi*eps[j])*ri3*rj3/(ri6+rj6);
  rst:=0.5*(ri6+rj6);
  rst3:=sqrt(rst);
  d33:=rst3/rr/rr2;d6:=sqr(d33);
  ff:=epsilon*(d33+d33-3)*d6;
  ffr:=-18*epsilon*(d6*d33-d6)/rr;
  sum_vdw:=sum_vdw+ff;
  tem:=ffr/rr;
  if(ic>0)then begin
   g[ii  ]:=g[ii  ]+tem*xij;g[jj  ]:=g[jj  ]-tem*xij;
   g[ii+1]:=g[ii+1]+tem*yij;g[jj+1]:=g[jj+1]-tem*yij;
   g[ii+2]:=g[ii+2]+tem*zij;g[jj+2]:=g[jj+2]-tem*zij;
  end;

  ff:=qiqj/(rr/bohr)*kcal;
  sum_es:=sum_es+ff;
  if(ic>0)then begin
   tem:=-ff/rr2;
   g[ii  ]:=g[ii  ]+tem*xij;g[jj  ]:=g[jj  ]-tem*xij;
   g[ii+1]:=g[ii+1]+tem*yij;g[jj+1]:=g[jj+1]-tem*yij;
   g[ii+2]:=g[ii+2]+tem*zij;g[jj+2]:=g[jj+2]-tem*zij;
  end;

  sk1:

 end;end;{j}
end;{i}

{magnetic forces}
if form1.CheckBox3.checked then begin
 bfieldy:=strtofloat(form3.Edit14.Text)/2.352e5;{magnetic field in au}
 {chiloc - susceptibilities in local coordinate system, mlocal - mag moments}
 {initialize with solvent values:}
 for ix:=1 to 3 do for jx:=1 to 3 do chilocal[ix,jx]:=chism[ix,jx];
 for ix:=1 to 3 do mlocal[ix]:=pmds[ix];
 for imol:=1 to 2*nst+nso+2*nch do begin
  {if not solvent, take the right susc and moment:}
  if((imol<=2*nst)or(imol>2*nst+nso))or form1.CheckBox5.checked then BEGIN
   if imol=2*nst+1     then for ix:=1 to 3 do for jx:=1 to 3 do chilocal[ix,jx]:=chiom[ix,jx];
   if imol=2*nst+1     then for ix:=1 to 3 do mlocal[ix]:=pmdo[ix];
   if imol=2*nst+nso+1 then for ix:=1 to 3 do for jx:=1 to 3 do chilocal[ix,jx]:=chicm[ix,jx];
   if imol=2*nst+nso+1 then for ix:=1 to 3 do mlocal[ix]:=pmdc[ix];
  {molecular mass}
   mmas:=0;for ia:=ias[imol] to iae[imol] do mmas:=mmas+mmass[ia];
   {molecular masses positions (gravity centers)}
   mmas:=0;sumx:=0;sumy:=0;sumz:=0;
   for ia:=ias[imol] to iae[imol] do begin
    mmas:=mmas+mmass[ia];
    sumx:=sumx+mmass[ia]*r[3*(ia-1)+1];
    sumy:=sumy+mmass[ia]*r[3*(ia-1)+2];
    sumz:=sumz+mmass[ia]*r[3*(ia-1)+3];
   end;
   rmol[imol,1]:=sumx/mmas;rmol[imol,2]:=sumy/mmas;rmol[imol,3]:=sumz/mmas;
  {get molecular moments of inertia}
   for ix:=1 to 3 do for jx:=1 to 3 do begin
    sum:=0;
    for ia:=ias[imol] to iae[imol] do sum:=sum+mmass[ia]*(r[3*(ia-1)+ix]-rmol[imol,ix])*(r[3*(ia-1)+jx]-rmol[imol,jx]);
    imom[ix,jx]:=sum;
   end;
   {diagonalize in order to get local coordinate system; th[common, diag local]}
   TRED12(3,imom,th,dh,2,ierr);if ierr<>0 then showmessage('diagonalization error in minimize');
   {chi in common origin system}
   for ix:=1 to 3 do for jx:=1 to 3 do begin
    sum:=0;for ixp:=1 to 3 do for jxp:=1 to 3 do sum:=sum+chilocal[ixp,jxp]*th[ix,ixp]*th[jx,jxp];chicom[ix,jx]:=sum;
   end;
   {premanent magnetic moments in common origin system}
   for ix:=1 to 3 do begin
    sum:=0;for ixp:=1 to 3 do sum:=sum+mlocal[ixp]*th[ix,ixp];mcom[ix]:=sum;
   end;
   {magnetic moments for molecules m=m0+chi*B0}
   for ix:=1 to 3 do mmag[imol,ix]:=mcom[ix]+chicom[ix,2]*Bfieldy;
  END;
 end;

 for imol:=1 to 2*nst+nso+2*nch do begin
  if((imol<=2*nst)or(imol>2*nst+nso))or form1.CheckBox5.checked then BEGIN
   {magnetic moments for molecules perturbed   m'=chi*(B0+u0/4/pi/r^3*(3 m.n n - m))}
   xi:=rmol[imol,1];yi:=rmol[imol,2];zi:=rmol[imol,3];
   for ix:=1 to 3 do bind[ix]:=0;{secondary magnetic field from induced momenta}
   if(ic>0)then begin fx:=0;fy:=0;fz:=0;end;
   for jmol:=1 to 2*nst+nso+2*nch do begin
    if((jmol<=2*nst)or(jmol>2*nst+nso))or form1.CheckBox5.checked then BEGIN
     if jmol<>imol then begin
      xj:=rmol[jmol,1];yj:=rmol[jmol,2];zj:=rmol[jmol,3];{coordinates in A, rest in au}
      {take care about periodic conditions:}
      if xi-xj>xb2 then xj:=xj+xbox else if xj-xi>xb2 then xj:=xj-xbox;
      if yi-yj>yb2 then yj:=yj+ybox else if yj-yi>yb2 then yj:=yj-ybox;
      if zi-zj>zb2 then zj:=zj+zbox else if zj-zi>zb2 then zj:=zj-zbox;
      xij:=xi-xj;yij:=yi-yj;zij:=zi-zj;
      rij2:=sqr(xij)+sqr(yij)+sqr(zij);
      rij5:=sqrt(rij2)*sqr(rij2);
      mjdotr:=xij*mmag[jmol,1]+yij*mmag[jmol,2]+zij*mmag[jmol,3];
      bind[1]:=bind[1]+(3*mjdotr*xij-rij2*mmag[jmol,1])/rij5;
      bind[2]:=bind[2]+(3*mjdotr*yij-rij2*mmag[jmol,2])/rij5;
      bind[3]:=bind[3]+(3*mjdotr*zij-rij2*mmag[jmol,3])/rij5;

      if(ic>0)then begin {also gradient kcal/mol/A}
       midotr :=xij*mmagi[1]+yij*mmagi[2]+zij*mmagi[3];
       midotmj:=mmag[jmol,1]*mmagi[1]+mmag[jmol,2]*mmagi[2]+mmag[jmol,3]*mmagi[3];
       {force acting on the molecule imol due to the magnetic field inhomogenity}
       for ix:=1 to 3 do begin
        fx:=fx+(3*midotr*mmag[jmol,1]+3*mjdotr*mmagi[1]-2*xij*midotmj)/rij5
                         -5*(3*mjdotr*midotr-rij2*midotmj)*xij/rij5/rij2;
        fy:=fy+(3*midotr*mmag[jmol,2]+3*mjdotr*mmagi[2]-2*yij*midotmj)/rij5
                         -5*(3*mjdotr*midotr-rij2*midotmj)*yij/rij5/rij2;
        fz:=fz+(3*midotr*mmag[jmol,3]+3*mjdotr*mmagi[3]-2*zij*midotmj)/rij5
                         -5*(3*mjdotr*midotr-rij2*midotmj)*zij/rij5/rij2;
       end;
      end;

     end;
    END;
   end;

   for ix:=1 to 3 do bind[ix]:=bind[ix]*7.881e-6;{to au, coordinates in A, mag moments in au}
   for ix:=1 to 3 do mmagi[ix]:=mmag[imol,ix];
   for ix:=1 to 3 do for ixp:=1 to 3 do mmagi[ix]:=mmagi[ix]+chicom[ix,ixp]*bind[ixp];
   sum_mag:=sum_mag-mmagi[1]*bind[1]-mmagi[2]*(bind[2]+Bfieldy)-mmagi[3]*bind[3];

   if(ic>0)then begin {also gradient kcal/mol/A}
    fx:=7.881e-6*fx*627.5/(iae[imol]-ias[imol]+1);{distribute over all atoms}
    fy:=7.881e-6*fy*627.5/(iae[imol]-ias[imol]+1);
    fz:=7.881e-6*fz*627.5/(iae[imol]-ias[imol]+1);
    for ia:=ias[imol] to iae[imol] do begin ii:=3*(ia-1);
     g[ii+1]:=g[ii+1]+fx;
     g[ii+2]:=g[ii+2]+fy;
     g[ii+3]:=g[ii+3]+fz;
    end;
    {torsional force:}
    tx:=mmagi[2]*bind[3]-mmagi[3]*(bind[2]+Bfieldy);tx:=tx/(iae[imol]-ias[imol]+1)*7.881e-6*627.5;
    ty:=mmagi[3]*bind[1]-mmagi[1]*bind[3];ty:=ty/(iae[imol]-ias[imol]+1)*7.881e-6*627.5;
    tz:=mmagi[1]*(bind[2]+Bfieldy)-mmagi[2]*bind[1];tz:=tz/(iae[imol]-ias[imol]+1)*7.881e-6*627.5;
    for ia:=ias[imol] to iae[imol] do begin ii:=3*(ia-1);
     xia:=r[ii+1]-rmol[imol,1];yia:=r[ii+2]-rmol[imol,2];zia:=r[ii+3]-rmol[imol,3];
     ri2xy:=sqr(xia)+sqr(yia);
     ri2xz:=sqr(xia)+sqr(zia);
     ri2yz:=sqr(yia)+sqr(zia);
     if(ri2>1e-4)then begin
      fx:=             +ty*zia/ri2xz-tz*yia/ri2xy;
      fy:=-tx*zia/ri2yz             +tz*xia/ri2xy;
      fz:= tx*yia/ri2yz-ty*xia/ri2xz;
      g[ii+1]:=g[ii+1]+fx;
      g[ii+2]:=g[ii+2]+fy;
      g[ii+3]:=g[ii+3]+fz;
     end;
    end;
   end;

  END;
 end;
 sum_mag:=sum_mag*kcal;
end;

{bonds}
{Periodic conditions do not need to be considered since whole molecules are always in box}
IF(not(form3.CheckBox13.Checked))THEN BEGIN
for b:=1 to nb do begin i:=b1[b];j:=b2[b];if(i>nat2st)or(j>nat2st)or(i<nat1st)or(j<nat1st)then begin
 ii:=i+i+i-2;jj:=j+j+j-2;
 xij:=r[ii]-r[jj];yij:=r[ii+1]-r[jj+1];zij:=r[ii+2]-r[jj+2];
 rr:=sqrt(sqr(xij)+sqr(yij)+sqr(zij));
 sum_b:=sum_b+k0[b]*sqr(rr-b0[b]);
 if(ic>0)then begin {also gradient}
  ffr:=2*k0[b]*(rr-b0[b])/rr; {actually ffr/rr}
  g[ii  ]:=g[ii  ]+ffr*xij;g[jj  ]:=g[jj  ]-ffr*xij;
  g[ii+1]:=g[ii+1]+ffr*yij;g[jj+1]:=g[jj+1]-ffr*yij;
  g[ii+2]:=g[ii+2]+ffr*zij;g[jj+2]:=g[jj+2]-ffr*zij;
 end;
end;end;
END;

{bond angles}
{Periodic conditions do not need to be considered since whole molecules always in box}
IF(not(form3.CheckBox14.Checked))THEN BEGIN
for b:=1 to nt do begin i:=t1[b];j:=t2[b];k:=t3[b];if(i>nat2st)or(j>nat2st)or(k>nat2st)or(i<nat1st)or(j<nat1st)or(k<nat1st) then begin
 ii:=i+i+i-2;jj:=j+j+j-2;kk:=k+k+k-2;
 xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];xj:=r[jj];yj:=r[jj+1];zj:=r[jj+2];xk:=r[kk];yk:=r[kk+1];zk:=r[kk+2];
 v1[1]:=xi-xj;v2[1]:=xk-xj;v1[2]:=yi-yj;v2[2]:=yk-yj;v1[3]:=zi-zj;v2[3]:=zk-zj;
 v1q:=sqrt(sp(v1,v1));v2q:=sqrt(sp(v2,v2));
 if v1q*v2q>1e-10 then v1av2a:=1/(v1q*v2q) else v1av2a:=1;
 ct:=sp(v1,v2)*v1av2a;
 tem:= arccosine(ct)-bt[b];
 sum_a:=sum_a+pi1802*kt[b]*sqr(tem);
 if(ic>0)then begin {also gradient}
  st:=-1/sqrt(1.0001-sqr(ct));
  t:=2*kt[b]*pi180*tem*st;
  for a:=0 to 2 do begin
   c1:=(v2[a+1]*v1av2a-ct/v1q*v1[a+1])*t;
   c2:=(v1[a+1]*v1av2a-ct/v2q*v2[a+1])*t;
   g[ii+a]:=g[ii+a]+c1;
   g[jj+a]:=g[jj+a]-c1-c2;
   g[kk+a]:=g[kk+a]+c2;
  end;
 end;
end;end;
END;

{torsion angles}
{Periodic conditions do not need to be considered since whole molecules always in box}
for b:=1 to nd do begin i:=d1[b];j:=d2[b];k:=d3[b];l:=d4[b];if(i>nat2st)or(j>nat2st)or(k>nat2st)or(l>nat2st)or(i<nat1st)or(j<nat1st)or(k<nat1st)or(l<nat1st) then begin
 ii:=i+i+i-2;jj:=j+j+j-2;kk:=k+k+k-2;ll:=l+l+l-2;
 xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];xj:=r[jj];yj:=r[jj+1];zj:=r[jj+2];xk:=r[kk];yk:=r[kk+1];zk:=r[kk+2];xl:=r[ll];yl:=r[ll+1];zl:=r[ll+2];
 v1[1]:=xi-xj;v2[1]:=xk-xj;v3[1]:=xl-xk;v1[2]:=yi-yj;v2[2]:=yk-yj;v3[2]:=yl-yk;v1[3]:=zi-zj;v2[3]:=zk-zj;v3[3]:=zl-zk;
 vp(v1,v2,av);aa:=sp(av,av);vp(v3,v2,bv);ba:=sp(bv,bv);rr:=1/sqrt(aa*ba);
 ct:=sp(av,bv)*rr;
 sum_t:=sum_t+k1d[b]*(1-ct)
             +k2d[b]*(1-(2*ct*ct-1))
             +k3d[b]*(1-(4*ct*ct*ct-3*ct));
 if(ic>0)then begin {also gradient}
  {c1,c2,c3 -derivative with respect to v1,v2,v3}
  v23:=sp(v2,v3);v12:=sp(v2,v1);v13:=sp(v1,v3);
  v1q:=sp(v1,v1);v2q:=sp(v2,v2);v3q:=sp(v3,v3);
  for a:=0 to 2 do begin
   c1:=-(v2[a+1]*v23-v2q*v3[a+1])*rr-ct/aa*(v2q*v1[a+1]-v12*v2[a+1]);
   c2:=-(v3[a+1]*v12+v1[a+1]*v23-2*v2[a+1]*v13)*rr-ct/aa*(v1q*v2[a+1]-v12*v1[a+1])
                                            -ct/ba*(v3q*v2[a+1]-v23*v3[a+1]);
   c3:=-(v2[a+1]*v12-v2q*v1[a+1])*rr-ct/ba*(v2q*v3[a+1]-v23*v2[a+1]);
   {tem - derivative of ct with respect to x_a,l
   i tem=c1
   l tem=c3
   j tem=-c1-c2
   k tem=-c3+c2}
   tem:=c1;    g[ii+a]:=g[ii+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
   tem:=c3;    g[ll+a]:=g[ll+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
   tem:=-c1-c2;g[jj+a]:=g[jj+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
   tem:=-c3+c2;g[kk+a]:=g[kk+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
  end;
 end;
end;end;

{out of plane}
{Periodic conditions do not need to be considered since whole molecules always in box}
for b:=1 to np do begin i:=o1[b];j:=o2[b];k:=o3[b];l:=o4[b];if(i>nat2st)or(j>nat2st)or(k>nat2st)or(l>nat2st)or(i<nat1st)or(j<nat1st)or(k<nat1st)or(l<nat1st) then begin
 ii:=i+i+i-2;jj:=j+j+j-2;kk:=k+k+k-2;ll:=l+l+l-2;
 xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];xj:=r[jj];yj:=r[jj+1];zj:=r[jj+2];xk:=r[kk];yk:=r[kk+1];zk:=r[kk+2];xl:=r[ll];yl:=r[ll+1];zl:=r[ll+2];
 v1[1]:=xj-xi;v2[1]:=xk-xi;v3[1]:=xl-xi;v1[2]:=yj-yi;v2[2]:=yk-yi;v3[2]:=yl-yi;v1[3]:=zj-zi;v2[3]:=zk-zi;v3[3]:=zl-zi;
 vp(v1,v2,av);oop:=sp(av,v3)/sqrt(sp(av,av))/sqrt(sp(v3,v3));
 if(i>nat2st)or(j>nat2st)or(k>nat2st)or(l>nat2st) then sum_o:=sum_o+oo[b]*sqr(oop);
 if(ic>0)then begin {also gradient}
  vp(v2,v3,bv);vp(v3,v1,cv);aa:=sp(av,av);v3q:=sp(v3,v3);
  rr:=1/sqrt(aa*v3q);
  chi:=sp(av,v3)*rr;
  for a:=0 to 2 do begin
   c3:=av[a+1]*rr-chi/v3q*v3[a+1];
   c1:=bv[a+1]*rr-chi/aa*(sp(v2,v2)*v1[a+1]-sp(v1,v2)*v2[a+1]);
   c2:=cv[a+1]*rr-chi/aa*(sp(v1,v1)*v2[a+1]-sp(v1,v2)*v1[a+1]);
   g[ii+a]:=g[ii+a]+2*oo[b]*chi*(-c1-c2-c3);
   g[jj+a]:=g[jj+a]+2*oo[b]*chi*(c1);
   g[kk+a]:=g[kk+a]+2*oo[b]*chi*(c2);
   g[ll+a]:=g[ll+a]+2*oo[b]*chi*(c3);
  end;
 end;
end;end;

etot:=sum_es+sum_vdw+sum_b+sum_a+sum_t+sum_o+sum_mag;

gnorm:=0;
if(ic=2)then begin {also gradient}
 for l:=1 to nat do begin
  if(form3.CheckBox2.Checked) then writeln(fv,l:4,g[3*(l-1)+1]:15:6,g[3*(l-1)+2]:15:6,g[3*(l-1)+3]:15:6,r[3*(l-1)+1]:12:6,   r[3*(l-1)+2]:12:6,   r[3*(l--1)+3]:12:6);
  if (l<nat1st)or(l>nat2st)then for i:=1 to 3 do gnorm:=gnorm+sqr(g[3*(l-1)+i]);
 end;
 if(form3.CheckBox2.Checked) then writeln(fv);
 gnorm:=sqrt(gnorm);
end;
if ic=2 then ts:=        'Initial Energy '+endline else ts:='Final Energy '+endline;
ts:=ts+      'Step          '+inttostr(nstep)+':'+endline+
             'electrostatic '+floattostrf(sum_es ,fffixed,20,3)+endline+
             'van der Waals '+floattostrf(sum_vdw,fffixed,20,3)+endline+
             'bonds         '+floattostrf(sum_b  ,fffixed,20,3)+endline+
             'angles        '+floattostrf(sum_a  ,fffixed,20,3)+endline+
             'torsions      '+floattostrf(sum_t  ,fffixed,20,3)+endline+
             'planes        '+floattostrf(sum_o  ,fffixed,20,3)+endline+
             'magnetic      '+floattostrf(sum_mag,fffixed,20,3)+endline+
             '              '+'--------------------'+endline+
             'total         '+floattostrf(etot   ,fffixed,20,3)+' kcal/mol'+endline+
             '|grad|        '+floattostrf(gnorm   ,fffixed,20,3)+'.';
if ic>1 then showmessage(ts);
end;

function func(a:real):real;
var i:integer;
begin
  for i:=1   to 3*(nat1st-1) do r[i]:=x0[i]-a*h0[i];
  for i:=3*nat2st+1 to 3*nat do r[i]:=x0[i]-a*h0[i];
  if(form3.checkbox13.Checked or form3.checkbox14.Checked)then shake;
  fixbox;
  energy(-1);
  func:=etot;
end;

 function fsign(a,b:real):real;{fortran transfer sign funtion}
 begin
  fsign:=abs(a)*sign(b);
 end;

      procedure mnbrak(var ax,bx,cx,fa,fb,fc:real);
      const GOLD=1.618034;GLIMIT=100;TINY=1.e-20;
      label l1;
      var dum,fu,q,r,u,ulim:real;
      {Given a function func, and given distinct initial points ax and bx,
      this routine searches in the downhill direction (defined by the
      function as evaluated at the initial points) and returns new points
      ax, bx, cx that bracket a minimum of the function. Also returned are
      the function values at the three points, fa, fb,and fc.
      Parameters: GOLD is the default ratio by which successive intervals
      are magnified; GLIMIT is the maximum magnification allowed for
      a parabolic-fit step. }
      BEGIN
      fa:=func(ax);
      fb:=func(bx);
      {Switch roles of a and b so that we can go downhill in the
      direction from a to b. }
      if(fb>fa)then begin
       dum:=ax;
       ax:=bx;
       bx:=dum;
       dum:=fb;
       fb:=fa;
       fa:=dum;
      end;
      cx:=bx+GOLD*(bx-ax);
      fc:=func(cx);
      l1:
      if(fb>=fc)then begin
       r:=(bx-ax)*(fb-fc);
       q:=(bx-cx)*(fb-fa);
       u:=bx-((bx-cx)*q-(bx-ax)* r)/(2.*fsign(max(abs(q-r),TINY),q-r)) ;
       ulim:=bx+GLIMIT*(cx-bx);
       if((bx-u)*(u-cx)>0)then begin
        fu:=func(u);
        if(fu<fc)then begin
         ax:=bx;
         fa:=fb;
         bx:=u;
         fb:=fu;
	 exit;
	end else begin
	 if(fu>fb)then begin
          cx:=u;
          fc:=fu;
          exit;
	 end;
	end;
        u:=cx+GOLD*(cx-bx);
        fu:=func(u);
       end else begin
        if((cx-u)*(u-ulim)>0)then begin
         fu:=func(u);
         if(fu<fc)then begin
          bx:=cx;
          cx:=u;
          u:=cx+GOLD*(cx-bx);
          fb:=fc;
          fc:=fu;
          fu:=func(u);
         end;
        end else begin
	 if((u-ulim)*(ulim-cx)>=0)then begin
          u:=ulim;
          fu:=func(u);
         end else begin
          u:=cx+GOLD*(cx-bx);
          fu:=func(u);
         end;
        end;
       end;
       ax:=bx;
       bx:=cx;
       cx:=u;
       fa:=fb;
       fb:=fc;
       fc:=fu;
       goto l1;
      end;
      END;

      FUNCTION golden(var ax,bx,cx,tol,xmin:real):real;
      label l1;
      const R=0.61803399;C=1-R;
      var f1,f2,x0,x1,x2,x3:real;
      begin
      x0:=ax;
      x3:=cx;
      if(abs(cx-bx)>abs(bx -ax))then begin
       x1:=bx;
       x2:=bx+C*(cx-bx);
      end else begin
       x2:=bx;
       x1:=bx-C*(bx-ax);
      end;
      f1:=func(x1);
      f2:=func(x2);
      l1:
      if(abs(x3-x0)>tol*(abs(x1)+abs(x2)))then begin
       if(f2<f1)then begin
        x0:=x1;
        x1:=x2;
        x2:=R*x1+C*x3;
        f1:=f2;
        f2:=func(x2);
       end else begin
        x3:=x2;
        x2:=x1;
        x1:=R*x2+C*x0;
        f2:=f1;
        f1:=func(x1);
       end;
       goto l1;
      end;
      if(f1<f2)then begin
       golden:=f1;
       xmin:=x1;
      end else begin
       golden:=f2;
       xmin:=x2;
      end;
      exit;
      END;


procedure minimini;
{$J+}
label sk1,sk2,sk3,sk4;
const elim:real=0.000001;glim:real=0.01;
      maxstep:real=0.35;{A}
      nlimlin:integer=30;
var ii,i,l:integer;
    dh,h,gnorm1,e00,gmax,gnorm0,ax,bx,cx,xtol,fa,fb,fc:real;
    t0,t1:double;
    ts:string;
begin
  nstep:=0;
  t0:=now;
  xtol:=strtofloat(form3.edit12.text);
  maxstep:=strtofloat(form3.edit1.text);
  elim:=strtofloat(form3.edit3.text);
  glim:=strtofloat(form3.edit4.text);
  nlimlin:=strtoint(form3.edit2.text);
  for l:=1 to 3*nat do g[l]:=0;
  energy(2);{energy and gradient, initial step}
  gnorm0:=0;
  gmax:=abs(g[1]);
  for l:=1 to nat do for i:=1 to 3 do begin ii:=3*(l-1)+i;
   x0[ii]:=r[ii];h0[ii]:=g[ii];
   if (l<nat1st)or(l>nat2st) then begin
    gnorm0:=gnorm0+sqr(g[ii]);
    if abs(g[ii])>gmax then gmax:=abs(g[ii]);
   end;
  end;
  gnorm0:=sqrt(gnorm0);if gnorm0<glim then begin ts:='Initial gradient too small - minimized';goto sk3;end;

  sk2:nstep:=nstep+1;

  {Linear search along grad h0:}
  e00:=etot;
  t1:=(now-t0)*86400;
  aparatusform.Caption:=floattostrf(t1,fffixed,7,1)+' sec '+inttostr(nstep)+' step, grad '+floattostr(gnorm0);
  Form1.Caption:='Energy '+floattostr(etot);
  ax:=0;dh:=maxstep/gmax;
  mnbrak(ax,dh,h,fa,fb,fc);
  bx:=dh;cx:=h;etot:=golden(ax,bx,cx,xtol,h);
  for i:=1 to 3*(nat1st-1)   do r[i]:=x0[i]-fsign(min(maxstep,abs(h*h0[i])),h*h0[i]);
  for i:=3*nat2st+1 to 3*nat do r[i]:=x0[i]-fsign(min(maxstep,abs(h*h0[i])),h*h0[i]);
  if(form3.checkbox13.Checked or form3.checkbox14.Checked)then shake;
  fixbox;
  if form3.CheckBox1.checked then draw;

  if(etot>e00)then begin
   showmessage('Lin. search not successful');
   exit;
  end;

  energy(1);gnorm1:=0;gmax:=abs(g[1]);
  for l:=1 to nat do begin
   if (l<nat1st)or(l>nat2st)then for i:=1 to 3 do begin gnorm1:=gnorm1+sqr(g[3*(l-1)+i]);if abs(g[3*(l-1)+i])>gmax then gmax:= abs(g[3*(l-1)+i]);end;
  end;for i:=1 to 3*nat do x0[i]:=r[i];
  gnorm1:=sqrt(gnorm1);
  for ii:=1 to 3*nat do begin
   h0[ii]:=g[ii]+sqr(gnorm1/gnorm0)*h0[ii];
  end;
  if(form3.CheckBox2.Checked) then writeln(fv,'Gradient         ',gnorm1       :15:6,'; limit ',glim:15:6);
  if(form3.CheckBox2.Checked) then writeln(fv,'Change of energy ',abs(e00-etot):15:6,'; limit ',elim:15:6);

  if (abs(e00-etot)<elim) and (gnorm1<glim) then begin ts:='Optimization converged';goto sk3;end;
  if (gnorm1<glim) then begin ts:='Optimization converged - small grad';goto sk3;end;
  if nstep>nstepmax then begin ts:='Too many steps';goto sk3;end;
  if getasynckeystate(27)<>0 then begin ts:='Optimization was interrupted.';goto sk3;end;

  gnorm0:=gnorm1;
  goto sk2;

 sk3:showmessage(ts);
 energy(3);
end;

procedure MinimizeEnergy;
label sk1,sk2,sk3;
var j,i:integer;ts:string;
begin
 nstepmax:=strtoint(form3.edit11.text);


 {how many bonds on each atom for speeding up pair term}
 for i:=1 to nat do begin
  nba[i]:=0;
  for j:=1 to nb do begin
   if (b1[j]=i)or(b2[j]=i) then begin
    nba[i]:=nba[i]+1;
    if (nba[i]>7)then begin showmessage('two many bonds on atom '+inttostr(i));exit;end;
    if(b2[j]=i)then nbt[i,nba[i]]:=b1[j]else nbt[i,nba[i]]:=b2[j];
   end;
  end;
 end;

 if(form3.CheckBox2.Checked) then begin
 assignfile(fv,'energy.log');
 rewrite(fv);
 writeln(fv,' Last energy calculation');writeln(fv);
 writeln(fv,nat:10,' atoms');
 writeln(fv,'atom charge vdwep vdwrs');
 for i:=1 to nat do begin
  writeln(fv,i:4,' ',q[i]:6:2,eps[i]:6:3,
  exp(1/3*ln(r3[i])):6:3);
 end;
 writeln(fv);
 writeln(fv,nb:10,' bonds');
 writeln(fv,'bond   i-   j     kb     b0');
 for i:=1 to nb do writeln(fv,i:4,b1[i]:4,' ',b2[i]:4,' ',k0[i]:6:1,' ',b0[i]:6:3);
 writeln(fv);
 writeln(fv,nt:10,' bond angles');
 writeln(fv,'angle   i-   j-   k     kt     t0');
 for i:=1 to nt do writeln(fv,i:4,' ',t1[i]:4,' ',t2[i]:4,' ',t3[i]:4,' ',kt[i]:6:1,' ',bt[i]:6:1);
 writeln(fv);
 writeln(fv,nd:10,' torsion angles');
 writeln(fv,'torsions   i-   j-   k-   l    k1f    k2f    k3f');
 for i:=1 to nd do writeln(fv,i:7,' ',d1[i]:4,' ',d2[i]:4,' ',d3[i]:4,' ',d4[i]:4,' ',k1d[i]:6:3,' ',k2d[i]:6:3,' ',k3d[i]:6:3);
 writeln(fv);
 writeln(fv,np:10,' out-of-plane waggings');
 writeln(fv,'planes     i-   j-   k-   l     oo');
 for i:=1 to np do writeln(fv,i:7,' ',o1[i]:4,' ',o2[i]:4,' ',o3[i]:4,' ',o4[i]:4,' ',oo[i]:6:3);
 end;

 minimini;
 str(etot:25:9,ts);
 form1.Caption:=' Energy = '+ts;

 if(form3.CheckBox2.Checked) then writeln(fv,ts);
 if(form3.CheckBox2.Checked) then close(fv);
end;


end.
