unit minimize;
   {$J+}
interface
uses unit1;

type real=single;

procedure MinimizeEnergy;
procedure energy(ic:integer);

implementation

uses dialogs,sysutils,unit2,windows,controls,unit3,math,diagpas;

var nstep:integer;
    fv:textfile;
    nba:array[1..nat0] of integer;
    nbt:array[1..nat0,1..7] of integer;

function sp(v1,v2:vector):real;begin sp:=v1[1]*v2[1]+v1[2]*v2[2]+v1[3]*v2[3];end;

procedure vp(v1,v2:vector;var v3:vector);begin v3[1]:=v1[2]*v2[3]-v1[3]*v2[2];v3[2]:=v1[3]*v2[1]-v1[1]*v2[3];v3[3]:=v1[1]*v2[2]-v1[2]*v2[1];end;

function ArcCosine(number: real): real;
var x: real;
begin
 if number<-1 then number:=-1;
 if number>1 then number:=1;
 if abs(number)<0.00001 then arccosine:=90 else begin
  x:=1-number*number;
  if abs(x)<0.00001 then begin
   if number>0 then arccosine:=0 else arccosine:=180;
  end  else   begin
   x:=(180/pi)*arctan(sqrt(x)/number);
   if x<0 then arccosine:=180+x else arccosine:=x;
  end;
 end;
end;

procedure lpc(var shx,shy,shz,xi,rmoljx,yi,rmoljy,zi,rmoljz,xb2,yb2,zb2:real;xbox,ybox,zbox:real);
const tol=0.01;
begin
   shx:=0;shy:=0;shz:=0;
   if xi-rmoljx>xb2+tol then shx:=xbox else if rmoljx-xi>xb2+tol then shx:=-xbox;
   if yi-rmoljy>yb2+tol then shy:=ybox else if rmoljy-yi>yb2+tol then shy:=-ybox;
   if zi-rmoljz>zb2+tol then shz:=zbox else if rmoljz-zi>zb2+tol then shz:=-zbox;
end;


procedure energy(ic:integer); {energy in kcal/mol, gradien in kcal/mol/A}
label sk1,sk2,lk;
const pi180=pi/180;pi1802=pi*pi/180/180;

var qi,ri3,ri6,rj3,rj6,epsilon,epsi,rst,sum_b,sum_vdw,sum_es,sum_pol,xi,yi,zi,d6,d33,rr,
tem,aa,ba,x,y,z,sum_o,ct,sum_a,v12,v13,v23,st,v1a,v2a,sum_t,t,c1,c2,c3,co3,
gxe2,gye2,gze2,
v3q,chi,ffr,oop,cc,ffes,ffres,ff,v2q,v1q,xb2,yb2,zb2,v1av2a,xx,yy,zz,efieldy,
xj,yj,rr2,gnorm,zj,xk,yk,zk,xl,yl,zl,rst3,sum,sum_mag,mmas,rij2,rij5,mdotr,
xij,yij,zij,qiqj,fx,fy,fz,mjdotr,midotr,midotmj,tx,ty,tz,ri2,xia,yia,zia,ri2xy,ri2xz,ri2yz,
co,sumx,shx,shy,shz,sumy,sumz,cut,mcos,msin,smooth,rmolix,rmoliy,rmoliz,rmoljx,rmoljy,rmoljz,
gxe,gye,sumxx,sumyy,sumzz,sumxy,sumxz,sumyz,gze,gxm,gym,gzm,ex,ey,ez,gnormvdw,
v1x,v1y,v1z,e1x,e1y,e1z,e2x,e2y,e2z,e3x,e3y,e3z,an,signc,
gnormb,gnorma,gnormm,rixy,ri3xy,riyz,ri3yz,rixz,ri3xz,bfx,bfy,bfz:real;
cv,av,bv,v3,v1,v2,mmagi,meli,mcom,mlocal:vector;

Efield:array[1..nat0,1..3] of real;
Efieldg:array[1..3*nat0,1..3] of real;
i1,i2,i3,io,kp,kxp,m,ll,kk,a,i,j,k,jj,l,ii,b,ix,jx,imol,jmol,ixp,jxp,ia,ierr,kx:integer;
      ts:string;
th,imom:mat3;
dh,bind,eind:vector;
chilocal,chicom,pollocal,polcom:array[1..3,1..3]of real;
chicome,chilocale:array[1..3,1..3,1..3]of real;

begin
sum_pol:=0;sum_es:=0.0;sum_vdw:=0.0;sum_b:=0.0;sum_a:=0.0;sum_t:=0.0;sum_o:=0;sum_mag:=0;
xb2:=xbox/2;yb2:=ybox/2;zb2:=zbox/2;
for i:=1 to 3*nat do begin bxf[i]:=0;byf[i]:=0;bzf[i]:=0;g[i]:=0; end;
cut:=strtofloat(form3.edit6.text);
co3:=bohr*bohr*bohr;
smooth:=strtofloat(form3.edit7.text);co:=cut-smooth;
if(co<0)then showmessage('cutoff must be bigger than smoothing');
efieldy:=strtofloat(form3.edit20.text);{electric field in au}
bfieldy:=strtofloat(form3.Edit14.Text)/2.352e5;{magnetic field in au}
bfieldx:=strtofloat(form3.Edit21.Text)/2.352e5;{magnetic field in au}
bfieldz:=strtofloat(form3.Edit22.Text)/2.352e5;{magnetic field in au}

{molecular masses and positions (gravity centers)}
for imol:=1 to 2*nst+nso+2*nch do begin
 mmas:=0;sumx:=0;sumy:=0;sumz:=0;
 for ia:=ias[imol] to iae[imol] do begin
  mmas:=mmas+mmass[ia];
  sumx:=sumx+mmass[ia]*r[3*(ia-1)+1];
  sumy:=sumy+mmass[ia]*r[3*(ia-1)+2];
  sumz:=sumz+mmass[ia]*r[3*(ia-1)+3];
 end;
 sumx:=sumx/mmas;sumy:=sumy/mmas;sumz:=sumz/mmas;
 rmol[imol,1]:=sumx;rmol[imol,2]:=sumy;rmol[imol,3]:=sumz;
 rr:=0;
 for ia:=ias[imol] to iae[imol] do rr:=rr+mmass[ia]*(sqr(r[3*(ia-1)+1]-sumx)+sqr(r[3*(ia-1)+2]-sumy)+sqr(r[3*(ia-1)+3]-sumz));
 rrmol[imol]:=rr/mmas;
end;

if form1.CheckBox2.checked or form1.CheckBox7.checked then begin  {polar}
for imol:=1 to 2*nst+nso+2*nch do begin
 xi:=rmol[imol,1];
 yi:=rmol[imol,2];
 zi:=rmol[imol,3];
 sumx:=0;sumy:=0;sumz:=0;
 sumxx:=0;sumxy:=0;sumxz:=0;
 sumyy:=0;sumyz:=0;sumzz:=0;
 for jmol:=1 to 2*nst+nso+2*nch do begin
  if(imol<>jmol)then begin
   rmoljx:=rmol[jmol,1];
   rmoljy:=rmol[jmol,2];
   rmoljz:=rmol[jmol,3];
   lpc(shx,shy,shz,xi,rmoljx,yi,rmoljy,zi,rmoljz,xb2,yb2,zb2,xbox,ybox,zbox);
   rmoljx:=rmoljx+shx;
   rmoljy:=rmoljy+shy;
   rmoljz:=rmoljz+shz;
   rr2:=sqr(rmoljx-xi)+sqr(rmoljy-yi)+sqr(rmoljz-zi)+0.000001;rr:=sqrt(rr2);
   if(rr<cut)THEN BEGIN
    for j:=ias[jmol] to iae[jmol] do begin
     jj:=j+j+j-2;xj:=r[jj]+shx;yj:=r[jj+1]+shy;zj:=r[jj+2]+shz;
     xij:=xi-xj;yij:=yi-yj;zij:=zi-zj;rr2:=sqr(xij)+sqr(yij)+sqr(zij)+0.000001;rr:=sqrt(rr2);
     if rr<cut then begin
      ffes:=q[j]/rr2;
      if rr>co then begin
       cc:=((cut-rr)/rr+1)/smooth*ffes;
       sumx:=sumx+xij*cc;
       sumy:=sumy+yij*cc;
       sumz:=sumz+zij*cc;
       if form1.CheckBox2.checked then begin
        cc:=((cut-rr)/rr+1);
        sumxx:=sumxx+ffes*(-2*cc*xij*xij/rr2-(cut-rr)*xij*xij/rr/rr2-xij*xij/rr2+cc)/smooth;
        sumyy:=sumyy+ffes*(-2*cc*yij*yij/rr2-(cut-rr)*yij*yij/rr/rr2-yij*yij/rr2+cc)/smooth;
        sumzz:=sumzz+ffes*(-2*cc*zij*zij/rr2-(cut-rr)*zij*zij/rr/rr2-zij*zij/rr2+cc)/smooth;
        sumxy:=sumxy+ffes*(-2*cc*xij*yij/rr2-(cut-rr)*xij*yij/rr/rr2-xij*yij/rr2)/smooth;
        sumxz:=sumxz+ffes*(-2*cc*xij*zij/rr2-(cut-rr)*xij*zij/rr/rr2-xij*zij/rr2)/smooth;
        sumyz:=sumyz+ffes*(-2*cc*yij*zij/rr2-(cut-rr)*yij*zij/rr/rr2-yij*zij/rr2)/smooth;
       end;
      end else begin
       sumx:=sumx+ffes*xij/rr;
       sumy:=sumy+ffes*yij/rr;
       sumz:=sumz+ffes*zij/rr;
       if form1.CheckBox2.checked then begin
        sumxx:=sumxx+ffes*(1-3*xij*xij/rr2)/rr;
        sumyy:=sumyy+ffes*(1-3*yij*yij/rr2)/rr;
        sumzz:=sumzz+ffes*(1-3*zij*zij/rr2)/rr;
        sumxy:=sumxy+ffes*( -3*xij*yij/rr2)/rr;
        sumxz:=sumxz+ffes*( -3*xij*zij/rr2)/rr;
        sumyz:=sumyz+ffes*( -3*yij*zij/rr2)/rr;
       end;
      end;
     end;
    end;
   END;
  end;
 end;
 Efield[imol,1]:=sumx*sqr(bohr);
 Efield[imol,2]:=sumy*sqr(bohr)+efieldy;
 Efield[imol,3]:=sumz*sqr(bohr);
 if form1.CheckBox2.checked then begin
  Efieldg[3*(imol-1)+1,1]:=sumxx*sqr(bohr);
  Efieldg[3*(imol-1)+2,2]:=sumyy*sqr(bohr);
  Efieldg[3*(imol-1)+3,3]:=sumzz*sqr(bohr);
  Efieldg[3*(imol-1)+1,2]:=sumxy*sqr(bohr);
  Efieldg[3*(imol-1)+2,1]:=sumxy*sqr(bohr);
  Efieldg[3*(imol-1)+1,3]:=sumxz*sqr(bohr);
  Efieldg[3*(imol-1)+3,1]:=sumxz*sqr(bohr);
  Efieldg[3*(imol-1)+2,3]:=sumyz*sqr(bohr);
  Efieldg[3*(imol-1)+3,2]:=sumyz*sqr(bohr);
 end;
end;
end;

{electrostatic and van der Waals}
if form1.CheckBox6.checked then begin
{same molecule extra}
for imol:=2*nst+1 to 2*nst+nso+2*nch do begin
 for i:=ias[imol] to iae[imol] do begin
  ri3:=r3[i];ri6:=ri3*ri3;epsi:=eps[i];qi:=q[i]*bohr*kcal;
  ii:=i+i+i-2;xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];
  for j:=i+1 to iae[imol] do begin
   for b:=1 to nb do if ((i=b1[b])and(j=b2[b]))or((j=b1[b])and(i=b2[b])) then goto lk;
   for b:=1 to nt do if ((i=t1[b])and(j=t3[b]))or((i=t1[b])and(j=t3[b])) then goto lk;
   for b:=1 to nd do if ((i=d1[b])and(j=d4[b]))or((i=d4[b])and(j=d1[b])) then goto lk;
   jj:=j+j+j-2;xj:=r[jj];yj:=r[jj+1];zj:=r[jj+2];
   xij:=xi-xj;yij:=yi-yj;zij:=zi-zj;rr2:=sqr(xij)+sqr(yij)+sqr(zij)+0.000001;rr:=sqrt(rr2);
   rj3:=r3[j];rj6:=rj3*rj3;
   epsilon:=2*sqrt(epsi*eps[j])*ri3*rj3/(ri6+rj6);
   rst:=0.5*(ri6+rj6);
   rst3:=sqrt(rst);
   d33:=rst3/rr/rr2;d6:=sqr(d33);
   ff:=epsilon*(d33+d33-3)*d6;
   ffes:=qi*q[j]/rr;
   sum_vdw:=sum_vdw+ff;
   sum_es:=sum_es+ffes;
   if(ic>0)then begin
    ffr:=-18*epsilon*(d6*d33-d6)/rr;
    ffres:=-ffes/rr;
    tem:=(ffr+ffres)/rr;
    g[ii  ]:=g[ii  ]+tem*xij;g[jj  ]:=g[jj  ]-tem*xij;
    g[ii+1]:=g[ii+1]+tem*yij;g[jj+1]:=g[jj+1]-tem*yij;
    g[ii+2]:=g[ii+2]+tem*zij;g[jj+2]:=g[jj+2]-tem*zij;
   end;
   lk:
  end;
 end;
end;

for imol:=1 to 2*nst+nso+2*nch do begin
 rmolix:=rmol[imol,1];rmoliy:=rmol[imol,2];rmoliz:=rmol[imol,3];
 for jmol:=imol+1 to 2*nst+nso+2*nch do begin
  if(imol>2*nst)or(jmol>2*nst)then begin
   rmoljx:=rmol[jmol,1];rmoljy:=rmol[jmol,2];rmoljz:=rmol[jmol,3];
   lpc(shx,shy,shz,rmolix,rmoljx,rmoliy,rmoljy,rmoliz,rmoljz,xb2,yb2,zb2,xbox,ybox,zbox);
   rmoljx:=rmoljx+shx;rmoljy:=rmoljy+shy;rmoljz:=rmoljz+shz;
   rr2:=sqr(rmoljx-rmolix)+sqr(rmoljy-rmoliy)+sqr(rmoljz-rmoliz)+0.000001;rr:=sqrt(rr2);
   if(rr<cut)THEN BEGIN
    for i:=ias[imol] to iae[imol] do begin
     ri3:=r3[i];ri6:=ri3*ri3;epsi:=eps[i];qi:=q[i]*bohr*kcal;
     ii:=i+i+i-2;xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];
     bfx:=0;bfy:=0;bfz:=0;{calculate magnetic field from motion, store for later}
     for j:=ias[jmol] to iae[jmol] do begin
      jj:=j+j+j-2;xj:=r[jj]+shx;yj:=r[jj+1]+shy;zj:=r[jj+2]+shz;
      xij:=xi-xj;yij:=yi-yj;zij:=zi-zj;rr2:=sqr(xij)+sqr(yij)+sqr(zij)+0.000001;rr:=sqrt(rr2);
      rj3:=r3[j];rj6:=rj3*rj3;
      epsilon:=2*sqrt(epsi*eps[j])*ri3*rj3/(ri6+rj6);
      rst:=0.5*(ri6+rj6);
      rst3:=sqrt(rst);
      d33:=rst3/rr/rr2;d6:=sqr(d33);
      ff:=epsilon*(d33+d33-3)*d6;
      ffes:=qi*q[j]/rr;
      bfx:=bfx+q[j]*((r[jj+1]-rmm[jj+1])*zij-(r[jj+2]-rmm[jj+2])*yij)/2/dt/rr/rr2;
      bfy:=bfy+q[j]*((r[jj+2]-rmm[jj+2])*xij-(r[jj  ]-rmm[jj  ])*zij)/2/dt/rr/rr2;
      bfz:=bfz+q[j]*((r[jj  ]-rmm[jj  ])*yij-(r[jj+1]-rmm[jj+1])*xij)/2/dt/rr/rr2;
      if rr<cut then begin
       if rr>co then cc:=(cut-rr)/smooth else cc:=1;
       sum_vdw:=sum_vdw+ff*cc;
       sum_es:=sum_es+ffes*cc;
       if(ic>0)then begin
        ffr:=-18*epsilon*(d6*d33-d6)/rr;
        ffres:=-ffes/rr;
        if rr>co then tem:=((ffr+ffres)*cc-(ff+ffes)/smooth)/rr else tem:=(ffr+ffres)/rr;
        g[ii  ]:=g[ii  ]+tem*xij;g[jj  ]:=g[jj  ]-tem*xij;
        g[ii+1]:=g[ii+1]+tem*yij;g[jj+1]:=g[jj+1]-tem*yij;
        g[ii+2]:=g[ii+2]+tem*zij;g[jj+2]:=g[jj+2]-tem*zij;
       end;
      end;
     end;{j}
     bxf[i]:=bfx* 7.881e-6/0.529;
     byf[i]:=bfy* 7.881e-6/0.529;
     bzf[i]:=bfz* 7.881e-6/0.529;
    end;{i}
   END;
  end;{exclude static-static}
 end;{jmol}
 for i:=ias[imol] to iae[imol] do sum_es:=sum_es-q[i]*efieldy*r[3*(i-1)+2]/bohr*kcal;
 if ic>0 then for i:=ias[imol] to iae[imol] do g[3*(i-1)+2]:=g[3*(i-1)+2]-q[i]*efieldy*kcal/bohr;
end;{imol}
end;


{magnetic forces and polarizabilities}
if form1.CheckBox3.checked or form1.CheckBox2.checked then begin
 {chiloc - susceptibilities in local coordinate system, mlocal - mag moments}
 {initialize with solvent values:}
 if form1.CheckBox3.checked then begin
  for ix:=1 to 3 do for jx:=1 to 3 do chilocal[ix,jx]:=chism[ix,jx];
  for ix:=1 to 3 do mlocal[ix]:=pmds[ix];
  if form1.CheckBox7.checked then begin
   for ix:=1 to 3 do for jx:=1 to 3 do for kx:=1 to 3 do chilocale[kx,ix,jx]:=chisme[kx,ix,jx];
  end;
 end;
 if form1.CheckBox2.checked then begin
  for ix:=1 to 3 do for jx:=1 to 3 do pollocal[ix,jx]:=polsm[ix,jx];
 end;
 {for all molecules included static and solvent (if desired) calc induced moments}
 for imol:=1 to 2*nst+nso+2*nch do begin
  {if not solvent, switch to the right susc and moment:}
  if form1.CheckBox3.checked then begin
   if imol=2*nst+1     then begin
    for ix:=1 to 3 do for jx:=1 to 3 do chilocal[ix,jx]:=chiom[ix,jx];
    if form1.CheckBox7.checked then begin
     for ix:=1 to 3 do for jx:=1 to 3 do for kx:=1 to 3 do chilocale[kx,ix,jx]:=chiome[kx,ix,jx];
    end;
   end;
   if imol=2*nst+1     then for ix:=1 to 3 do mlocal[ix]:=pmdo[ix];
   if imol=2*nst+nso+1 then begin
    for ix:=1 to 3 do for jx:=1 to 3 do chilocal[ix,jx]:=chicm[ix,jx];
    if form1.CheckBox7.checked then begin
     for ix:=1 to 3 do for jx:=1 to 3 do for kx:=1 to 3 do chilocale[kx,ix,jx]:=chicme[kx,ix,jx];
    end;
   end;
   if imol=2*nst+nso+1 then for ix:=1 to 3 do mlocal[ix]:=pmdc[ix];
  end;
  if form1.CheckBox2.checked then begin
   if imol=2*nst+1     then for ix:=1 to 3 do for jx:=1 to 3 do pollocal[ix,jx]:=polom[ix,jx];
   if imol=2*nst+nso+1 then for ix:=1 to 3 do for jx:=1 to 3 do pollocal[ix,jx]:=polcm[ix,jx];
  end;
  if (form1.CheckBox2.checked )or(((imol<=2*nst)or(imol>2*nst+nso))or form1.CheckBox5.checked) then BEGIN
   {get molecular moments of inertia}
   if(form3.CheckBox1.checked)then begin
    i1:=3*(ias[imol]  -1);i2:=3*(ias[imol]+1-1);i3:=3*(ias[imol]+2-1);
    v1x:=r[i2+1]-r[i1+1];v1y:=r[i2+2]-r[i1+2];v1z:=r[i2+3]-r[i1+3];
    e1x:=r[i3+1]-r[i2+1];e1y:=r[i3+2]-r[i2+2];e1z:=r[i3+3]-r[i2+3];
    an:=sqrt(sqr(e1x)+sqr(e1y)+sqr(e1z)+1.0e-8);
    e1x:=e1x/an;e1y:=e1y/an;e1z:=e1z/an;
    e2x:=v1y*e1z-v1z*e1y;
    e2y:=v1z*e1x-v1x*e1z;
    e2z:=v1x*e1y-v1y*e1x;
    an:=sqrt(sqr(e2x)+sqr(e2y)+sqr(e2z)+1.0e-8);
    e2x:=e2x/an;e2y:=e2y/an;e2z:=e2z/an;
    e3x:=e1y*e2z-e1z*e2y;
    e3y:=e1z*e2x-e1x*e2z;
    e3z:=e1x*e2y-e1y*e2x;
    th[1,1]:=e1x;
    th[1,2]:=e2x;
    th[1,3]:=e3x;
    th[2,1]:=e1y;
    th[2,2]:=e2y;
    th[2,3]:=e3y;
    th[3,1]:=e1z;
    th[3,2]:=e2z;
    th[3,3]:=e3z;
   end else begin
    for ix:=1 to 3 do for jx:=1 to 3 do begin
     sum:=0;
     for ia:=ias[imol] to iae[imol] do sum:=sum+mmass[ia]*(r[3*(ia-1)+ix]-rmol[imol,ix])*(r[3*(ia-1)+jx]-rmol[imol,jx]);
     imom[ix,jx]:=sum;
    end;
    {diagonalize in order to get local coordinate system; th[common, diag local]}
    TRED12(3,imom,th,dh,2,ierr);if ierr<>0 then showmessage('diagonalization error in minimize');
   end;
   if form1.CheckBox3.checked then begin
    {chi in common origin system}
    for ix:=1 to 3 do for jx:=1 to 3 do begin
     sum:=0;for ixp:=1 to 3 do for jxp:=1 to 3 do sum:=sum+chilocal[ixp,jxp]*th[ix,ixp]*th[jx,jxp];chicom[ix,jx]:=sum;
    end;
    if form1.CheckBox7.checked then begin
     {chi el der in common origin system}
     for kx:=1 to 3 do for ix:=1 to 3 do for jx:=1 to 3 do begin
      sum:=0;
      for kxp:=1 to 3 do for ixp:=1 to 3 do for jxp:=1 to 3 do sum:=sum+chilocale[kxp,ixp,jxp]*th[ix,ixp]*th[jx,jxp]*th[kx,kxp];
      chicome[kx,ix,jx]:=sum;
     end;
    end;

    {dependence of the susceptibility on the electric field:}
    if form1.CheckBox7.checked then begin
     {this tensor is chirality sensitive:}
     signc:=1;
     if form1.radiobutton1.Checked then if(imol<=2*nst+nso+nch)then signc:=1 else signc:=-1;
     if form1.radiobutton2.Checked then signc:=-1;
     for ix:=1 to 3 do for jx:=1 to 3 do begin
      sum:=0;
      for kx:=1 to 3 do sum:=sum+chicome[kx,ix,jx]*Efield[imol,kx];
      chicom[ix,jx]:=chicom[ix,jx]+sum*signc;
     end;
    end;

    { permanent magnetic moments in common origin system}
    for ix:=1 to 3 do begin
     sum:=0;for ixp:=1 to 3 do sum:=sum+mlocal[ixp]*th[ix,ixp];mcom[ix]:=sum;
    end;
    {total magnetic moments for molecules m=m0+chi*B0}
    for ix:=1 to 3 do mmag[imol,ix]:=mcom[ix]+chicom[ix,1]*Bfieldx+chicom[ix,2]*Bfieldy+chicom[ix,3]*Bfieldz;
   end;
   if form1.CheckBox2.checked then begin
    {polarizability in common origin system}
    for ix:=1 to 3 do for jx:=1 to 3 do begin
     sum:=0;for ixp:=1 to 3 do for jxp:=1 to 3 do sum:=sum+pollocal[ixp,jxp]*th[ix,ixp]*th[jx,jxp];polcom[ix,jx]:=sum;
    end;
    {total induced el moment}
    for ix:=1 to 3 do begin
     mel[imol,ix]:=polcom[ix,1]*Efield[imol,1]+polcom[ix,2]*Efield[imol,2]+polcom[ix,3]*Efield[imol,3];
    end;
   end;
  END;
 end;

 {energy and gradient only for chiral + solvent(if desired)}
 for imol:=2*nst+1 to 2*nst+nso+2*nch do begin
  if (form1.CheckBox2.checked) or ((imol>2*nst+nso)or form1.CheckBox5.checked ) then BEGIN
   {magnetic moments for molecules perturbed   m'=chi*(B0+u0/4/pi/r^3*(3 m.n n - m))}
   xi:=rmol[imol,1];yi:=rmol[imol,2];zi:=rmol[imol,3];
   if (form1.CheckBox3.checked) then begin
    for ix:=1 to 3 do mmagi[ix]:=mmag[imol,ix];
    for ix:=1 to 3 do bind[ix]:=0;{secondary magnetic field from induced momenta}
   end;
   if (form1.CheckBox2.checked) then begin
    for ix:=1 to 3 do meli[ix]:=mel[imol,ix];
    for ix:=1 to 3 do eind[ix]:=0;{secondary electric field from induced momenta}
   end;
   gxe:=0;gye:=0;gze:=0;gxm:=0;gym:=0;gzm:=0;gxe2:=0;gye2:=0;gze2:=0 ;

   {induced field from everything:}
   for jmol:=1 to 2*nst+nso+2*nch do begin
    if (form1.CheckBox2.checked) or (((jmol<=2*nst)or(jmol>2*nst+nso))or form1.CheckBox5.checked) then BEGIN
     if jmol<>imol then begin
      xj:=rmol[jmol,1];yj:=rmol[jmol,2];zj:=rmol[jmol,3];{coordinates in A, rest in au}
      {take care about periodic conditions:}
      lpc(shx,shy,shz,xi,xj,yi,yj,zi,zj,xb2,yb2,zb2,xbox,ybox,zbox);
      xj:=xj+shx;yj:=yj+shy;zj:=zj+shz;
      xij:=xi-xj;yij:=yi-yj;zij:=zi-zj;
      rij2:=sqr(xij)+sqr(yij)+sqr(zij)+1.0e-8;
      rij5:=sqrt(rij2)*sqr(rij2);
      if (form1.CheckBox3.checked) then begin
       mjdotr:=xij*mmag[jmol,1]+yij*mmag[jmol,2]+zij*mmag[jmol,3];
       bind[1]:=bind[1]+(3*mjdotr*xij-rij2*mmag[jmol,1])/rij5;
       bind[2]:=bind[2]+(3*mjdotr*yij-rij2*mmag[jmol,2])/rij5;
       bind[3]:=bind[3]+(3*mjdotr*zij-rij2*mmag[jmol,3])/rij5;

       if(ic>0)then begin
        midotr :=xij*mmagi[1]+yij*mmagi[2]+zij*mmagi[3];
        midotmj:=mmag[jmol,1]*mmagi[1]+mmag[jmol,2]*mmagi[2]+mmag[jmol,3]*mmagi[3];
        {gradient imol due to the magnetic field inhomogenity}
        gxm:=gxm-(3*midotr*mmag[jmol,1]+3*mjdotr*mmagi[1]-2*xij*midotmj)/rij5
                         +5*(3*mjdotr*midotr-rij2*midotmj)*xij/rij5/rij2;
        gym:=gym-(3*midotr*mmag[jmol,2]+3*mjdotr*mmagi[2]-2*yij*midotmj)/rij5
                         +5*(3*mjdotr*midotr-rij2*midotmj)*yij/rij5/rij2;
        gzm:=gzm-(3*midotr*mmag[jmol,3]+3*mjdotr*mmagi[3]-2*zij*midotmj)/rij5
                         +5*(3*mjdotr*midotr-rij2*midotmj)*zij/rij5/rij2;
       end;
      end;

      if (form1.CheckBox2.checked) then begin
       mjdotr:=xij*mel[jmol,1]+yij*mel[jmol,2]+zij*mel[jmol,3];
       eind[1]:=eind[1]+(3*mjdotr*xij-rij2*mel[jmol,1])/rij5*co3;
       eind[2]:=eind[2]+(3*mjdotr*yij-rij2*mel[jmol,2])/rij5*co3;
       eind[3]:=eind[3]+(3*mjdotr*zij-rij2*mel[jmol,3])/rij5*co3;
       if(ic>0)then begin
        midotr :=xij*meli[1]+yij*meli[2]+zij*meli[3];
        midotmj:=mel[jmol,1]*meli[1]+mel[jmol,2]*meli[2]+mel[jmol,3]*meli[3];
        {force acting on the molecule imol due to the elnetic field inhomogenity}
        gxe:=gxe-(3*midotr*mel[jmol,1]+3*mjdotr*meli[1]-2*xij*midotmj)/rij5
                         +5*(3*mjdotr*midotr-rij2*midotmj)*xij/rij5/rij2;
        gye:=gye-(3*midotr*mel[jmol,2]+3*mjdotr*meli[2]-2*yij*midotmj)/rij5
                         +5*(3*mjdotr*midotr-rij2*midotmj)*yij/rij5/rij2;
        gze:=gze-(3*midotr*mel[jmol,3]+3*mjdotr*meli[3]-2*zij*midotmj)/rij5
                         +5*(3*mjdotr*midotr-rij2*midotmj)*zij/rij5/rij2;
       end;
      end;

     end;
    END;
   end;

   if (form1.CheckBox3.checked) then begin
    for ix:=1 to 3 do bind[ix]:=bind[ix]*7.881e-6;{to au, coordinates in A, mag moments in au}
    for ix:=1 to 3 do for ixp:=1 to 3 do mmagi[ix]:=mmagi[ix]+chicom[ix,ixp]*bind[ixp];
    bind[1]:=bind[1]+Bfieldx;bind[2]:=bind[2]+Bfieldy;bind[3]:=bind[3]+Bfieldz;
    sum_mag:=sum_mag-mmagi[1]*bind[1]-mmagi[2]*bind[2]-mmagi[3]*bind[3];
   end;

   if (form1.CheckBox2.checked) then begin
    for ix:=1 to 3 do for ixp:=1 to 3 do meli[ix]:=meli[ix]+polcom[ix,ixp]*eind[ixp];
    for ix:=1 to 3 do sum_pol:=sum_pol-meli[ix]*(eind[ix]+Efield[imol,ix]);
    {force acting on the molecule imol due to the elnetic field inhomogenity}
    if(ic>0)then begin for ix:=1 to 3 do begin
     gxe2:=gxe2-meli[ix]*Efieldg[3*(imol-1)+1,ix];
     gye2:=gye2-meli[ix]*Efieldg[3*(imol-1)+2,ix];
     gze2:=gze2-meli[ix]*Efieldg[3*(imol-1)+3,ix];
    end;end;
   end;

   if(ic>0)then begin
    fx:=gxm*7.881e-6+gxe*co3+gxe2;
    fy:=gym*7.881e-6+gye*co3+gye2;
    fz:=gzm*7.881e-6+gze*co3+gze2;
    fx:=fx*627.5/(iae[imol]-ias[imol]+1);{distribute over all atoms in imol}
    fy:=fy*627.5/(iae[imol]-ias[imol]+1);
    fz:=fz*627.5/(iae[imol]-ias[imol]+1);
    for ia:=ias[imol] to iae[imol] do begin ii:=3*(ia-1);
     g[ii+1]:=g[ii+1]+fx;
     g[ii+2]:=g[ii+2]+fy;
     g[ii+3]:=g[ii+3]+fz;
    end;
    {torsional force:}
    tx:=0;ty:=0;tz:=0;
    if (form1.CheckBox3.checked) then begin
     tx:=mmagi[2]*bind[3]-mmagi[3]*bind[2];
     ty:=mmagi[3]*bind[1]-mmagi[1]*bind[3];
     tz:=mmagi[1]*bind[2]-mmagi[2]*bind[1];
    end;
    if (form1.CheckBox2.checked) then begin
     ex:=eind[1]+Efield[imol,1];ey:=eind[2]+Efield[imol,2];ez:=eind[3]+Efield[imol,3];
     tx:=tx+meli[2]*ez-meli[3]*ey;
     ty:=ty+meli[3]*ex-meli[1]*ez;
     tz:=tz+meli[1]*ey-meli[2]*ex;
    end;
    tx:=tx/(iae[imol]-ias[imol]+1)*627.5;
    ty:=ty/(iae[imol]-ias[imol]+1)*627.5;
    tz:=tz/(iae[imol]-ias[imol]+1)*627.5;
    rr:=rrmol[imol]/bohr;
    for ia:=ias[imol] to iae[imol] do begin ii:=3*(ia-1);
     xia:=r[ii+1]-rmol[imol,1];yia:=r[ii+2]-rmol[imol,2];zia:=r[ii+3]-rmol[imol,3];
     g[ii+1]:=g[ii+1]-(             +ty*zia-tz*yia)/rr;
     g[ii+2]:=g[ii+2]-(-tx*zia             +tz*xia)/rr;
     g[ii+3]:=g[ii+3]-( tx*yia      -ty*xia       )/rr;
    end;
   end;

  END;
 end;
 sum_mag:=sum_mag*kcal;
 sum_pol:=sum_pol*kcal;
end;
{magnetic forces and polarizabilities}

{bonds}
{Periodic conditions do not need to be considered since whole molecules are always in box}
for b:=1 to nb do begin i:=b1[b];j:=b2[b];if(i>nat2st)or(j>nat2st)then begin
 ii:=i+i+i-2;jj:=j+j+j-2;
 xij:=r[ii]-r[jj];yij:=r[ii+1]-r[jj+1];zij:=r[ii+2]-r[jj+2];
 rr:=sqrt(sqr(xij)+sqr(yij)+sqr(zij));
 sum_b:=sum_b+k0[b]*sqr(rr-b0[b]);
 if(ic>0)then begin {also gradient}
  ffr:=2*k0[b]*(rr-b0[b])/rr; {actually ffr/rr}
  g[ii  ]:=g[ii  ]+ffr*xij;g[jj  ]:=g[jj  ]-ffr*xij;
  g[ii+1]:=g[ii+1]+ffr*yij;g[jj+1]:=g[jj+1]-ffr*yij;
  g[ii+2]:=g[ii+2]+ffr*zij;g[jj+2]:=g[jj+2]-ffr*zij;
 end;
end;end;

{bond angles}
{Periodic conditions do not need to be considered since whole molecules always in box}
for b:=1 to nt do begin i:=t1[b];j:=t2[b];k:=t3[b];if(i>nat2st)or(j>nat2st)or(k>nat2st)or(i<nat1st)or(j<nat1st)or(k<nat1st) then begin
 ii:=i+i+i-2;jj:=j+j+j-2;kk:=k+k+k-2;
 for a:=0 to 2 do begin v1[a+1]:=r[ii+a]-r[jj+a];v2[a+1]:=r[kk+a]-r[jj+a];end;
 v1q:=sp(v1,v1);v2q:=sp(v2,v2);
 if v1q*v2q>1e-10 then v1av2a:=1/sqrt(v1q*v2q) else v1av2a:=1;
 ct:=sp(v1,v2)*v1av2a;
 tem:= arccosine(ct)-bt[b];
 sum_a:=sum_a+pi1802*kt[b]*sqr(tem);
 if(ic>0)then begin {also gradient}
  t:=2*kt[b]*pi180*tem*(-1/sqrt(1.0001-sqr(ct)));
  for a:=0 to 2 do begin
   c1:=(v2[a+1]*v1av2a-ct*v1[a+1]/v1q)*t;
   c2:=(v1[a+1]*v1av2a-ct*v2[a+1]/v2q)*t;
   g[ii+a]:=g[ii+a]+c1;
   g[jj+a]:=g[jj+a]-c1-c2;
   g[kk+a]:=g[kk+a]+c2;
  end;
 end;
end;end;

{torsion angles}
{Periodic conditions do not need to be considered since whole molecules always in box}
for b:=1 to nd do begin i:=d1[b];j:=d2[b];k:=d3[b];l:=d4[b];if(i>nat2st)or(j>nat2st)or(k>nat2st)or(l>nat2st)or(i<nat1st)or(j<nat1st)or(k<nat1st)or(l<nat1st) then begin
 ii:=i+i+i-2;jj:=j+j+j-2;kk:=k+k+k-2;ll:=l+l+l-2;
 xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];xj:=r[jj];yj:=r[jj+1];zj:=r[jj+2];xk:=r[kk];yk:=r[kk+1];zk:=r[kk+2];xl:=r[ll];yl:=r[ll+1];zl:=r[ll+2];
 v1[1]:=xi-xj;v2[1]:=xk-xj;v3[1]:=xl-xk;v1[2]:=yi-yj;v2[2]:=yk-yj;v3[2]:=yl-yk;v1[3]:=zi-zj;v2[3]:=zk-zj;v3[3]:=zl-zk;
 vp(v1,v2,av);aa:=sp(av,av);vp(v3,v2,bv);ba:=sp(bv,bv);rr:=1/sqrt(aa*ba);
 ct:=sp(av,bv)*rr;
 sum_t:=sum_t+k1d[b]*(1-ct)
             +k2d[b]*(1-(2*ct*ct-1))
             +k3d[b]*(1-(4*ct*ct*ct-3*ct));
 if(ic>0)then begin {also gradient}
  {c1,c2,c3 -derivative with respect to v1,v2,v3}
  v23:=sp(v2,v3);v12:=sp(v2,v1);v13:=sp(v1,v3);
  v1q:=sp(v1,v1);v2q:=sp(v2,v2);v3q:=sp(v3,v3);
  for a:=0 to 2 do begin
   c1:=-(v2[a+1]*v23-v2q*v3[a+1])*rr-ct/aa*(v2q*v1[a+1]-v12*v2[a+1]);
   c2:=-(v3[a+1]*v12+v1[a+1]*v23-2*v2[a+1]*v13)*rr-ct/aa*(v1q*v2[a+1]-v12*v1[a+1])
                                            -ct/ba*(v3q*v2[a+1]-v23*v3[a+1]);
   c3:=-(v2[a+1]*v12-v2q*v1[a+1])*rr-ct/ba*(v2q*v3[a+1]-v23*v2[a+1]);
   {tem - derivative of ct with respect to x_a,l
   i tem=c1
   l tem=c3
   j tem=-c1-c2
   k tem=-c3+c2}
   tem:=c1;    g[ii+a]:=g[ii+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
   tem:=c3;    g[ll+a]:=g[ll+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
   tem:=-c1-c2;g[jj+a]:=g[jj+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
   tem:=-c3+c2;g[kk+a]:=g[kk+a]-(k1d[b]+4*ct*k2d[b]+k3d[b]*(12*ct*ct-3))*tem;
  end;
 end;
end;end;

{out of plane}
{Periodic conditions do not need to be considered since whole molecules always in box}
for b:=1 to np do begin i:=o1[b];j:=o2[b];k:=o3[b];l:=o4[b];if(i>nat2st)or(j>nat2st)or(k>nat2st)or(l>nat2st)or(i<nat1st)or(j<nat1st)or(k<nat1st)or(l<nat1st) then begin
 ii:=i+i+i-2;jj:=j+j+j-2;kk:=k+k+k-2;ll:=l+l+l-2;
 xi:=r[ii];yi:=r[ii+1];zi:=r[ii+2];xj:=r[jj];yj:=r[jj+1];zj:=r[jj+2];xk:=r[kk];yk:=r[kk+1];zk:=r[kk+2];xl:=r[ll];yl:=r[ll+1];zl:=r[ll+2];
 v1[1]:=xj-xi;v2[1]:=xk-xi;v3[1]:=xl-xi;v1[2]:=yj-yi;v2[2]:=yk-yi;v3[2]:=yl-yi;v1[3]:=zj-zi;v2[3]:=zk-zi;v3[3]:=zl-zi;
 vp(v1,v2,av);oop:=sp(av,v3)/sqrt(sp(av,av))/sqrt(sp(v3,v3));
 if(i>nat2st)or(j>nat2st)or(k>nat2st)or(l>nat2st) then sum_o:=sum_o+oo[b]*sqr(oop);
 if(ic>0)then begin {also gradient}
  vp(v2,v3,bv);vp(v3,v1,cv);aa:=sp(av,av);v3q:=sp(v3,v3);
  rr:=1/sqrt(aa*v3q);
  chi:=sp(av,v3)*rr;
  for a:=0 to 2 do begin
   c3:=av[a+1]*rr-chi/v3q*v3[a+1];
   c1:=bv[a+1]*rr-chi/aa*(sp(v2,v2)*v1[a+1]-sp(v1,v2)*v2[a+1]);
   c2:=cv[a+1]*rr-chi/aa*(sp(v1,v1)*v2[a+1]-sp(v1,v2)*v1[a+1]);
   g[ii+a]:=g[ii+a]+2*oo[b]*chi*(-c1-c2-c3);
   g[jj+a]:=g[jj+a]+2*oo[b]*chi*(c1);
   g[kk+a]:=g[kk+a]+2*oo[b]*chi*(c2);
   g[ll+a]:=g[ll+a]+2*oo[b]*chi*(c3);
  end;
 end;
end;end;

etot:=sum_pol+sum_es+sum_vdw+sum_b+sum_a+sum_t+sum_o+sum_mag;

gnorm:=0;
if(ic=2)then begin {also gradient}
 for l:=1 to nat do begin
  if(form3.CheckBox2.Checked) then writeln(fv,l:4,g[3*(l-1)+1]:15:6,g[3*(l-1)+2]:15:6,g[3*(l-1)+3]:15:6,r[3*(l-1)+1]:12:6,   r[3*(l-1)+2]:12:6,   r[3*(l--1)+3]:12:6);
  if (l<nat1st)or(l>nat2st)then for i:=1 to 3 do gnorm:=gnorm+sqr(g[3*(l-1)+i]);
 end;
 if(form3.CheckBox2.Checked) then writeln(fv);
 gnorm:=sqrt(gnorm);
end;
if ic=2 then ts:=        'Initial Energy '+endline else ts:='Final Energy '+endline;
ts:=ts+      'Step          '+inttostr(nstep)+':'+endline+
             'electrostatic '+floattostrf(sum_es ,fffixed,20,3)+endline+
             'van der Waals '+floattostrf(sum_vdw,fffixed,20,3)+endline+
             'bonds         '+floattostrf(sum_b  ,fffixed,20,3)+endline+
             'angles        '+floattostrf(sum_a  ,fffixed,20,3)+endline+
             'torsions      '+floattostrf(sum_t  ,fffixed,20,3)+endline+
             'planes        '+floattostrf(sum_o  ,fffixed,20,3)+endline+
             'magnetic      '+floattostrf(sum_mag,fffixed,20,3)+endline+
             'polar         '+floattostrf(sum_pol,fffixed,20,3)+endline+
             '              '+'--------------------'+endline+
             'total         '+floattostrf(etot   ,fffixed,20,3)+' kcal/mol'+endline+
             '|grad|        '+floattostrf(gnorm   ,fffixed,20,3);
if ic>1 then showmessage(ts);
end;

function func(a:real):real;
var i:integer;
begin
  for i:=1   to 3*(nat1st-1) do r[i]:=x0[i]-a*h0[i];
  for i:=3*nat2st+1 to 3*nat do r[i]:=x0[i]-a*h0[i];
  fixbox;
  energy(-1);
  func:=etot;
end;

 function fsign(a,b:real):real;{fortran transfer sign funtion}
 begin
  fsign:=abs(a)*sign(b);
 end;

      procedure mnbrak(var ax,bx,cx,fa,fb,fc:real);
      const GOLD=1.618034;GLIMIT=100;TINY=1.e-20;
      label l1;
      var dum,fu,q,r,u,ulim:real;
      {Given a function func, and given distinct initial points ax and bx,
      this routine searches in the downhill direction (defined by the
      function as evaluated at the initial points) and returns new points
      ax, bx, cx that bracket a minimum of the function. Also returned are
      the function values at the three points, fa, fb,and fc.
      Parameters: GOLD is the default ratio by which successive intervals
      are magnified; GLIMIT is the maximum magnification allowed for
      a parabolic-fit step. }
      BEGIN
      fa:=func(ax);
      fb:=func(bx);
      {Switch roles of a and b so that we can go downhill in the
      direction from a to b. }
      if(fb>fa)then begin
       dum:=ax;
       ax:=bx;
       bx:=dum;
       dum:=fb;
       fb:=fa;
       fa:=dum;
      end;
      cx:=bx+GOLD*(bx-ax);
      fc:=func(cx);
      l1:
      if(fb>=fc)then begin
       r:=(bx-ax)*(fb-fc);
       q:=(bx-cx)*(fb-fa);
       u:=bx-((bx-cx)*q-(bx-ax)* r)/(2.*fsign(max(abs(q-r),TINY),q-r)) ;
       ulim:=bx+GLIMIT*(cx-bx);
       if((bx-u)*(u-cx)>0)then begin
        fu:=func(u);
        if(fu<fc)then begin
         ax:=bx;
         fa:=fb;
         bx:=u;
         fb:=fu;
	 exit;
	end else begin
	 if(fu>fb)then begin
          cx:=u;
          fc:=fu;
          exit;
	 end;
	end;
        u:=cx+GOLD*(cx-bx);
        fu:=func(u);
       end else begin
        if((cx-u)*(u-ulim)>0)then begin
         fu:=func(u);
         if(fu<fc)then begin
          bx:=cx;
          cx:=u;
          u:=cx+GOLD*(cx-bx);
          fb:=fc;
          fc:=fu;
          fu:=func(u);
         end;
        end else begin
	 if((u-ulim)*(ulim-cx)>=0)then begin
          u:=ulim;
          fu:=func(u);
         end else begin
          u:=cx+GOLD*(cx-bx);
          fu:=func(u);
         end;
        end;
       end;
       ax:=bx;
       bx:=cx;
       cx:=u;
       fa:=fb;
       fb:=fc;
       fc:=fu;
       goto l1;
      end;
      END;

      FUNCTION golden(var ax,bx,cx,tol,xmin:real):real;
      label l1;
      const R=0.61803399;C=1-R;
      var f1,f2,x0,x1,x2,x3:real;
      begin
      x0:=ax;
      x3:=cx;
      if(abs(cx-bx)>abs(bx -ax))then begin
       x1:=bx;
       x2:=bx+C*(cx-bx);
      end else begin
       x2:=bx;
       x1:=bx-C*(bx-ax);
      end;
      f1:=func(x1);
      f2:=func(x2);
      l1:
      if(abs(x3-x0)>tol*(abs(x1)+abs(x2)))then begin
       if(f2<f1)then begin
        x0:=x1;
        x1:=x2;
        x2:=R*x1+C*x3;
        f1:=f2;
        f2:=func(x2);
       end else begin
        x3:=x2;
        x2:=x1;
        x1:=R*x2+C*x0;
        f2:=f1;
        f1:=func(x1);
       end;
       goto l1;
      end;
      if(f1<f2)then begin
       golden:=f1;
       xmin:=x1;
      end else begin
       golden:=f2;
       xmin:=x2;
      end;
      exit;
      END;


procedure minimini;
{$J+}
label sk1,sk2,sk3,sk4;
const elim:real=0.000001;glim:real=0.01;
      maxstep:real=0.35;{A}
      nlimlin:integer=30;
var ii,i,l:integer;
    dh,h,gnorm1,e00,gmax,gnorm0,ax,bx,cx,xtol,fa,fb,fc:real;
    t0,t1:double;
    ts:string;
begin
  nstep:=0;
  t0:=now;
  xtol:=strtofloat(form3.edit12.text);
  maxstep:=strtofloat(form3.edit1.text);
  elim:=strtofloat(form3.edit3.text);
  glim:=strtofloat(form3.edit4.text);
  nlimlin:=strtoint(form3.edit2.text);
  for l:=1 to 3*nat do g[l]:=0;
  energy(2);{energy and gradient, initial step}
  gnorm0:=0;
  gmax:=abs(g[1]);
  for l:=1 to nat do for i:=1 to 3 do begin ii:=3*(l-1)+i;
   x0[ii]:=r[ii];h0[ii]:=g[ii];
   if (l<nat1st)or(l>nat2st) then begin
    gnorm0:=gnorm0+sqr(g[ii]);
    if abs(g[ii])>gmax then gmax:=abs(g[ii]);
   end;
  end;
  gnorm0:=sqrt(gnorm0);if gnorm0<glim then begin ts:='Initial gradient too small - minimized';goto sk3;end;

  sk2:nstep:=nstep+1;

  {Linear search along grad h0:}
  e00:=etot;
  t1:=(now-t0)*86400;
  aparatusform.Caption:=floattostrf(t1,fffixed,7,1)+' sec '+inttostr(nstep)+' step, grad '+floattostr(gnorm0);
  Form1.Caption:='Energy '+floattostr(etot);
  ax:=0;dh:=maxstep/gmax;
  mnbrak(ax,dh,h,fa,fb,fc);
  bx:=dh;cx:=h;etot:=golden(ax,bx,cx,xtol,h);
  for i:=1 to 3*(nat1st-1)   do r[i]:=x0[i]-fsign(min(maxstep,abs(h*h0[i])),h*h0[i]);
  for i:=3*nat2st+1 to 3*nat do r[i]:=x0[i]-fsign(min(maxstep,abs(h*h0[i])),h*h0[i]);
  fixbox;
  draw;

  if(etot>e00)then begin
   showmessage('Lin. search not successful');
   exit;
  end;

  energy(1);gnorm1:=0;gmax:=abs(g[1]);
  for l:=1 to nat do begin
   if (l<nat1st)or(l>nat2st)then for i:=1 to 3 do begin gnorm1:=gnorm1+sqr(g[3*(l-1)+i]);if abs(g[3*(l-1)+i])>gmax then gmax:= abs(g[3*(l-1)+i]);end;
  end;for i:=1 to 3*nat do x0[i]:=r[i];
  gnorm1:=sqrt(gnorm1);
  for ii:=1 to 3*nat do begin
   h0[ii]:=g[ii]+sqr(gnorm1/gnorm0)*h0[ii];
  end;
  if(form3.CheckBox2.Checked) then writeln(fv,'Gradient         ',gnorm1       :15:6,'; limit ',glim:15:6);
  if(form3.CheckBox2.Checked) then writeln(fv,'Change of energy ',abs(e00-etot):15:6,'; limit ',elim:15:6);

  if (abs(e00-etot)<elim) and (gnorm1<glim) then begin ts:='Optimization converged';goto sk3;end;
  if (gnorm1<glim) then begin ts:='Optimization converged - small grad';goto sk3;end;
  if nstep>nstepmax then begin ts:='Too many steps';goto sk3;end;
  {$IFDEF MSWINDOWS}
  if getasynckeystate(27)<>0 then begin ts:='Optimization was interrupted.';goto sk3;end;
  {$ENDIF}
  {$IFDEF LINUX}
  assignfile(fstop,'STOP');
  {$I-}
  reset(fstop);
  {$I+}
  if IOResult=0  then begin
   closefile(fstop);
   ts:='Optimization was interrupted.';goto sk3;
  end;
  {$ENDIF}


  gnorm0:=gnorm1;
  goto sk2;

 sk3:showmessage(ts);
 energy(3);
end;

procedure MinimizeEnergy;
label sk1,sk2,sk3;
var j,i:integer;ts:string;
begin
 nstepmax:=strtoint(form3.edit11.text);


 {how many bonds on each atom for speeding up pair term}
 for i:=1 to nat do begin
  nba[i]:=0;
  for j:=1 to nb do begin
   if (b1[j]=i)or(b2[j]=i) then begin
    nba[i]:=nba[i]+1;
    if (nba[i]>7)then begin showmessage('two many bonds on atom '+inttostr(i));exit;end;
    if(b2[j]=i)then nbt[i,nba[i]]:=b1[j]else nbt[i,nba[i]]:=b2[j];
   end;
  end;
 end;

 if(form3.CheckBox2.Checked) then begin
 assignfile(fv,'energy.log');
 rewrite(fv);
 writeln(fv,' Last energy calculation');writeln(fv);
 writeln(fv,nat:10,' atoms');
 writeln(fv,'atom charge vdwep vdwrs');
 for i:=1 to nat do begin
  writeln(fv,i:4,' ',q[i]:6:2,eps[i]:6:3,
  exp(1/3*ln(r3[i])):6:3);
 end;
 writeln(fv);
 writeln(fv,nb:10,' bonds');
 writeln(fv,'bond   i-   j     kb     b0');
 for i:=1 to nb do writeln(fv,i:4,b1[i]:4,' ',b2[i]:4,' ',k0[i]:6:1,' ',b0[i]:6:3);
 writeln(fv);
 writeln(fv,nt:10,' bond angles');
 writeln(fv,'angle   i-   j-   k     kt     t0');
 for i:=1 to nt do writeln(fv,i:4,' ',t1[i]:4,' ',t2[i]:4,' ',t3[i]:4,' ',kt[i]:6:1,' ',bt[i]:6:1);
 writeln(fv);
 writeln(fv,nd:10,' torsion angles');
 writeln(fv,'torsions   i-   j-   k-   l    k1f    k2f    k3f');
 for i:=1 to nd do writeln(fv,i:7,' ',d1[i]:4,' ',d2[i]:4,' ',d3[i]:4,' ',d4[i]:4,' ',k1d[i]:6:3,' ',k2d[i]:6:3,' ',k3d[i]:6:3);
 writeln(fv);
 writeln(fv,np:10,' out-of-plane waggings');
 writeln(fv,'planes     i-   j-   k-   l     oo');
 for i:=1 to np do writeln(fv,i:7,' ',o1[i]:4,' ',o2[i]:4,' ',o3[i]:4,' ',o4[i]:4,' ',oo[i]:6:3);
 end;

 minimini;
 str(etot:25:9,ts);
 form1.Caption:=' Energy = '+ts;

 if(form3.CheckBox2.Checked) then writeln(fv,ts);
 if(form3.CheckBox2.Checked) then close(fv);
end;


end.
